
/*
 * author Jiří Zuzaňák
 * institution BUT FIT UPGM
 */

@begin
   include "dot_loader.h"
@end

/*
 * constants and definitions
 */

// - parse callback array -
void(*dl_parse_callbacks[])(dot_loader_s &dl) = 
{
   dot_loader_s::pa_null,
   dot_loader_s::pa_null,
   dot_loader_s::pa_null,
   dot_loader_s::pa_graph_name,
   dot_loader_s::pa_graph_type_graph,
   dot_loader_s::pa_graph_type_digraph,
   dot_loader_s::pa_null,
   dot_loader_s::pa_null,
   dot_loader_s::pa_null,
   dot_loader_s::pa_null,
   dot_loader_s::pa_null,
   dot_loader_s::pa_null,
   dot_loader_s::pa_null,
   dot_loader_s::pa_global_vertex,
   dot_loader_s::pa_global_edge,
   dot_loader_s::pa_create_vertex,
   dot_loader_s::pa_create_vertex,
   dot_loader_s::pa_create_edge,
   dot_loader_s::pa_create_edge,
   dot_loader_s::pa_graph_vertex,
   dot_loader_s::pa_graph_edge,
   dot_loader_s::pa_null,
   dot_loader_s::pa_null,
   dot_loader_s::pa_null,
   dot_loader_s::pa_null,
   dot_loader_s::pa_set_label,
   dot_loader_s::pa_null,
   dot_loader_s::pa_null,
   dot_loader_s::pa_identifier,
   dot_loader_s::pa_single_char_const,
   dot_loader_s::pa_octal_char_const,
   dot_loader_s::pa_hex_char_const,
   dot_loader_s::pa_backslash_char_const,
   dot_loader_s::pa_oct_int_const,
   dot_loader_s::pa_dec_int_const,
   dot_loader_s::pa_hex_int_const,
   dot_loader_s::pa_float_const,
   dot_loader_s::pa_string_const,
};

/*
 * methods of generated structures
 */

// -- lalr_stack_element_s --
@begin
   methods lalr_stack_element_s
@end

// -- lalr_stack_s --
@begin
   methods lalr_stack_s
@end

// -- ne_patameters_s --
@begin
   methods ne_parameters_s
@end

// -- ne_parameters_array_s --
@begin
   methods ne_parameters_array_s
@end

// -- name_map_s --
@begin
   methods name_map_s
@end

// -- name_map_array_s --
@begin
   methods name_map_array_s
@end

unsigned name_map_array_s::get_idx_by_name(unsigned a_length,const char *a_data)
{/*{{{*/
   if (used <= 0) return c_idx_not_exist;

   name_map_s *ptr = data;
   name_map_s *ptr_end = ptr + used;
   do {
      if (ptr->name.compare_char_ptr(a_length,a_data)) {
         return ptr - data;
      }
   } while(++ptr < ptr_end);

   return c_idx_not_exist;
}/*}}}*/

// -- dot_loader_s --
@begin
   methods dot_loader_s
@end

unsigned dot_loader_s::recognize_terminal(unsigned &input_idx)
{/*{{{*/
   unsigned source_string_length = source_string.size - 1;

#define GET_NEXT_CHAR() \
{\
   if (input_idx < source_string_length) {\
      in_char = (unsigned char)source_string[input_idx];\
   }\
   else {\
      in_char = '\0';\
   }\
}

#define CLOSE_CHAR(RET_TERM_IDX) \
{\
   if (in_char == '\0') {\
      return RET_TERM_IDX;\
   }\
\
   input_idx++;\
}

   unsigned short in_char;

// - STAV 0 - 
   GET_NEXT_CHAR();

   if (in_char == 0)
      goto state_1_label;

   if (in_char >= 9 && in_char < 11)
      goto state_27_label;

   if (in_char == 32)
      goto state_27_label;

   if (in_char == 34)
      goto state_2_label;

   if (in_char == 35)
      goto state_3_label;

   if (in_char == 39)
      goto state_4_label;

   if (in_char == 42)
      goto state_5_label;

   if (in_char == 45)
      goto state_6_label;

   if (in_char == 46)
      goto state_7_label;

   if (in_char == 47)
      goto state_8_label;

   if (in_char == 48)
      goto state_9_label;

   if (in_char >= 49 && in_char < 58)
      goto state_10_label;

   if (in_char == 61)
      goto state_11_label;

   if (in_char >= 65 && in_char < 76)
      goto state_16_label;

   if (in_char == 76)
      goto state_12_label;

   if (in_char >= 77 && in_char < 84)
      goto state_16_label;

   if (in_char == 84)
      goto state_13_label;

   if (in_char >= 85 && in_char < 91)
      goto state_16_label;

   if (in_char == 91)
      goto state_14_label;

   if (in_char == 93)
      goto state_15_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 99)
      goto state_16_label;

   if (in_char == 99)
      goto state_17_label;

   if (in_char == 100)
      goto state_18_label;

   if (in_char == 101)
      goto state_19_label;

   if (in_char == 102)
      goto state_16_label;

   if (in_char == 103)
      goto state_20_label;

   if (in_char >= 104 && in_char < 108)
      goto state_16_label;

   if (in_char == 108)
      goto state_21_label;

   if (in_char == 109)
      goto state_16_label;

   if (in_char == 110)
      goto state_22_label;

   if (in_char >= 111 && in_char < 114)
      goto state_16_label;

   if (in_char == 114)
      goto state_23_label;

   if (in_char == 115)
      goto state_24_label;

   if (in_char >= 116 && in_char < 123)
      goto state_16_label;

   if (in_char == 123)
      goto state_25_label;

   if (in_char == 125)
      goto state_26_label;

   return c_idx_not_exist;

// - STAV 1 - 
state_1_label:
   CLOSE_CHAR(32)
   return 32;

// - STAV 2 - 
state_2_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 10)
      goto state_2_label;

   if (in_char >= 11 && in_char < 34)
      goto state_2_label;

   if (in_char == 34)
      goto state_29_label;

   if (in_char >= 35 && in_char < 92)
      goto state_2_label;

   if (in_char == 92)
      goto state_30_label;

   if (in_char >= 93 && in_char < 256)
      goto state_2_label;

   return c_idx_not_exist;

// - STAV 3 - 
state_3_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 10)
      goto state_3_label;

   if (in_char == 10)
      goto state_31_label;

   if (in_char >= 11 && in_char < 257)
      goto state_3_label;

   return c_idx_not_exist;

// - STAV 4 - 
state_4_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 92)
      goto state_33_label;

   if (in_char == 92)
      goto state_32_label;

   if (in_char >= 93 && in_char < 257)
      goto state_33_label;

   return c_idx_not_exist;

// - STAV 5 - 
state_5_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 47)
      goto state_34_label;

   return c_idx_not_exist;

// - STAV 6 - 
state_6_label:
   CLOSE_CHAR(25)
   GET_NEXT_CHAR();

   if (in_char == 46)
      goto state_35_label;

   if (in_char == 48)
      goto state_36_label;

   if (in_char >= 49 && in_char < 58)
      goto state_37_label;

   if (in_char == 62)
      goto state_38_label;

   return 25;

// - STAV 7 - 
state_7_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_40_label;

   return c_idx_not_exist;

// - STAV 8 - 
state_8_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 42)
      goto state_41_label;

   if (in_char == 47)
      goto state_42_label;

   return c_idx_not_exist;

// - STAV 9 - 
state_9_label:
   CLOSE_CHAR(4)
   GET_NEXT_CHAR();

   if (in_char == 46)
      goto state_43_label;

   if (in_char >= 48 && in_char < 56)
      goto state_44_label;

   if (in_char >= 56 && in_char < 58)
      goto state_28_label;

   if (in_char == 69)
      goto state_45_label;

   if (in_char == 88)
      goto state_46_label;

   if (in_char == 101)
      goto state_45_label;

   if (in_char == 120)
      goto state_46_label;

   return 4;

// - STAV 10 - 
state_10_label:
   CLOSE_CHAR(5)
   GET_NEXT_CHAR();

   if (in_char == 46)
      goto state_43_label;

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char == 69)
      goto state_45_label;

   if (in_char == 101)
      goto state_45_label;

   return 5;

// - STAV 11 - 
state_11_label:
   CLOSE_CHAR(19)
   return 19;

// - STAV 12 - 
state_12_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 82)
      goto state_16_label;

   if (in_char == 82)
      goto state_47_label;

   if (in_char >= 83 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 13 - 
state_13_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 68)
      goto state_16_label;

   if (in_char == 68)
      goto state_48_label;

   if (in_char >= 69 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 14 - 
state_14_label:
   CLOSE_CHAR(23)
   return 23;

// - STAV 15 - 
state_15_label:
   CLOSE_CHAR(24)
   return 24;

// - STAV 16 - 
state_16_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 17 - 
state_17_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 111)
      goto state_16_label;

   if (in_char == 111)
      goto state_49_label;

   if (in_char >= 112 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 18 - 
state_18_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 105)
      goto state_16_label;

   if (in_char == 105)
      goto state_50_label;

   if (in_char >= 106 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 19 - 
state_19_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 100)
      goto state_16_label;

   if (in_char == 100)
      goto state_51_label;

   if (in_char >= 101 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 20 - 
state_20_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 114)
      goto state_16_label;

   if (in_char == 114)
      goto state_52_label;

   if (in_char >= 115 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 21 - 
state_21_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char == 97)
      goto state_53_label;

   if (in_char >= 98 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 22 - 
state_22_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 111)
      goto state_16_label;

   if (in_char == 111)
      goto state_54_label;

   if (in_char >= 112 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 23 - 
state_23_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char == 97)
      goto state_55_label;

   if (in_char >= 98 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 24 - 
state_24_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 104)
      goto state_16_label;

   if (in_char == 104)
      goto state_56_label;

   if (in_char >= 105 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 25 - 
state_25_label:
   CLOSE_CHAR(21)
   return 21;

// - STAV 26 - 
state_26_label:
   CLOSE_CHAR(22)
   return 22;

// - STAV 27 - 
state_27_label:
   CLOSE_CHAR(29)
   GET_NEXT_CHAR();

   if (in_char >= 9 && in_char < 11)
      goto state_27_label;

   if (in_char == 32)
      goto state_27_label;

   return 29;

// - STAV 28 - 
state_28_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 46)
      goto state_43_label;

   if (in_char >= 48 && in_char < 58)
      goto state_28_label;

   if (in_char == 69)
      goto state_45_label;

   if (in_char == 101)
      goto state_45_label;

   return c_idx_not_exist;

// - STAV 29 - 
state_29_label:
   CLOSE_CHAR(8)
   return 8;

// - STAV 30 - 
state_30_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 34)
      goto state_2_label;

   if (in_char == 39)
      goto state_2_label;

   if (in_char >= 48 && in_char < 56)
      goto state_57_label;

   if (in_char == 63)
      goto state_2_label;

   if (in_char == 92)
      goto state_2_label;

   if (in_char >= 97 && in_char < 99)
      goto state_2_label;

   if (in_char == 102)
      goto state_2_label;

   if (in_char == 110)
      goto state_2_label;

   if (in_char == 114)
      goto state_2_label;

   if (in_char == 116)
      goto state_2_label;

   if (in_char == 118)
      goto state_2_label;

   if (in_char == 120)
      goto state_58_label;

   return c_idx_not_exist;

// - STAV 31 - 
state_31_label:
   CLOSE_CHAR(30)
   return 30;

// - STAV 32 - 
state_32_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 34)
      goto state_59_label;

   if (in_char == 39)
      goto state_60_label;

   if (in_char >= 48 && in_char < 56)
      goto state_61_label;

   if (in_char == 63)
      goto state_59_label;

   if (in_char == 92)
      goto state_59_label;

   if (in_char >= 97 && in_char < 99)
      goto state_59_label;

   if (in_char == 102)
      goto state_59_label;

   if (in_char == 110)
      goto state_59_label;

   if (in_char == 114)
      goto state_59_label;

   if (in_char == 116)
      goto state_59_label;

   if (in_char == 118)
      goto state_59_label;

   if (in_char == 120)
      goto state_62_label;

   return c_idx_not_exist;

// - STAV 33 - 
state_33_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 39)
      goto state_63_label;

   return c_idx_not_exist;

// - STAV 34 - 
state_34_label:
   CLOSE_CHAR(28)
   return 28;

// - STAV 35 - 
state_35_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_64_label;

   return c_idx_not_exist;

// - STAV 36 - 
state_36_label:
   CLOSE_CHAR(4)
   GET_NEXT_CHAR();

   if (in_char == 46)
      goto state_65_label;

   if (in_char >= 48 && in_char < 56)
      goto state_66_label;

   if (in_char >= 56 && in_char < 58)
      goto state_39_label;

   if (in_char == 88)
      goto state_46_label;

   if (in_char == 120)
      goto state_46_label;

   return 4;

// - STAV 37 - 
state_37_label:
   CLOSE_CHAR(5)
   GET_NEXT_CHAR();

   if (in_char == 46)
      goto state_65_label;

   if (in_char >= 48 && in_char < 58)
      goto state_37_label;

   return 5;

// - STAV 38 - 
state_38_label:
   CLOSE_CHAR(26)
   return 26;

// - STAV 39 - 
state_39_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 46)
      goto state_65_label;

   if (in_char >= 48 && in_char < 58)
      goto state_39_label;

   return c_idx_not_exist;

// - STAV 40 - 
state_40_label:
   CLOSE_CHAR(7)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_40_label;

   if (in_char == 69)
      goto state_45_label;

   if (in_char == 101)
      goto state_45_label;

   return 7;

// - STAV 41 - 
state_41_label:
   CLOSE_CHAR(27)
   return 27;

// - STAV 42 - 
state_42_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 10)
      goto state_42_label;

   if (in_char == 10)
      goto state_67_label;

   if (in_char >= 11 && in_char < 257)
      goto state_42_label;

   return c_idx_not_exist;

// - STAV 43 - 
state_43_label:
   CLOSE_CHAR(7)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_40_label;

   if (in_char == 69)
      goto state_45_label;

   if (in_char == 101)
      goto state_45_label;

   return 7;

// - STAV 44 - 
state_44_label:
   CLOSE_CHAR(4)
   GET_NEXT_CHAR();

   if (in_char == 46)
      goto state_43_label;

   if (in_char >= 48 && in_char < 56)
      goto state_44_label;

   if (in_char >= 56 && in_char < 58)
      goto state_28_label;

   if (in_char == 69)
      goto state_45_label;

   if (in_char == 101)
      goto state_45_label;

   return 4;

// - STAV 45 - 
state_45_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 43)
      goto state_68_label;

   if (in_char == 45)
      goto state_68_label;

   if (in_char >= 48 && in_char < 58)
      goto state_69_label;

   return c_idx_not_exist;

// - STAV 46 - 
state_46_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_70_label;

   if (in_char >= 65 && in_char < 71)
      goto state_70_label;

   if (in_char >= 97 && in_char < 103)
      goto state_70_label;

   return c_idx_not_exist;

// - STAV 47 - 
state_47_label:
   CLOSE_CHAR(15)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 15;

// - STAV 48 - 
state_48_label:
   CLOSE_CHAR(16)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 16;

// - STAV 49 - 
state_49_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 108)
      goto state_16_label;

   if (in_char == 108)
      goto state_71_label;

   if (in_char >= 109 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 50 - 
state_50_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 103)
      goto state_16_label;

   if (in_char == 103)
      goto state_72_label;

   if (in_char >= 104 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 51 - 
state_51_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 103)
      goto state_16_label;

   if (in_char == 103)
      goto state_73_label;

   if (in_char >= 104 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 52 - 
state_52_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char == 97)
      goto state_74_label;

   if (in_char >= 98 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 53 - 
state_53_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char == 97)
      goto state_16_label;

   if (in_char == 98)
      goto state_75_label;

   if (in_char >= 99 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 54 - 
state_54_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 100)
      goto state_16_label;

   if (in_char == 100)
      goto state_76_label;

   if (in_char >= 101 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 55 - 
state_55_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 110)
      goto state_16_label;

   if (in_char == 110)
      goto state_77_label;

   if (in_char >= 111 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 56 - 
state_56_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char == 97)
      goto state_78_label;

   if (in_char >= 98 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 57 - 
state_57_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 10)
      goto state_2_label;

   if (in_char >= 11 && in_char < 34)
      goto state_2_label;

   if (in_char == 34)
      goto state_29_label;

   if (in_char >= 35 && in_char < 48)
      goto state_2_label;

   if (in_char >= 48 && in_char < 56)
      goto state_79_label;

   if (in_char >= 56 && in_char < 92)
      goto state_2_label;

   if (in_char == 92)
      goto state_30_label;

   if (in_char >= 93 && in_char < 256)
      goto state_2_label;

   return c_idx_not_exist;

// - STAV 58 - 
state_58_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_80_label;

   if (in_char >= 65 && in_char < 71)
      goto state_80_label;

   if (in_char >= 97 && in_char < 103)
      goto state_80_label;

   return c_idx_not_exist;

// - STAV 59 - 
state_59_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 39)
      goto state_81_label;

   return c_idx_not_exist;

// - STAV 60 - 
state_60_label:
   CLOSE_CHAR(0)
   GET_NEXT_CHAR();

   if (in_char == 39)
      goto state_81_label;

   return 0;

// - STAV 61 - 
state_61_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 39)
      goto state_82_label;

   if (in_char >= 48 && in_char < 56)
      goto state_83_label;

   return c_idx_not_exist;

// - STAV 62 - 
state_62_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_84_label;

   if (in_char >= 65 && in_char < 71)
      goto state_84_label;

   if (in_char >= 97 && in_char < 103)
      goto state_84_label;

   return c_idx_not_exist;

// - STAV 63 - 
state_63_label:
   CLOSE_CHAR(0)
   return 0;

// - STAV 64 - 
state_64_label:
   CLOSE_CHAR(7)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_64_label;

   return 7;

// - STAV 65 - 
state_65_label:
   CLOSE_CHAR(7)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_64_label;

   return 7;

// - STAV 66 - 
state_66_label:
   CLOSE_CHAR(4)
   GET_NEXT_CHAR();

   if (in_char == 46)
      goto state_65_label;

   if (in_char >= 48 && in_char < 56)
      goto state_66_label;

   if (in_char >= 56 && in_char < 58)
      goto state_39_label;

   return 4;

// - STAV 67 - 
state_67_label:
   CLOSE_CHAR(31)
   return 31;

// - STAV 68 - 
state_68_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_69_label;

   return c_idx_not_exist;

// - STAV 69 - 
state_69_label:
   CLOSE_CHAR(7)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_69_label;

   return 7;

// - STAV 70 - 
state_70_label:
   CLOSE_CHAR(6)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_70_label;

   if (in_char >= 65 && in_char < 71)
      goto state_70_label;

   if (in_char >= 97 && in_char < 103)
      goto state_70_label;

   return 6;

// - STAV 71 - 
state_71_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 111)
      goto state_16_label;

   if (in_char == 111)
      goto state_85_label;

   if (in_char >= 112 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 72 - 
state_72_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 114)
      goto state_16_label;

   if (in_char == 114)
      goto state_86_label;

   if (in_char >= 115 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 73 - 
state_73_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 101)
      goto state_16_label;

   if (in_char == 101)
      goto state_87_label;

   if (in_char >= 102 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 74 - 
state_74_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 112)
      goto state_16_label;

   if (in_char == 112)
      goto state_88_label;

   if (in_char >= 113 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 75 - 
state_75_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 101)
      goto state_16_label;

   if (in_char == 101)
      goto state_89_label;

   if (in_char >= 102 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 76 - 
state_76_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 101)
      goto state_16_label;

   if (in_char == 101)
      goto state_90_label;

   if (in_char >= 102 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 77 - 
state_77_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 107)
      goto state_16_label;

   if (in_char == 107)
      goto state_91_label;

   if (in_char >= 108 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 78 - 
state_78_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 112)
      goto state_16_label;

   if (in_char == 112)
      goto state_92_label;

   if (in_char >= 113 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 79 - 
state_79_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 10)
      goto state_2_label;

   if (in_char >= 11 && in_char < 34)
      goto state_2_label;

   if (in_char == 34)
      goto state_29_label;

   if (in_char >= 35 && in_char < 92)
      goto state_2_label;

   if (in_char == 92)
      goto state_30_label;

   if (in_char >= 93 && in_char < 256)
      goto state_2_label;

   return c_idx_not_exist;

// - STAV 80 - 
state_80_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 10)
      goto state_2_label;

   if (in_char >= 11 && in_char < 34)
      goto state_2_label;

   if (in_char == 34)
      goto state_29_label;

   if (in_char >= 35 && in_char < 92)
      goto state_2_label;

   if (in_char == 92)
      goto state_30_label;

   if (in_char >= 93 && in_char < 256)
      goto state_2_label;

   return c_idx_not_exist;

// - STAV 81 - 
state_81_label:
   CLOSE_CHAR(3)
   return 3;

// - STAV 82 - 
state_82_label:
   CLOSE_CHAR(1)
   return 1;

// - STAV 83 - 
state_83_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 39)
      goto state_82_label;

   if (in_char >= 48 && in_char < 56)
      goto state_93_label;

   return c_idx_not_exist;

// - STAV 84 - 
state_84_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 39)
      goto state_94_label;

   if (in_char >= 48 && in_char < 58)
      goto state_95_label;

   if (in_char >= 65 && in_char < 71)
      goto state_95_label;

   if (in_char >= 97 && in_char < 103)
      goto state_95_label;

   return c_idx_not_exist;

// - STAV 85 - 
state_85_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 114)
      goto state_16_label;

   if (in_char == 114)
      goto state_96_label;

   if (in_char >= 115 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 86 - 
state_86_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char == 97)
      goto state_97_label;

   if (in_char >= 98 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 87 - 
state_87_label:
   CLOSE_CHAR(18)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 18;

// - STAV 88 - 
state_88_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 104)
      goto state_16_label;

   if (in_char == 104)
      goto state_98_label;

   if (in_char >= 105 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 89 - 
state_89_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 108)
      goto state_16_label;

   if (in_char == 108)
      goto state_99_label;

   if (in_char >= 109 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 90 - 
state_90_label:
   CLOSE_CHAR(17)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 17;

// - STAV 91 - 
state_91_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 100)
      goto state_16_label;

   if (in_char == 100)
      goto state_100_label;

   if (in_char >= 101 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 92 - 
state_92_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 101)
      goto state_16_label;

   if (in_char == 101)
      goto state_101_label;

   if (in_char >= 102 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 93 - 
state_93_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 39)
      goto state_82_label;

   return c_idx_not_exist;

// - STAV 94 - 
state_94_label:
   CLOSE_CHAR(2)
   return 2;

// - STAV 95 - 
state_95_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 39)
      goto state_94_label;

   return c_idx_not_exist;

// - STAV 96 - 
state_96_label:
   CLOSE_CHAR(14)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 14;

// - STAV 97 - 
state_97_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 112)
      goto state_16_label;

   if (in_char == 112)
      goto state_102_label;

   if (in_char >= 113 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 98 - 
state_98_label:
   CLOSE_CHAR(9)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 9;

// - STAV 99 - 
state_99_label:
   CLOSE_CHAR(12)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 12;

// - STAV 100 - 
state_100_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 105)
      goto state_16_label;

   if (in_char == 105)
      goto state_103_label;

   if (in_char >= 106 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 101 - 
state_101_label:
   CLOSE_CHAR(13)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 13;

// - STAV 102 - 
state_102_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 104)
      goto state_16_label;

   if (in_char == 104)
      goto state_104_label;

   if (in_char >= 105 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 103 - 
state_103_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 114)
      goto state_16_label;

   if (in_char == 114)
      goto state_105_label;

   if (in_char >= 115 && in_char < 123)
      goto state_16_label;

   return 20;

// - STAV 104 - 
state_104_label:
   CLOSE_CHAR(10)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 10;

// - STAV 105 - 
state_105_label:
   CLOSE_CHAR(11)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_16_label;

   if (in_char >= 65 && in_char < 91)
      goto state_16_label;

   if (in_char == 95)
      goto state_16_label;

   if (in_char >= 97 && in_char < 123)
      goto state_16_label;

   return 11;

}/*}}}*/

bool dot_loader_s::parse_source_string()
{/*{{{*/
   lalr_stack.used = 0;
   lalr_stack.push(0);

   unsigned old_input_idx = 0;
   unsigned input_idx = 0;
   unsigned ret_term = c_idx_not_exist;

   do {

      while (ret_term == c_idx_not_exist) {
         old_input_idx = input_idx;

         ret_term = recognize_terminal(input_idx);
         cassert(ret_term != c_idx_not_exist);

         if (ret_term >= 29 && ret_term <= 31) {
            ret_term = c_idx_not_exist;
         }
      }

      // - nalezeni akce v tabulce akci -
      unsigned parse_action = dl_lalr_table[lalr_stack.last().lalr_state*c_dl_terminal_plus_nonterminal_cnt + ret_term];
      cassert(parse_action != c_idx_not_exist);

      // - akce SHIFT -
      if (parse_action < c_dl_lalr_table_reduce_base) {

         if (ret_term == 32) {
            break;
         }

         // - vlozi na zasobnik novy stav a pozici terminalu ve zdrojovem retezci -
         lalr_stack.push(parse_action,old_input_idx,input_idx);
         ret_term = c_idx_not_exist;
      }

      // -akce REDUCE-
      else {
         parse_action -= c_dl_lalr_table_reduce_base;

         // - call parse callback -
         dl_parse_callbacks[parse_action](*this);

         // - odstraneni tela pravidla z vrcholu zasobniku -
         lalr_stack.used -= dl_rule_body_lengths[parse_action];

         // - ulozeni noveho stavu automatu na zasobnik -
         unsigned goto_val = dl_lalr_table[lalr_stack.last().lalr_state*c_dl_terminal_plus_nonterminal_cnt + dl_rule_head_idxs[parse_action]];
         lalr_stack.push(goto_val);
      }

   } while(1);

   lalr_stack.clear();

   return true;
}/*}}}*/

void dot_loader_s::load_graph_from_source_string(graph_s &a_graph,bool a_edge_identifiers)
{/*{{{*/

   // - empty vertex_array -
   vertex_array.used = 0;

   // - empty edge array -
   store_edge_identifiers = a_edge_identifiers;
   edge_array.used = 0;

   // - if not exist create parameters array -
   if (parameters.used < 3) {
      parameters.copy_resize(3);
      parameters.used = 3;
   }

   // - clear and set default values -
   parameter_target = c_pct_actual;

   ne_parameters_s &actual_params = parameters[c_pct_actual];

   actual_params.label_type = c_nel_param_type_null;
   actual_params.label_value = NULL;
   actual_params.color = 0;
   actual_params.shape = 0;

   parameters[c_pct_default_vertex] = actual_params;
   parameters[c_pct_default_edge] = actual_params;

   graph.clear();

   // - set graph vertices and edges value_fps -
   graph.vertices.value_fps = (void **)graph_blank_functions;
   graph.edges.value_fps = (void **)graph_blank_functions;

   parse_source_string();
   a_graph.swap(graph);
}/*}}}*/

void dot_loader_s::pa_null(dot_loader_s &dl)
{/*{{{*/
}/*}}}*/

void dot_loader_s::pa_graph_name(dot_loader_s &dl)
{/*{{{*/
}/*}}}*/

void dot_loader_s::pa_graph_type_graph(dot_loader_s &dl)
{/*{{{*/
   dl.graph.type = c_graph_type_graph;

   // -----

   debug_message_4(fprintf(stderr,"dot_parser: parse_action: pa_graph_type_graph\n"));
}/*}}}*/

void dot_loader_s::pa_graph_type_digraph(dot_loader_s &dl)
{/*{{{*/
   dl.graph.type = c_graph_type_digraph;

   // -----

   debug_message_4(fprintf(stderr,"dot_parser: parse_action: pa_graph_type_digraph\n"));
}/*}}}*/

void dot_loader_s::pa_global_vertex(dot_loader_s &dl)
{/*{{{*/

   // - set global vertex as parameter target -
   dl.parameter_target = c_pct_default_vertex;

   // -----

   debug_message_4(fprintf(stderr,"dot_parser: parse_action: pa_global_vertex\n"));
}/*}}}*/

void dot_loader_s::pa_global_edge(dot_loader_s &dl)
{/*{{{*/

   // - set global edge as parameter target -
   dl.parameter_target = c_pct_default_edge;

   // -----

   debug_message_4(fprintf(stderr,"dot_parser: parse_action: pa_global_edge\n"));
}/*}}}*/

void dot_loader_s::pa_create_vertex(dot_loader_s &dl)
{/*{{{*/
   ne_parameters_s &actual_params = dl.parameters[c_pct_actual];

   // - test type of label and graph labeling type -
   if (dl.graph.vertices.value_fps == graph_blank_functions) {
      if (actual_params.label_type != c_nel_param_type_null) {
         cassert(dl.graph.vertices.used <= 0);

         switch (actual_params.label_type) {
         case c_nel_param_type_identifier:
            dl.graph.vertices.value_fps = (void **)graph_int_functions;
            break;
         case c_nel_param_type_char:
            dl.graph.vertices.value_fps = (void **)graph_char_functions;
            break;
         case c_nel_param_type_integer:
            dl.graph.vertices.value_fps = (void **)graph_int_functions;
            break;
         case c_nel_param_type_float:
            dl.graph.vertices.value_fps = (void **)graph_float_functions;
            break;
         case c_nel_param_type_string:
            dl.graph.vertices.value_fps = (void **)graph_string_functions;
            break;
         default:
            cassert(0);
         }
      }
   }
   else if (dl.graph.vertices.value_fps == graph_char_functions) {
      cassert(actual_params.label_type == c_nel_param_type_char);
   }
   else if (dl.graph.vertices.value_fps == graph_int_functions) {
      cassert(actual_params.label_type == c_nel_param_type_integer);
   }
   else if (dl.graph.vertices.value_fps == graph_float_functions) {
      cassert(actual_params.label_type == c_nel_param_type_float);
   }
   else if (dl.graph.vertices.value_fps == graph_string_functions) {
      cassert(actual_params.label_type == c_nel_param_type_string);
   }
   else {
      cassert(0);
   }

   // - create or adjust vertex -
   unsigned vertex_idx = dl.vertex_array.get_idx_by_name(dl.vertex_edge_name.size - 1,dl.vertex_edge_name.data);

   if (vertex_idx != c_idx_not_exist) {
      vertex_s &vertex = dl.graph.vertices[dl.vertex_array[vertex_idx].idx];

      if (actual_params.label_type == c_nel_param_type_string) {
         dl.graph.vertices.vf_operator_equal(&vertex.value,(void *)&actual_params.label_string_value);
      }
      else {
         dl.graph.vertices.vf_operator_equal(&vertex.value,actual_params.label_value);
      }
   }
   else {
      if (actual_params.label_type == c_nel_param_type_string) {
         vertex_idx = dl.graph.insert_vertex((void *)&actual_params.label_string_value);
      }
      else {
         vertex_idx = dl.graph.insert_vertex((void *)actual_params.label_value);
      }

      dl.vertex_array.push_blank();
      name_map_s &name_map = dl.vertex_array.last();

      name_map.name.swap(dl.vertex_edge_name);
      name_map.idx = vertex_idx;
   }

   // -----

   debug_message_4(fprintf(stderr,"dot_parser: parse_action: pa_create_vertex: idx: %u\n",vertex_idx));
}/*}}}*/

void dot_loader_s::pa_create_edge(dot_loader_s &dl)
{/*{{{*/
   ne_parameters_s &actual_params = dl.parameters[c_pct_actual];

   // - test type of label and graph labeling type -
   if (dl.graph.edges.value_fps == graph_blank_functions) {
      if (actual_params.label_type != c_nel_param_type_null) {
         cassert(dl.graph.edges.used <= 0);

         switch (actual_params.label_type) {
         case c_nel_param_type_identifier:
            dl.graph.edges.value_fps = (void **)graph_int_functions;
            break;
         case c_nel_param_type_char:
            dl.graph.edges.value_fps = (void **)graph_char_functions;
            break;
         case c_nel_param_type_integer:
            dl.graph.edges.value_fps = (void **)graph_int_functions;
            break;
         case c_nel_param_type_float:
            dl.graph.edges.value_fps = (void **)graph_float_functions;
            break;
         case c_nel_param_type_string:
            dl.graph.edges.value_fps = (void **)graph_string_functions;
            break;
         default:
            cassert(0);
         }
      }
   }
   else if (dl.graph.edges.value_fps == graph_char_functions) {
      cassert(actual_params.label_type == c_nel_param_type_char);
   }
   else if (dl.graph.edges.value_fps == graph_int_functions) {
      cassert(actual_params.label_type == c_nel_param_type_integer);
   }
   else if (dl.graph.edges.value_fps == graph_float_functions) {
      cassert(actual_params.label_type == c_nel_param_type_float);
   }
   else if (dl.graph.edges.value_fps == graph_string_functions) {
      cassert(actual_params.label_type == c_nel_param_type_string);
   }
   else {
      cassert(0);
   }

   // - insert edge to graph -
   unsigned edge_idx;
   if (actual_params.label_type == c_nel_param_type_string) {
      edge_idx = dl.graph.insert_edge(dl.vertex_array[dl.vertex_0_idx].idx,dl.vertex_array[dl.vertex_1_idx].idx,(void *)&actual_params.label_string_value);
   }
   else {
      edge_idx = dl.graph.insert_edge(dl.vertex_array[dl.vertex_0_idx].idx,dl.vertex_array[dl.vertex_1_idx].idx,(void *)actual_params.label_value);
   }

   if (dl.store_edge_identifiers) {
      dl.edge_array.push_blank();
      name_map_s &name_map = dl.edge_array.last();

      name_map.name.swap(dl.vertex_edge_name);
      name_map.idx = edge_idx;
   }

   // -----
   debug_message_4(fprintf(stderr,"dot_parser: parse_action: pa_create_edge\n"));
}/*}}}*/

void dot_loader_s::pa_graph_vertex(dot_loader_s &dl)
{/*{{{*/

   // - copy default vertex settings -
   dl.parameters[c_pct_actual] = dl.parameters[c_pct_default_vertex];

   // - set actual as parameter target -
   dl.parameter_target = c_pct_actual;

   // - get vertex name position -
   lalr_stack_element_s &lse = dl.lalr_stack[dl.lalr_stack.used - 1];

   unsigned name_length = lse.terminal_end - lse.terminal_start;
   char *name_data = dl.source_string.data + lse.terminal_start;

   // - copy vertex name -
   dl.vertex_edge_name.set(name_length,name_data);

   // -----

   debug_message_4(fprintf(stderr,"dot_parser: parse_action: pa_graph_vertex: name: %s\n",dl.vertex_edge_name.data));
}/*}}}*/

void dot_loader_s::pa_graph_edge(dot_loader_s &dl)
{/*{{{*/

   // - copy default edge settings -
   dl.parameters[c_pct_actual] = dl.parameters[c_pct_default_edge];

   // - set actual as parameter target -
   dl.parameter_target = c_pct_actual;

   // - get first vertex name position -
   lalr_stack_element_s &first_lse = dl.lalr_stack[dl.lalr_stack.used - 3];

   unsigned first_name_length = first_lse.terminal_end - first_lse.terminal_start;
   char *first_name_data = dl.source_string.data + first_lse.terminal_start;

   // - find edge vertex idx -
   dl.vertex_0_idx = dl.vertex_array.get_idx_by_name(first_name_length,first_name_data);
   cassert(dl.vertex_0_idx != c_idx_not_exist);

   // - get second vertex name position -
   lalr_stack_element_s &second_lse = dl.lalr_stack[dl.lalr_stack.used - 1];

   unsigned second_name_length = second_lse.terminal_end - second_lse.terminal_start;
   char *second_name_data = dl.source_string.data + second_lse.terminal_start;

   // - find edge vertex idx -
   dl.vertex_1_idx = dl.vertex_array.get_idx_by_name(second_name_length,second_name_data);
   cassert(dl.vertex_1_idx != c_idx_not_exist);

   // - if enabled storing of edge identifiers -
   if (dl.store_edge_identifiers) {
      
      // - get edge name position -
      lalr_stack_element_s &lse = dl.lalr_stack[dl.lalr_stack.used - 5];

      unsigned name_length = lse.terminal_end - lse.terminal_start;
      char *name_data = dl.source_string.data + lse.terminal_start;

      // - copy vertex name -
      dl.vertex_edge_name.set(name_length,name_data);
   }

   // -----

   debug_message_4(fprintf(stderr,"dot_parser: parse_action: pa_graph_edge: vertices: %s -> %s\n",dl.vertex_array[dl.vertex_0_idx].name.data,dl.vertex_array[dl.vertex_1_idx].name.data));
}/*}}}*/

void dot_loader_s::pa_set_label(dot_loader_s &dl)
{/*{{{*/
   switch (dl.last_value_type) {
   case c_nel_param_type_char:
   case c_nel_param_type_integer:
   case c_nel_param_type_float:
      {
         ne_parameters_s &params = dl.parameters[dl.parameter_target];

         params.label_type = dl.last_value_type;
         params.label_value = dl.last_value;
      }
      break;
   case c_nel_param_type_string:
      {
         ne_parameters_s &params = dl.parameters[dl.parameter_target];

         params.label_type = c_nel_param_type_string;
         params.label_string_value.swap(dl.last_string_value);
      }
      break;
   default:
      cassert(0);
   }

   // -----

   debug_message_4(fprintf(stderr,"dot_parser: parse_action: pa_set_label\n"));
}/*}}}*/

void dot_loader_s::pa_identifier(dot_loader_s &dl)
{/*{{{*/

   // - get identifier string -
   lalr_stack_element_s &lse = dl.lalr_stack[dl.lalr_stack.used - 1];

   unsigned name_length = lse.terminal_end - lse.terminal_start;
   char *name_data = dl.source_string.data + lse.terminal_start;

   // - copy identifier string -
   dl.last_string_value.set(name_length,name_data);

   // - set last value type -
   dl.last_value_type = c_nel_param_type_identifier;

   // -----

   debug_message_4(fprintf(stderr,"dot_parser: parse_action: pa_identifier\n"));
}/*}}}*/

void dot_loader_s::pa_single_char_const(dot_loader_s &dl)
{/*{{{*/
   char const_char = dl.source_string.data[dl.lalr_stack.last().terminal_start + 1];

   // - set last value -
   dl.last_value = (pointer)(t_ps_uint)const_char;

   // - set last value type -
   dl.last_value_type = c_nel_param_type_char;

   // -----

   debug_message_4(fprintf(stderr,"dot_parser: parse_action: pa_single_char_const: %c\n",const_char));
}/*}}}*/

void dot_loader_s::pa_octal_char_const(dot_loader_s &dl)
{/*{{{*/
   lalr_stack_element_s &lse = dl.lalr_stack.last();
   unsigned char_num_end = (lse.terminal_end - lse.terminal_start) - 1;
   char *char_num_data = dl.source_string.data + lse.terminal_start;

   // - retrieve of char number -
   char_num_data[char_num_end] = '\0';
   char const_char = strtol(char_num_data + 2,NULL,8);
   char_num_data[char_num_end] = '\'';

   // - set last value -
   dl.last_value = (pointer)(t_ps_uint)const_char;

   // - set last value type -
   dl.last_value_type = c_nel_param_type_char;

   // -----

   debug_message_4(
      char *ptr = dl.source_string.data + lse.terminal_end;
      *ptr = '\0';
      fprintf(stderr,"dot_parser: parse_action: pa_octal_char_const: %s\n",dl.source_string.data + lse.terminal_start);
      *ptr = '\'';
   );
}/*}}}*/

void dot_loader_s::pa_hex_char_const(dot_loader_s &dl)
{/*{{{*/
   lalr_stack_element_s &lse = dl.lalr_stack.last();
   unsigned char_num_end = (lse.terminal_end - lse.terminal_start) - 1;
   char *char_num_data = dl.source_string.data + lse.terminal_start;

   // - retrieve of char number -
   char_num_data[char_num_end] = '\0';
   char const_char = strtol(char_num_data + 3,NULL,16);
   char_num_data[char_num_end] = '\'';

   // - set last value -
   dl.last_value = (pointer)(t_ps_uint)const_char;

   // - set last value type -
   dl.last_value_type = c_nel_param_type_char;

   // -----

   debug_message_4(
      char *ptr = dl.source_string.data + lse.terminal_end;
      *ptr = '\0';
      fprintf(stderr,"dot_parser: parse_action: pa_hex_char_const: %s\n",dl.source_string.data + lse.terminal_start);
      *ptr = '\'';
   );
}/*}}}*/

void dot_loader_s::pa_backslash_char_const(dot_loader_s &dl)
{/*{{{*/
   char const_char = 0;

   switch (dl.source_string.data[dl.lalr_stack.last().terminal_start + 2]) {
   case 'a': const_char = '\a'; break;
   case 'b': const_char = '\b'; break;
   case 'f': const_char = '\f'; break;
   case 'n': const_char = '\n'; break;
   case 'r': const_char = '\r'; break;
   case 't': const_char = '\t'; break;
   case 'v': const_char = '\v'; break;
   case '\\': const_char = '\\'; break;
   case '?': const_char = '\?'; break;
   case '\'': const_char = '\''; break;
   case '"': const_char = '"'; break;
   default:
      debug_assert(0);
   }

   // - set last value -
   dl.last_value = (pointer)(t_ps_uint)const_char;

   // - set last value type -
   dl.last_value_type = c_nel_param_type_char;

   // -----

   debug_message_4(
      lalr_stack_element_s &lse = dl.lalr_stack.last();
      char *ptr = dl.source_string.data + lse.terminal_end;
      *ptr = '\0';
      fprintf(stderr,"dot_parser: parse_action: pa_backlash_char_const: %s\n",dl.source_string.data + lse.terminal_start);
      *ptr = '\'';
   );
}/*}}}*/

void dot_loader_s::pa_oct_int_const(dot_loader_s &dl)
{/*{{{*/
   lalr_stack_element_s &lse = dl.lalr_stack.last();
   unsigned num_end = lse.terminal_end - lse.terminal_start;
   char *num_data = dl.source_string.data + lse.terminal_start;

   // - retrieve of number -
   char tmp_char = num_data[num_end];
   num_data[num_end] = '\0';
   int const_int = strtol(num_data,NULL,8);
   num_data[num_end] = tmp_char;

   // - set last value -
   dl.last_value = (pointer)(t_ps_uint)const_int;

   // - set last value type -
   dl.last_value_type = c_nel_param_type_integer;

   // -----

   debug_message_4(
      num_data[num_end] = '\0';
      fprintf(stderr,"dot_parser: parse_action: pa_const_oct_int: %s\n",num_data);
      num_data[num_end] = tmp_char;
   );
}/*}}}*/

void dot_loader_s::pa_dec_int_const(dot_loader_s &dl)
{/*{{{*/
   lalr_stack_element_s &lse = dl.lalr_stack.last();
   unsigned num_end = lse.terminal_end - lse.terminal_start;
   char *num_data = dl.source_string.data + lse.terminal_start;

   // - retrieve of number -
   char tmp_char = num_data[num_end];
   num_data[num_end] = '\0';
   int const_int = strtol(num_data,NULL,10);
   num_data[num_end] = tmp_char;

   // - set last value -
   dl.last_value = (pointer)(t_ps_uint)const_int;

   // - set last value type -
   dl.last_value_type = c_nel_param_type_integer;

   // -----

   debug_message_4(
      num_data[num_end] = '\0';
      fprintf(stderr,"dot_parser: parse_action: pa_const_dec_int: %s\n",num_data);
      num_data[num_end] = tmp_char;
   );
}/*}}}*/

void dot_loader_s::pa_hex_int_const(dot_loader_s &dl)
{/*{{{*/
   lalr_stack_element_s &lse = dl.lalr_stack.last();
   unsigned num_end = lse.terminal_end - lse.terminal_start;
   char *num_data = dl.source_string.data + lse.terminal_start;

   // - retrieve of number -
   char tmp_char = num_data[num_end];
   num_data[num_end] = '\0';
   int const_int = strtol(num_data,NULL,16);
   num_data[num_end] = tmp_char;

   // - set last value -
   dl.last_value = (pointer)(t_ps_uint)const_int;

   // - set last value type -
   dl.last_value_type = c_nel_param_type_integer;

   // -----

   debug_message_4(
      num_data[num_end] = '\0';
      fprintf(stderr,"dot_parser: parse_action: pa_const_hex_int: %s\n",num_data);
      num_data[num_end] = tmp_char;
   );
}/*}}}*/

void dot_loader_s::pa_float_const(dot_loader_s &dl)
{/*{{{*/
   lalr_stack_element_s &lse = dl.lalr_stack.last();
   unsigned float_num_end = lse.terminal_end - lse.terminal_start;
   char *float_num_data = dl.source_string.data + lse.terminal_start;

   // - retrieve of number from string -
   char tmp_char = float_num_data[float_num_end];
   float_num_data[float_num_end] = '\0';
   float const_float = strtod(float_num_data,NULL);
   float_num_data[float_num_end] = tmp_char;

   // - set last value -
   dl.last_value = *((pointer *)&const_float);

   // - set last value type -
   dl.last_value_type = c_nel_param_type_float;

   // -----
   debug_message_4(
      float_num_data[float_num_end] = '\0';
      fprintf(stderr,"dot_parser: parse_action: pa_const_float: %s\n",float_num_data);
      float_num_data[float_num_end] = tmp_char;
   );
}/*}}}*/

void dot_loader_s::pa_string_const(dot_loader_s &dl)
{/*{{{*/
   lalr_stack_element_s &lse = dl.lalr_stack.last();

   char *ptr = dl.source_string.data + lse.terminal_start + 1;
   char *ptr_end = dl.source_string.data + lse.terminal_end - 1;

   bc_array_s char_buffer;
   char_buffer.init_size((ptr_end - ptr) + 1);

   if (ptr < ptr_end) {
      do {
	 if (*ptr == '\\') {
	    ptr++;

	    // - process of char represented by octal number -
	    if (*ptr >= '0' && *ptr <= '7') {
	       char new_char = *ptr++ - '0';

	       if (*ptr >= '0' && *ptr <= '7') {
		  new_char = (new_char << 3) | (*ptr++ - '0');

		  if (*ptr >= '0' && *ptr <= '7') {
		     new_char = (new_char << 3) | (*ptr++ - '0');
		  }
	       }

	       char_buffer.push(new_char);
	    }
	    // - process of char representation by hexadecimal number -
	    else if (*ptr == 'x') {
	       ptr++;
	       char new_char = 0;

	       // - first char in hexadecimal representation -
	       if (*ptr >= '0' && *ptr <= '9') {
		  new_char = *ptr++ - '0';
	       }
	       else if (*ptr >= 'a' && *ptr <= 'f') {
		  new_char = 10 + (*ptr++ - 'a');
	       }
	       else if (*ptr >= 'A' && *ptr <= 'F') {
		  new_char = 10 + (*ptr++ - 'A');
	       }
	       else {
		  debug_assert(0);
	       }

	       // - second char in hexadecimal representation -
	       if (*ptr >= '0' && *ptr <= '9') {
		  new_char = (new_char << 4) | (*ptr++ - '0');
	       }
	       else if (*ptr >= 'a' && *ptr <= 'f') {
		  new_char = (new_char << 4) | (10 + (*ptr++ - 'a'));
	       }
	       else if (*ptr >= 'A' && *ptr <= 'F') {
		  new_char = (new_char << 4) | (10 + (*ptr++ - 'A'));
	       }

	       char_buffer.push(new_char);
	    }
	    else {
	       switch (*ptr++) {
	       case 'a': char_buffer.push('\a'); break;
	       case 'b': char_buffer.push('\b'); break;
	       case 'f': char_buffer.push('\f'); break;
	       case 'n': char_buffer.push('\n'); break;
	       case 'r': char_buffer.push('\r'); break;
	       case 't': char_buffer.push('\t'); break;
	       case 'v': char_buffer.push('\v'); break;
	       case '\\': char_buffer.push('\\'); break;
	       case '?': char_buffer.push('?'); break;
	       case '\'': char_buffer.push('\''); break;
	       case '"': char_buffer.push('"'); break;
	       default:
		  debug_assert(0);
	       }
	    }
	 }
	 else {
	    char_buffer.push(*ptr++);
	 }
      } while(ptr < ptr_end);
   }

   char_buffer.data[char_buffer.used] = '\0';

   // - copy identifier string -
   dl.last_string_value.clear();
   dl.last_string_value.size = char_buffer.used + 1;
   dl.last_string_value.data = char_buffer.data;

   // - set last value type -
   dl.last_value_type = c_nel_param_type_string;

   // -----
   debug_message_4(
      char *end_ptr = dl.source_string.data + lse.terminal_end;
      char tmp_char = *end_ptr;
      *end_ptr = '\0';
      fprintf(stderr,"dot_parser: parse_action: pa_const_string: %s\n",dl.source_string.data + lse.terminal_start);
      *end_ptr = tmp_char;
   );
}/*}}}*/




