
/*
 * author Jiří Zuzaňák
 * institution BUT FIT UPGM
 */

#ifndef __DOT_LOADER_H
#define __DOT_LOADER_H

/*
 * header files
 */

@begin
   include "basic.h"
   include "mem_check.h"
   include "structures.h"
   include "string.h"
   include "graph.h"
@end

/*
 * constants and definitions
 */

// - parse rules info -
const unsigned c_dl_rule_cnt = 38;
const unsigned dl_rule_head_idxs[c_dl_rule_cnt] = {33, 34, 34, 35, 36, 36, 37, 37, 38, 39, 39, 38, 38, 40, 41, 38, 38, 38, 38, 42, 43, 44, 44, 45, 45, 46, 46, 46, 47, 47, 47, 47, 47, 47, 47, 47, 47, 47, };
const unsigned dl_rule_body_lengths[c_dl_rule_cnt] = {1, 2, 1, 4, 1, 1, 2, 1, 3, 1, 1, 3, 3, 1, 1, 1, 3, 1, 3, 1, 6, 1, 1, 2, 1, 3, 3, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, };

// - parse table info -
#define dl_blank c_idx_not_exist
#define DL_SHIFT(VALUE) VALUE
#define DL_REDUCE(VALUE) c_dl_lalr_table_reduce_base + VALUE
#define DL_GOTO(VALUE) VALUE

const unsigned c_dl_lalr_table_reduce_base = 0x80000000;
const unsigned c_dl_terminal_plus_nonterminal_cnt = 48;
const unsigned dl_lalr_state_cnt = 62;

const unsigned dl_lalr_table[dl_lalr_state_cnt*c_dl_terminal_plus_nonterminal_cnt] = 
{/*{{{*/
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_SHIFT(5),    DL_SHIFT(6),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_SHIFT(3),       dl_blank,     DL_GOTO(1),     DL_GOTO(2),     DL_GOTO(4),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_SHIFT(7),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_SHIFT(8),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(4),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(5),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(10),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,     DL_GOTO(9),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(12),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(17),   DL_SHIFT(18),       dl_blank,   DL_SHIFT(19),       dl_blank,   DL_SHIFT(21),       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(20),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(11),       dl_blank,    DL_GOTO(13),    DL_GOTO(14),    DL_GOTO(15),    DL_GOTO(16),       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(7),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(7),   DL_REDUCE(7),       dl_blank,   DL_REDUCE(7),       dl_blank,   DL_REDUCE(7),       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(7),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(6),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(6),   DL_REDUCE(6),       dl_blank,   DL_REDUCE(6),       dl_blank,   DL_REDUCE(6),       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(6),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(22),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(24),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(23),       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(24),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(25),       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(15),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(15),  DL_REDUCE(15),       dl_blank,  DL_REDUCE(15),       dl_blank,  DL_REDUCE(15),   DL_SHIFT(24),       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(15),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(26),       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(17),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(17),  DL_REDUCE(17),       dl_blank,  DL_REDUCE(17),       dl_blank,  DL_REDUCE(17),   DL_SHIFT(24),       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(17),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(27),       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(13),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(14),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(19),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(19),  DL_REDUCE(19),       dl_blank,  DL_REDUCE(19),       dl_blank,  DL_REDUCE(19),  DL_REDUCE(19),       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(19),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(28),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(3),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(30),   DL_SHIFT(31),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(29),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(33),   DL_SHIFT(34),   DL_SHIFT(35),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(36),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(32),       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(24),  DL_REDUCE(24),  DL_REDUCE(24),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(24),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(33),   DL_SHIFT(34),   DL_SHIFT(35),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(37),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(32),       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(33),   DL_SHIFT(34),   DL_SHIFT(35),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(38),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(32),       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(33),   DL_SHIFT(34),   DL_SHIFT(35),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(39),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(32),       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(40),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(8),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(8),   DL_REDUCE(8),       dl_blank,   DL_REDUCE(8),       dl_blank,   DL_REDUCE(8),       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(8),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(9),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(9),   DL_REDUCE(9),       dl_blank,   DL_REDUCE(9),       dl_blank,   DL_REDUCE(9),       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_REDUCE(9),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(10),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(10),  DL_REDUCE(10),       dl_blank,  DL_REDUCE(10),       dl_blank,  DL_REDUCE(10),       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(10),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(23),  DL_REDUCE(23),  DL_REDUCE(23),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(23),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(41),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(42),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(43),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(11),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(11),  DL_REDUCE(11),       dl_blank,  DL_REDUCE(11),       dl_blank,  DL_REDUCE(11),       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(11),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(12),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(12),  DL_REDUCE(12),       dl_blank,  DL_REDUCE(12),       dl_blank,  DL_REDUCE(12),       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(12),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(16),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(16),  DL_REDUCE(16),       dl_blank,  DL_REDUCE(16),       dl_blank,  DL_REDUCE(16),       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(16),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(18),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(18),  DL_REDUCE(18),       dl_blank,  DL_REDUCE(18),       dl_blank,  DL_REDUCE(18),       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(18),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(44),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
   DL_SHIFT(47),   DL_SHIFT(48),   DL_SHIFT(49),   DL_SHIFT(50),   DL_SHIFT(51),   DL_SHIFT(52),   DL_SHIFT(53),   DL_SHIFT(54),   DL_SHIFT(55),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(46),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(45),
   DL_SHIFT(47),   DL_SHIFT(48),   DL_SHIFT(49),   DL_SHIFT(50),   DL_SHIFT(51),   DL_SHIFT(52),   DL_SHIFT(53),   DL_SHIFT(54),   DL_SHIFT(55),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(46),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(56),
   DL_SHIFT(47),   DL_SHIFT(48),   DL_SHIFT(49),   DL_SHIFT(50),   DL_SHIFT(51),   DL_SHIFT(52),   DL_SHIFT(53),   DL_SHIFT(54),   DL_SHIFT(55),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(46),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(57),
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(59),   DL_SHIFT(60),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,    DL_GOTO(58),       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(25),  DL_REDUCE(25),  DL_REDUCE(25),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(25),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(28),  DL_REDUCE(28),  DL_REDUCE(28),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(28),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(29),  DL_REDUCE(29),  DL_REDUCE(29),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(29),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(30),  DL_REDUCE(30),  DL_REDUCE(30),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(30),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(31),  DL_REDUCE(31),  DL_REDUCE(31),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(31),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(32),  DL_REDUCE(32),  DL_REDUCE(32),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(32),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(33),  DL_REDUCE(33),  DL_REDUCE(33),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(33),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(34),  DL_REDUCE(34),  DL_REDUCE(34),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(34),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(35),  DL_REDUCE(35),  DL_REDUCE(35),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(35),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(36),  DL_REDUCE(36),  DL_REDUCE(36),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(36),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(37),  DL_REDUCE(37),  DL_REDUCE(37),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(37),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(26),  DL_REDUCE(26),  DL_REDUCE(26),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(26),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(27),  DL_REDUCE(27),  DL_REDUCE(27),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(27),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,   DL_SHIFT(61),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(21),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(22),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(20),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(20),  DL_REDUCE(20),       dl_blank,  DL_REDUCE(20),       dl_blank,  DL_REDUCE(20),  DL_REDUCE(20),       dl_blank,       dl_blank,       dl_blank,  DL_REDUCE(20),       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,       dl_blank,
};/*}}}*/

// - parameters change target -
enum {
   c_pct_actual = 0,
   c_pct_default_vertex,
   c_pct_default_edge
};

// - vertex, edge parameter label types -
const unsigned c_ne_param_label_type_cnt = 6;
enum {
   c_nel_param_type_null = 0,
   c_nel_param_type_identifier,
   c_nel_param_type_char,
   c_nel_param_type_integer,
   c_nel_param_type_float,
   c_nel_param_type_string,
};

/*
 * definition of generated structures
 */

// -- lalr_stack_element_s --
@begin
   struct
   <
   unsigned:lalr_state
   unsigned:terminal_start
   unsigned:terminal_end
   >
   lalr_stack_element_s;
@end

// -- lalr_stack_s --
@begin
   array<lalr_stack_element_s>

   additions {
      inline void push(unsigned a_lalr_state);
      inline void push(unsigned a_lalr_state,unsigned a_terminal_start,unsigned a_terminal_end);
   }

   lalr_stack_s;
@end

// -- ne_parameters_s --
@begin
   struct
   <
   unsigned:label_type
   pointer:label_value
   string_s:label_string_value
   unsigned:color
   unsigned:shape
   >
   ne_parameters_s;
@end

// -- ne_parameters_array_s --
@begin
   array<ne_parameters_s> ne_parameters_array_s;
@end

// -- name_map_s --
@begin
   struct
   <
   string_s:name
   unsigned:idx
   >
   name_map_s;
@end

// -- name_map_array_s --
@begin
   array<name_map_s>

   additions {
      unsigned get_idx_by_name(unsigned a_length,const char *a_data);
   }

   name_map_array_s;
@end

// -- dot_loader_s --
@begin
   struct
   <
   string_s:source_string
   lalr_stack_s:lalr_stack

   name_map_array_s:vertex_array

   bool:store_edge_identifiers
   name_map_array_s:edge_array

   unsigned:vertex_0_idx
   unsigned:vertex_1_idx
   string_s:vertex_edge_name

   unsigned:parameter_target

   unsigned:last_value_type
   pointer:last_value
   string_s:last_string_value
   ne_parameters_array_s:parameters

   graph_s:graph
   >

   additions {
      unsigned recognize_terminal(unsigned &input_idx);
      bool parse_source_string();

      void load_graph_from_source_string(graph_s &a_graph,bool a_edge_identifiers);
      inline void load_graph_from_string(string_s &a_graph_string,graph_s &a_graph,bool a_edge_identifiers);
      inline bool load_graph(const char *a_file_name,graph_s &a_graph,bool a_edge_identifiers);

      static void pa_null(dot_loader_s &dl);
      static void pa_graph_name(dot_loader_s &dl);
      static void pa_graph_type_graph(dot_loader_s &dl);
      static void pa_graph_type_digraph(dot_loader_s &dl);
      static void pa_global_vertex(dot_loader_s &dl);
      static void pa_global_edge(dot_loader_s &dl);
      static void pa_create_vertex(dot_loader_s &dl);
      static void pa_create_edge(dot_loader_s &dl);
      static void pa_graph_vertex(dot_loader_s &dl);
      static void pa_graph_edge(dot_loader_s &dl);
      static void pa_set_label(dot_loader_s &dl);

      static void pa_identifier(dot_loader_s &dl);
      static void pa_single_char_const(dot_loader_s &dl);
      static void pa_octal_char_const(dot_loader_s &dl);
      static void pa_hex_char_const(dot_loader_s &dl);
      static void pa_backslash_char_const(dot_loader_s &dl);
      static void pa_oct_int_const(dot_loader_s &dl);
      static void pa_dec_int_const(dot_loader_s &dl);
      static void pa_hex_int_const(dot_loader_s &dl);
      static void pa_float_const(dot_loader_s &dl);
      static void pa_string_const(dot_loader_s &dl);
   }

   dot_loader_s;
@end

// - parse callback array -
extern void(*dl_parse_callbacks[])(dot_loader_s &dl);

/*
 * inline methods of generated structures
 */

// -- lalr_stack_element_s --
@begin
   inlines lalr_stack_element_s
@end

// -- lalr_stack_s --
@begin
   inlines lalr_stack_s
@end

inline void lalr_stack_s::push(unsigned a_lalr_state)
{
   if (used >= size) {
      copy_resize(size + c_array_add);
   }

   lalr_stack_element_s &target = data[used++];

   target.lalr_state = a_lalr_state;
}

inline void lalr_stack_s::push(unsigned a_lalr_state,unsigned a_terminal_start,unsigned a_terminal_end)
{
   if (used >= size) {
      copy_resize(size + c_array_add);
   }

   lalr_stack_element_s &target = data[used++];

   target.lalr_state = a_lalr_state;
   target.terminal_start = a_terminal_start;
   target.terminal_end = a_terminal_end;
}

// -- ne_parameters_s --
@begin
   inlines ne_parameters_s
@end

// -- ne_parameters_array_s --
@begin
   inlines ne_parameters_array_s
@end

// -- name_map_s --
@begin
   inlines name_map_s
@end

// -- name_map_array_s --
@begin
   inlines name_map_array_s
@end

// -- dot_loader_s --
@begin
   inlines dot_loader_s
@end

inline void dot_loader_s::load_graph_from_string(string_s &a_graph_string,graph_s &a_graph,bool a_edge_identifiers)
{/*{{{*/
   source_string.clear();
   source_string.data = a_graph_string.data;
   source_string.size = a_graph_string.size;

   load_graph_from_source_string(a_graph,a_edge_identifiers);

   source_string.init();
}/*}}}*/

inline bool dot_loader_s::load_graph(const char *a_file_name,graph_s &a_graph,bool a_edge_identifiers)
{/*{{{*/
   if (!source_string.load_text_file(a_file_name)) {
      return false;
   }

   load_graph_from_source_string(a_graph,a_edge_identifiers);

   return true;
}/*}}}*/

#endif

