
/*
 * author Jiří Zuzaňák
 * institution BUT FIT UPGM
 */

@begin
   include "iso_processor.h"
@end

/*
 * constants and definitions
 */

void(*ip_parse_callbacks[])(iso_processor_s &a_ip) = 
{
   iso_processor_s::pa_null,
   iso_processor_s::pa_null,
   iso_processor_s::pa_null,
   iso_processor_s::pa_null,
   iso_processor_s::pa_null,
   iso_processor_s::pa_null,
   iso_processor_s::pa_null,
   iso_processor_s::pa_null,
   iso_processor_s::pa_clean_all,
   iso_processor_s::pa_clean_searched_all,
   iso_processor_s::pa_clean_searched_int,
   iso_processor_s::pa_clean_host,
   iso_processor_s::pa_clean_automata,
   iso_processor_s::pa_clean_isomorphisms_all,
   iso_processor_s::pa_clean_isomorphisms_int,
   iso_processor_s::pa_null,
   iso_processor_s::pa_load_searched,
   iso_processor_s::pa_load_host,
   iso_processor_s::pa_null,
   iso_processor_s::pa_join_vertices_all,
   iso_processor_s::pa_join_vertices_none,
   iso_processor_s::pa_null,
   iso_processor_s::pa_null,
   iso_processor_s::pa_null,
   iso_processor_s::pa_join_vertex,
   iso_processor_s::pa_null,
   iso_processor_s::pa_create_automata,
   iso_processor_s::pa_create_isomorphisms,
   iso_processor_s::pa_null,
   iso_processor_s::print_searched_all,
   iso_processor_s::print_searched_int,
   iso_processor_s::pa_print_host,
   iso_processor_s::pa_print_automata,
   iso_processor_s::pa_print_automata_dot,
   iso_processor_s::pa_null,
   iso_processor_s::pa_print_isomorphisms_all,
   iso_processor_s::pa_print_isomorphisms_all_dot,
   iso_processor_s::pa_print_isomorphisms_int,
   iso_processor_s::pa_print_isomorphisms_int_dot,
   iso_processor_s::pa_oct_int_constant,
   iso_processor_s::pa_dec_int_constant,
   iso_processor_s::pa_hex_int_constant,
};

/*
 * methods of generated structures
 */

// -- iso_processor_s --
@begin
   methods iso_processor_s
@end

unsigned iso_processor_s::recognize_terminal(unsigned &input_idx)
{/*{{{*/
   unsigned source_string_length = source_string.size - 1;

#define GET_NEXT_CHAR() \
{\
   if (input_idx < source_string_length) {\
      in_char = (unsigned char)source_string[input_idx];\
   }\
   else {\
      in_char = '\0';\
   }\
}

#define CLOSE_CHAR(RET_TERM_IDX) \
{\
   if (in_char == '\0') {\
      return RET_TERM_IDX;\
   }\
\
   input_idx++;\
}

   unsigned short in_char;

// - STATE 0 - 
   GET_NEXT_CHAR();

   if (in_char == 0)
      goto state_1_label;

   if (in_char == 9)
      goto state_24_label;

   if (in_char == 10)
      goto state_2_label;

   if (in_char == 32)
      goto state_24_label;

   if (in_char == 34)
      goto state_3_label;

   if (in_char == 35)
      goto state_4_label;

   if (in_char == 44)
      goto state_5_label;

   if (in_char == 47)
      goto state_6_label;

   if (in_char == 48)
      goto state_7_label;

   if (in_char >= 49 && in_char < 58)
      goto state_8_label;

   if (in_char == 59)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char == 97)
      goto state_11_label;

   if (in_char == 98)
      goto state_10_label;

   if (in_char == 99)
      goto state_12_label;

   if (in_char == 100)
      goto state_13_label;

   if (in_char >= 101 && in_char < 104)
      goto state_10_label;

   if (in_char == 104)
      goto state_14_label;

   if (in_char == 105)
      goto state_15_label;

   if (in_char == 106)
      goto state_16_label;

   if (in_char == 107)
      goto state_10_label;

   if (in_char == 108)
      goto state_17_label;

   if (in_char == 109)
      goto state_10_label;

   if (in_char == 110)
      goto state_18_label;

   if (in_char == 111)
      goto state_10_label;

   if (in_char == 112)
      goto state_19_label;

   if (in_char >= 113 && in_char < 115)
      goto state_10_label;

   if (in_char == 115)
      goto state_20_label;

   if (in_char >= 116 && in_char < 118)
      goto state_10_label;

   if (in_char == 118)
      goto state_21_label;

   if (in_char >= 119 && in_char < 123)
      goto state_10_label;

   if (in_char == 123)
      goto state_22_label;

   if (in_char == 125)
      goto state_23_label;

   return c_idx_not_exist;

// - STATE 1 - 
state_1_label:
   CLOSE_CHAR(26)
   return 26;

// - STATE 2 - 
state_2_label:
   CLOSE_CHAR(22)
   GET_NEXT_CHAR();

   if (in_char >= 9 && in_char < 11)
      goto state_24_label;

   if (in_char == 32)
      goto state_24_label;

   return 22;

// - STATE 3 - 
state_3_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 34)
      goto state_3_label;

   if (in_char == 34)
      goto state_25_label;

   if (in_char >= 35 && in_char < 257)
      goto state_3_label;

   return c_idx_not_exist;

// - STATE 4 - 
state_4_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 10)
      goto state_4_label;

   if (in_char == 10)
      goto state_26_label;

   if (in_char >= 11 && in_char < 257)
      goto state_4_label;

   return c_idx_not_exist;

// - STATE 5 - 
state_5_label:
   CLOSE_CHAR(18)
   return 18;

// - STATE 6 - 
state_6_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 47)
      goto state_27_label;

   return c_idx_not_exist;

// - STATE 7 - 
state_7_label:
   CLOSE_CHAR(0)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 56)
      goto state_28_label;

   if (in_char == 88)
      goto state_29_label;

   if (in_char == 120)
      goto state_29_label;

   return 0;

// - STATE 8 - 
state_8_label:
   CLOSE_CHAR(1)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_8_label;

   return 1;

// - STATE 9 - 
state_9_label:
   CLOSE_CHAR(21)
   return 21;

// - STATE 10 - 
state_10_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 11 - 
state_11_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 108)
      goto state_10_label;

   if (in_char == 108)
      goto state_30_label;

   if (in_char >= 109 && in_char < 117)
      goto state_10_label;

   if (in_char == 117)
      goto state_31_label;

   if (in_char >= 118 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 12 - 
state_12_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 108)
      goto state_10_label;

   if (in_char == 108)
      goto state_32_label;

   if (in_char >= 109 && in_char < 114)
      goto state_10_label;

   if (in_char == 114)
      goto state_33_label;

   if (in_char >= 115 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 13 - 
state_13_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 111)
      goto state_10_label;

   if (in_char == 111)
      goto state_34_label;

   if (in_char >= 112 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 14 - 
state_14_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 111)
      goto state_10_label;

   if (in_char == 111)
      goto state_35_label;

   if (in_char >= 112 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 15 - 
state_15_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 115)
      goto state_10_label;

   if (in_char == 115)
      goto state_36_label;

   if (in_char >= 116 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 16 - 
state_16_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 111)
      goto state_10_label;

   if (in_char == 111)
      goto state_37_label;

   if (in_char >= 112 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 17 - 
state_17_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 111)
      goto state_10_label;

   if (in_char == 111)
      goto state_38_label;

   if (in_char >= 112 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 18 - 
state_18_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 111)
      goto state_10_label;

   if (in_char == 111)
      goto state_39_label;

   if (in_char >= 112 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 19 - 
state_19_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 114)
      goto state_10_label;

   if (in_char == 114)
      goto state_40_label;

   if (in_char >= 115 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 20 - 
state_20_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 101)
      goto state_10_label;

   if (in_char == 101)
      goto state_41_label;

   if (in_char >= 102 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 21 - 
state_21_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 101)
      goto state_10_label;

   if (in_char == 101)
      goto state_42_label;

   if (in_char >= 102 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 22 - 
state_22_label:
   CLOSE_CHAR(16)
   return 16;

// - STATE 23 - 
state_23_label:
   CLOSE_CHAR(17)
   return 17;

// - STATE 24 - 
state_24_label:
   CLOSE_CHAR(25)
   GET_NEXT_CHAR();

   if (in_char >= 9 && in_char < 11)
      goto state_24_label;

   if (in_char == 32)
      goto state_24_label;

   return 25;

// - STATE 25 - 
state_25_label:
   CLOSE_CHAR(19)
   return 19;

// - STATE 26 - 
state_26_label:
   CLOSE_CHAR(23)
   return 23;

// - STATE 27 - 
state_27_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 10)
      goto state_27_label;

   if (in_char == 10)
      goto state_43_label;

   if (in_char >= 11 && in_char < 257)
      goto state_27_label;

   return c_idx_not_exist;

// - STATE 28 - 
state_28_label:
   CLOSE_CHAR(0)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 56)
      goto state_28_label;

   return 0;

// - STATE 29 - 
state_29_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_44_label;

   if (in_char >= 65 && in_char < 71)
      goto state_44_label;

   if (in_char >= 97 && in_char < 103)
      goto state_44_label;

   return c_idx_not_exist;

// - STATE 30 - 
state_30_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 108)
      goto state_10_label;

   if (in_char == 108)
      goto state_45_label;

   if (in_char >= 109 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 31 - 
state_31_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 116)
      goto state_10_label;

   if (in_char == 116)
      goto state_46_label;

   if (in_char >= 117 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 32 - 
state_32_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 101)
      goto state_10_label;

   if (in_char == 101)
      goto state_47_label;

   if (in_char >= 102 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 33 - 
state_33_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 101)
      goto state_10_label;

   if (in_char == 101)
      goto state_48_label;

   if (in_char >= 102 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 34 - 
state_34_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 116)
      goto state_10_label;

   if (in_char == 116)
      goto state_49_label;

   if (in_char >= 117 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 35 - 
state_35_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 115)
      goto state_10_label;

   if (in_char == 115)
      goto state_50_label;

   if (in_char >= 116 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 36 - 
state_36_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 111)
      goto state_10_label;

   if (in_char == 111)
      goto state_51_label;

   if (in_char >= 112 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 37 - 
state_37_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 105)
      goto state_10_label;

   if (in_char == 105)
      goto state_52_label;

   if (in_char >= 106 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 38 - 
state_38_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char == 97)
      goto state_53_label;

   if (in_char >= 98 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 39 - 
state_39_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 110)
      goto state_10_label;

   if (in_char == 110)
      goto state_54_label;

   if (in_char >= 111 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 40 - 
state_40_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 105)
      goto state_10_label;

   if (in_char == 105)
      goto state_55_label;

   if (in_char >= 106 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 41 - 
state_41_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char == 97)
      goto state_56_label;

   if (in_char >= 98 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 42 - 
state_42_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 114)
      goto state_10_label;

   if (in_char == 114)
      goto state_57_label;

   if (in_char >= 115 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 43 - 
state_43_label:
   CLOSE_CHAR(24)
   return 24;

// - STATE 44 - 
state_44_label:
   CLOSE_CHAR(2)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_44_label;

   if (in_char >= 65 && in_char < 71)
      goto state_44_label;

   if (in_char >= 97 && in_char < 103)
      goto state_44_label;

   return 2;

// - STATE 45 - 
state_45_label:
   CLOSE_CHAR(9)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 9;

// - STATE 46 - 
state_46_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 111)
      goto state_10_label;

   if (in_char == 111)
      goto state_58_label;

   if (in_char >= 112 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 47 - 
state_47_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char == 97)
      goto state_59_label;

   if (in_char >= 98 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 48 - 
state_48_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char == 97)
      goto state_60_label;

   if (in_char >= 98 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 49 - 
state_49_label:
   CLOSE_CHAR(11)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 11;

// - STATE 50 - 
state_50_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 116)
      goto state_10_label;

   if (in_char == 116)
      goto state_61_label;

   if (in_char >= 117 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 51 - 
state_51_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 109)
      goto state_10_label;

   if (in_char == 109)
      goto state_62_label;

   if (in_char >= 110 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 52 - 
state_52_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 110)
      goto state_10_label;

   if (in_char == 110)
      goto state_63_label;

   if (in_char >= 111 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 53 - 
state_53_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 100)
      goto state_10_label;

   if (in_char == 100)
      goto state_64_label;

   if (in_char >= 101 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 54 - 
state_54_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 101)
      goto state_10_label;

   if (in_char == 101)
      goto state_65_label;

   if (in_char >= 102 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 55 - 
state_55_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 110)
      goto state_10_label;

   if (in_char == 110)
      goto state_66_label;

   if (in_char >= 111 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 56 - 
state_56_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 114)
      goto state_10_label;

   if (in_char == 114)
      goto state_67_label;

   if (in_char >= 115 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 57 - 
state_57_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 116)
      goto state_10_label;

   if (in_char == 116)
      goto state_68_label;

   if (in_char >= 117 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 58 - 
state_58_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 109)
      goto state_10_label;

   if (in_char == 109)
      goto state_69_label;

   if (in_char >= 110 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 59 - 
state_59_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 110)
      goto state_10_label;

   if (in_char == 110)
      goto state_70_label;

   if (in_char >= 111 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 60 - 
state_60_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 116)
      goto state_10_label;

   if (in_char == 116)
      goto state_71_label;

   if (in_char >= 117 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 61 - 
state_61_label:
   CLOSE_CHAR(3)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 3;

// - STATE 62 - 
state_62_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 111)
      goto state_10_label;

   if (in_char == 111)
      goto state_72_label;

   if (in_char >= 112 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 63 - 
state_63_label:
   CLOSE_CHAR(7)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 7;

// - STATE 64 - 
state_64_label:
   CLOSE_CHAR(13)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 13;

// - STATE 65 - 
state_65_label:
   CLOSE_CHAR(10)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 10;

// - STATE 66 - 
state_66_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 116)
      goto state_10_label;

   if (in_char == 116)
      goto state_73_label;

   if (in_char >= 117 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 67 - 
state_67_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 99)
      goto state_10_label;

   if (in_char == 99)
      goto state_74_label;

   if (in_char >= 100 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 68 - 
state_68_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 105)
      goto state_10_label;

   if (in_char == 105)
      goto state_75_label;

   if (in_char >= 106 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 69 - 
state_69_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char == 97)
      goto state_76_label;

   if (in_char >= 98 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 70 - 
state_70_label:
   CLOSE_CHAR(12)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 12;

// - STATE 71 - 
state_71_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 101)
      goto state_10_label;

   if (in_char == 101)
      goto state_77_label;

   if (in_char >= 102 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 72 - 
state_72_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 114)
      goto state_10_label;

   if (in_char == 114)
      goto state_78_label;

   if (in_char >= 115 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 73 - 
state_73_label:
   CLOSE_CHAR(15)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 15;

// - STATE 74 - 
state_74_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 104)
      goto state_10_label;

   if (in_char == 104)
      goto state_79_label;

   if (in_char >= 105 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 75 - 
state_75_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 99)
      goto state_10_label;

   if (in_char == 99)
      goto state_80_label;

   if (in_char >= 100 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 76 - 
state_76_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 116)
      goto state_10_label;

   if (in_char == 116)
      goto state_81_label;

   if (in_char >= 117 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 77 - 
state_77_label:
   CLOSE_CHAR(14)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 14;

// - STATE 78 - 
state_78_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 112)
      goto state_10_label;

   if (in_char == 112)
      goto state_82_label;

   if (in_char >= 113 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 79 - 
state_79_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 101)
      goto state_10_label;

   if (in_char == 101)
      goto state_83_label;

   if (in_char >= 102 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 80 - 
state_80_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 101)
      goto state_10_label;

   if (in_char == 101)
      goto state_84_label;

   if (in_char >= 102 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 81 - 
state_81_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char == 97)
      goto state_85_label;

   if (in_char >= 98 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 82 - 
state_82_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 104)
      goto state_10_label;

   if (in_char == 104)
      goto state_86_label;

   if (in_char >= 105 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 83 - 
state_83_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 100)
      goto state_10_label;

   if (in_char == 100)
      goto state_87_label;

   if (in_char >= 101 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 84 - 
state_84_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 115)
      goto state_10_label;

   if (in_char == 115)
      goto state_88_label;

   if (in_char >= 116 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 85 - 
state_85_label:
   CLOSE_CHAR(5)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 5;

// - STATE 86 - 
state_86_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 105)
      goto state_10_label;

   if (in_char == 105)
      goto state_89_label;

   if (in_char >= 106 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 87 - 
state_87_label:
   CLOSE_CHAR(4)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 4;

// - STATE 88 - 
state_88_label:
   CLOSE_CHAR(8)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 8;

// - STATE 89 - 
state_89_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 115)
      goto state_10_label;

   if (in_char == 115)
      goto state_90_label;

   if (in_char >= 116 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 90 - 
state_90_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 109)
      goto state_10_label;

   if (in_char == 109)
      goto state_91_label;

   if (in_char >= 110 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 91 - 
state_91_label:
   CLOSE_CHAR(20)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 115)
      goto state_10_label;

   if (in_char == 115)
      goto state_92_label;

   if (in_char >= 116 && in_char < 123)
      goto state_10_label;

   return 20;

// - STATE 92 - 
state_92_label:
   CLOSE_CHAR(6)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_10_label;

   if (in_char >= 65 && in_char < 91)
      goto state_10_label;

   if (in_char == 95)
      goto state_10_label;

   if (in_char >= 97 && in_char < 123)
      goto state_10_label;

   return 6;

}/*}}}*/

void iso_processor_s::get_interactive_source_string()
{/*{{{*/
   char *line_ptr = readline(">>> ");

   if (line_ptr != NULL) {
      source_string.setf("%s;\n",line_ptr);
      free(line_ptr);
   }
   else {
      fputc('\n',rl_outstream);
      fflush(rl_outstream);
      source_string.set(0,"");
   }

   old_input_idx = 0;
   input_idx = 0;
}/*}}}*/

bool iso_processor_s::parse_source_string()
{/*{{{*/
   lalr_stack.used = 0;
   lalr_stack.push(0);

   old_input_idx = 0;
   input_idx = 0;
   unsigned ret_term = c_idx_not_exist;

   do {

      while (ret_term == c_idx_not_exist) {
         old_input_idx = input_idx;

         ret_term = recognize_terminal(input_idx);
         if (ret_term == c_idx_not_exist) {
            fprintf(stderr,"ERROR: unrecognized terminal symbol\n");

            if (interactive) get_interactive_source_string();
            else cassert(0);
         }

         if (interactive && (ret_term >= 22 && ret_term <= 24)) {
            get_interactive_source_string();
            ret_term = c_idx_not_exist;
         }
         else {
            if (ret_term >= 22 && ret_term <= 25) {
               ret_term = c_idx_not_exist;
            }
         }
      }

      // - nalezeni akce v tabulce akci -
      unsigned parse_action = ip_lalr_table[lalr_stack.last().lalr_state*c_ip_terminal_plus_nonterminal_cnt + ret_term];
      cassert(parse_action != c_idx_not_exist);

      // - akce SHIFT -
      if (parse_action < c_ip_lalr_table_reduce_base) {

         if (ret_term == 26) {
            break;
         }

         // - vlozi na zasobnik novy stav a pozici terminalu ve zdrojovem retezci -
         lalr_stack.push(parse_action,old_input_idx,input_idx);
         ret_term = c_idx_not_exist;
      }

      // -akce REDUCE-
      else {
         parse_action -= c_ip_lalr_table_reduce_base;

         // - vypis indexu pravidla redukce na vystup -
         ip_parse_callbacks[parse_action](*this);

         // - odstraneni tela pravidla z vrcholu zasobniku -
         lalr_stack.used -= ip_rule_body_lengths[parse_action];

         // - ulozeni noveho stavu automatu na zasobnik -
         unsigned goto_val = ip_lalr_table[lalr_stack.last().lalr_state*c_ip_terminal_plus_nonterminal_cnt + ip_rule_head_idxs[parse_action]];
         lalr_stack.push(goto_val);
      }

   } while(1);

   lalr_stack.clear();

   return true;
}/*}}}*/

void iso_processor_s::print_isomorphism_informations(unsigned a_sg_idx)
{/*{{{*/
   cassert(a_sg_idx < searched_graphs.used);

   ui_arrays_s &li_edge_maps_array = li_edge_maps_arrays[a_sg_idx];
   ui_arrays_s &li_vertex_maps_array = li_vertex_maps_arrays[a_sg_idx];
   ui_array_s &li_vertex_map_idxs = li_vertex_map_idxs_array[a_sg_idx];

   if (li_edge_maps_array.used != 0) {
      unsigned m_idx = 0;
      do {
         printf(" --- ISOMORPHISM %u --- \n",m_idx);
         
         // - print vertex mapping -
         {
            printf("VERTICES: ");

            ui_array_s &vertex_map = li_vertex_maps_array[li_vertex_map_idxs[m_idx]];
            vertex_rb_tree_s &s_vertices = searched_graphs[a_sg_idx].vertices;

            unsigned stack[s_vertices.get_descent_stack_size()];
            unsigned *stack_ptr = stack;

            unsigned v_idx = s_vertices.get_stack_min_value_idx(s_vertices.root_idx,&stack_ptr);
            do {
               printf("%4.4u - %4.4u, ",v_idx,vertex_map[v_idx]);
               v_idx = s_vertices.get_stack_next_idx(v_idx,&stack_ptr,stack);
            } while(v_idx != c_idx_not_exist);

            putchar('\n');
         }

         // - print edge mapping -
         {
            printf("EDGES:    ");

            ui_array_s &edge_map = li_edge_maps_array[m_idx];
            edge_rb_tree_s &s_edges = searched_graphs[a_sg_idx].edges;

            unsigned stack[s_edges.get_descent_stack_size()];
            unsigned *stack_ptr = stack;

            unsigned e_idx = s_edges.get_stack_min_value_idx(s_edges.root_idx,&stack_ptr);
            do {
               printf("%4.4u - %4.4u, ",e_idx,edge_map[e_idx]);
               e_idx = s_edges.get_stack_next_idx(e_idx,&stack_ptr,stack);
            } while(e_idx != c_idx_not_exist);

            printf("\n\n");
         }

      } while(++m_idx < li_edge_maps_array.used);
   }
   else {
      fprintf(stderr,"There are no isomorphisms found for searched graph at position %u\n",a_sg_idx);
   }
}/*}}}*/

void iso_processor_s::print_isomorphism_dot_informations(unsigned a_sg_idx)
{/*{{{*/
   cassert(a_sg_idx < searched_graphs.used);

   ui_arrays_s &li_edge_maps_array = li_edge_maps_arrays[a_sg_idx];
   ui_arrays_s &li_vertex_maps_array = li_vertex_maps_arrays[a_sg_idx];
   ui_array_s &li_vertex_map_idxs = li_vertex_map_idxs_array[a_sg_idx];

   if (li_edge_maps_array.used != 0) {
      unsigned m_idx = 0;
      do {
         ui_array_s &vertex_map = li_vertex_maps_array[li_vertex_map_idxs[m_idx]];
         ui_array_s &edge_map = li_edge_maps_array[m_idx];

         host_graph.DEBUG_print_dot_code_subgraph(stdout,searched_graphs[a_sg_idx],vertex_map,edge_map);
      } while(++m_idx < li_edge_maps_array.used);
   }
   else {
      fprintf(stderr,"There are no isomorphisms found for searched graph at position %u\n",a_sg_idx);
   }
}/*}}}*/

void iso_processor_s::pa_null(iso_processor_s &a_ip)
{/*{{{*/
}/*}}}*/

void iso_processor_s::pa_clean_all(iso_processor_s &a_ip)
{/*{{{*/
   a_ip.searched_graphs.clear();
   a_ip.join_vertex_maps.clear();
   a_ip.graph_parser.clear();
   a_ip.host_graph.clear();

   a_ip.li_vertex_maps_arrays.clear();
   a_ip.li_edge_maps_arrays.clear();
   a_ip.li_vertex_map_idxs_array.clear();

   // -----

   fprintf(stderr,"INFO: searched graph set, host graph, graph automata and graph isomorphisms has been cleared\n");
}/*}}}*/

void iso_processor_s::pa_clean_searched_all(iso_processor_s &a_ip)
{/*{{{*/
   a_ip.searched_graphs.clear();
   a_ip.join_vertex_maps.clear();
   a_ip.graph_parser.clear();

   a_ip.li_vertex_maps_arrays.clear();
   a_ip.li_edge_maps_arrays.clear();
   a_ip.li_vertex_map_idxs_array.clear();

   // -----

   fprintf(stderr,"INFO: searched graph set, graph automata and graph isomorphisms has been cleared\n");
}/*}}}*/

void iso_processor_s::pa_clean_searched_int(iso_processor_s &a_ip)
{/*{{{*/

   ui_array_s &uint_stack = a_ip.uint_stack;
   graph_array_s &searched_graphs = a_ip.searched_graphs;
   ui_arrays_s &join_vertex_maps = a_ip.join_vertex_maps;

   // -----

   unsigned sg_idx = uint_stack.pop();

   if (sg_idx >= searched_graphs.used) {
      fprintf(stderr,"ERROR: given index exceeds count of loaded searched graphs\n");
      return;
   }
   
   // - remove searched graph -
   searched_graphs.remove_by_idx(sg_idx);
   join_vertex_maps.remove_by_idx(sg_idx);

   a_ip.graph_parser.clear();

   a_ip.li_vertex_maps_arrays.clear();
   a_ip.li_edge_maps_arrays.clear();
   a_ip.li_vertex_map_idxs_array.clear();

   // -----

   fprintf(stderr,"INFO: cleared searched graph at position %u, cleared graph automata and graph isomorphisms\n",sg_idx);
}/*}}}*/

void iso_processor_s::pa_clean_host(iso_processor_s &a_ip)
{/*{{{*/
   a_ip.host_graph.clear();
   a_ip.li_vertex_maps_arrays.clear();
   a_ip.li_edge_maps_arrays.clear();
   a_ip.li_vertex_map_idxs_array.clear();

   // -----

   fprintf(stderr,"INFO: host graph, and isomotphisms was cleared\n");
}/*}}}*/

void iso_processor_s::pa_clean_automata(iso_processor_s &a_ip)
{/*{{{*/
   a_ip.graph_parser.clear();

   // -----

   fprintf(stderr,"INFO: graph automata was cleared\n");
}/*}}}*/

void iso_processor_s::pa_clean_isomorphisms_all(iso_processor_s &a_ip)
{/*{{{*/
   fprintf(stderr,"FIXME TODO: iso_processor_s::pa_clean_isomorphisms_all\n");
}/*}}}*/

void iso_processor_s::pa_clean_isomorphisms_int(iso_processor_s &a_ip)
{/*{{{*/
   fprintf(stderr,"FIXME TODO: iso_processor_s::pa_clean_isomorphisms_int\n");
}/*}}}*/

void iso_processor_s::pa_load_searched(iso_processor_s &a_ip)
{/*{{{*/
   string_s &source_string = a_ip.source_string;
   lalr_stack_s &lalr_stack = a_ip.lalr_stack;
   graph_array_s &searched_graphs = a_ip.searched_graphs;
   ui_arrays_s &join_vertex_maps = a_ip.join_vertex_maps;
   graph_parser_s &graph_parser = a_ip.graph_parser;
   dot_loader_s &searched_dot_loader = a_ip.searched_dot_loader;

   // -----

   // - create new searched graph -
   searched_graphs.push_blank();
   graph_s &searched_graph = searched_graphs.last();

   {
      // - retrieve file name of searched graph -
      lalr_stack_element_s &lse = lalr_stack.last();

      char *str_data = source_string.data + lse.terminal_start + 1;
      unsigned str_length = (lse.terminal_end - 1) - (lse.terminal_start + 1);

      // - insert end of string character -
      str_data[str_length] = '\0';

      // - load graph -
      if (!searched_dot_loader.load_graph(str_data,searched_graph,false)) {
         fprintf(stderr,"ERROR: cannot load searched graph from file \"%s\"\n",str_data);
         searched_graphs.used -= 1;
         str_data[str_length] = '"';
         return;
      }

      // - restore source string character -
      str_data[str_length] = '"';
   }

   // - test new graph properties -
   if (searched_graph.vertices.root_idx == c_idx_not_exist || (!searched_graph.is_connected_graph())) {
      fprintf(stderr,"ERROR: loaded searched graph is empty, or is not connected (is composed from more than one component)\n");
      searched_graphs.used -= 1;
      return;
   }

   if (searched_graphs.used > 1) {
      graph_s &zero_graph = searched_graphs[0];

      if (searched_graph.vertices.value_fps != zero_graph.vertices.value_fps ||
         searched_graph.edges.value_fps != zero_graph.edges.value_fps ||
         searched_graph.type != zero_graph.type) {
         fprintf(stderr,"ERROR: loaded searched graph is not compatible with previously loaded searched graphs (vertex and edge evaluation or graph type)\n");
         searched_graphs.used -= 1;
         return;
      }
   }

   // - clear graph parser if exist -
   if (graph_parser.vertices_value_fps != NULL || graph_parser.edges_value_fps != NULL) {
      graph_parser.clear();
   }

   // - create and initialize searched graph join vertex map -
   join_vertex_maps.push_blank();
   ui_array_s &join_vertex_map = join_vertex_maps.last();

   join_vertex_map.init_size(searched_graph.vertices.used);
   join_vertex_map.used = join_vertex_map.size;

   // - initialize join vertex map to blank (no join vertices) -
   memset(join_vertex_map.data,c_idx_not_exist,join_vertex_map.used*sizeof(unsigned));

   // -----

   fprintf(stderr,"INFO: searched graph loaded: position: %u, vertex_cnt: %u, edge_cnt: %u\n",searched_graphs.used - 1,searched_graph.vertex_cnt,searched_graph.edge_cnt);
}/*}}}*/

void iso_processor_s::pa_load_host(iso_processor_s &a_ip)
{/*{{{*/
   string_s &source_string = a_ip.source_string;
   lalr_stack_s &lalr_stack = a_ip.lalr_stack;
   graph_s &host_graph = a_ip.host_graph;
   dot_loader_s &host_dot_loader = a_ip.host_dot_loader;

   // -----

   // - retrieve file name of host graph -
   lalr_stack_element_s &lse = lalr_stack.last();

   char *str_data = source_string.data + lse.terminal_start + 1;
   unsigned str_length = (lse.terminal_end - 1) - (lse.terminal_start + 1);

   // - insert end of string character -
   str_data[str_length] = '\0';

   // - load host graph -
   if (!host_dot_loader.load_graph(str_data,host_graph,false)) {
      fprintf(stderr,"ERROR: cannot load host graph from file \"%s\"\n",str_data);
      str_data[str_length] = '"';
      return;
   }

   // - restore source string character -
   str_data[str_length] = '"';

   // -----

   fprintf(stderr,"INFO: host graph loaded: vertex_cnt: %u, edge_cnt: %u\n",host_graph.vertex_cnt,host_graph.edge_cnt);
}/*}}}*/

void iso_processor_s::pa_join_vertices_all(iso_processor_s &a_ip)
{/*{{{*/
   ui_arrays_s &join_vertex_maps = a_ip.join_vertex_maps;

   // -----

   if (join_vertex_maps.used == 0) {
      fprintf(stderr,"ERROR: there is no last loaded searched graph, for which can be defined join vertex map\n");
      return;
   }

   ui_array_s &join_vertex_map = join_vertex_maps.last();
   memset(join_vertex_map.data,0,join_vertex_map.used*sizeof(unsigned));

   // -----

   fprintf(stderr,"INFO: all vertices of searched graph at position %u was set as join\n",a_ip.join_vertex_maps.used - 1);
}/*}}}*/

void iso_processor_s::pa_join_vertices_none(iso_processor_s &a_ip)
{/*{{{*/
   ui_arrays_s &join_vertex_maps = a_ip.join_vertex_maps;

   // -----

   if (join_vertex_maps.used == 0) {
      fprintf(stderr,"ERROR: there is no last loaded searched graph, for which can be defined join vertex map\n");
      return;
   }

   ui_array_s &join_vertex_map = join_vertex_maps.last();
   memset(join_vertex_map.data,c_idx_not_exist,join_vertex_map.used*sizeof(unsigned));

   // -----

   fprintf(stderr,"INFO: all vertices of searched graph at position %u was set as not join\n",join_vertex_maps.used - 1);
}/*}}}*/

void iso_processor_s::pa_join_vertex(iso_processor_s &a_ip)
{/*{{{*/
   string_s &source_string = a_ip.source_string;
   lalr_stack_s &lalr_stack = a_ip.lalr_stack;
   ui_arrays_s &join_vertex_maps = a_ip.join_vertex_maps;
   dot_loader_s &searched_dot_loader = a_ip.searched_dot_loader;

   // -----

   // - retrieve vertex identifier -
   lalr_stack_element_s &lse = lalr_stack.last();

   char *name_data = source_string.data + lse.terminal_start;
   unsigned name_length = lse.terminal_end - lse.terminal_start;

   // - find vertex index -
   name_map_array_s &vertex_array = searched_dot_loader.vertex_array;
   unsigned v_idx = vertex_array.get_idx_by_name(name_length,name_data);
   if (v_idx == c_idx_not_exist) {
      char tmp_char = name_data[name_length];
      name_data[name_length] = '\0';
      fprintf(stderr,"ERROR: cannot find vertex %s in last loaded searched graph\n",name_data);
      name_data[name_length] = tmp_char;
      return;
   }

   // - retrieve real vertex index -
   v_idx = vertex_array[v_idx].idx;

   if (join_vertex_maps.used == 0) {
      fprintf(stderr,"ERROR: there is no last loaded searched graph, for which can be defined join vertex map\n");
      return;
   }

   // - mark vertex as join -
   ui_array_s &join_vertex_map = join_vertex_maps.last();
   cassert(join_vertex_map.used > v_idx);

   join_vertex_map[v_idx] = 0;

   // -----

   char tmp_char = name_data[name_length];
   name_data[name_length] = '\0';
   fprintf(stderr,"INFO: vertex \"%s\" of searched graph at position %u was set as join\n",name_data,join_vertex_maps.used - 1);
   name_data[name_length] = tmp_char;
   
}/*}}}*/

void iso_processor_s::pa_create_automata(iso_processor_s &a_ip)
{/*{{{*/
   graph_array_s &searched_graphs = a_ip.searched_graphs;
   ui_arrays_s &join_vertex_maps = a_ip.join_vertex_maps;
   graph_parser_s &graph_parser = a_ip.graph_parser;

   // -----

   // - test if there are some search graphs, and if there exist appropriate count of join vertex maps -
   if (searched_graphs.used == 0 || searched_graphs.used != join_vertex_maps.used) {
      fprintf(stderr,"ERROR: set of searched graphs was not properly defined\n");
      return;
   }

   // - create graph parser (graph automata) -
   graph_parser.clear();

   graph_parser.vertices_value_fps = searched_graphs[0].vertices.value_fps;
   graph_parser.edges_value_fps = searched_graphs[0].edges.value_fps;

   graph_parser.create_parsing_automata(searched_graphs,join_vertex_maps);
   graph_parser.create_edge_arrays(searched_graphs);

   // -----

   fprintf(stderr,"INFO: created graph automata (parser): state_cnt: %u\n",graph_parser.states.used);
}/*}}}*/

void iso_processor_s::pa_create_isomorphisms(iso_processor_s &a_ip)
{/*{{{*/
   graph_array_s &searched_graphs = a_ip.searched_graphs;
   graph_parser_s &graph_parser = a_ip.graph_parser;
   graph_s &host_graph = a_ip.host_graph;

   ui_arrays_array_s &li_vertex_maps_arrays = a_ip.li_vertex_maps_arrays;
   ui_arrays_array_s &li_edge_maps_arrays = a_ip.li_edge_maps_arrays;
   ui_arrays_s &li_vertex_map_idxs_array = a_ip.li_vertex_map_idxs_array;

   // -----

   // - test if is created graph parser -
   if (graph_parser.vertices_value_fps == NULL || graph_parser.edges_value_fps == NULL) {
      fprintf(stderr,"ERROR: cannot find graph isomorphisms (graph automata was not created)\n");
      return;
   }

   // - test host graph -
   if (host_graph.vertices.root_idx == c_idx_not_exist || host_graph.vertices.value_fps != graph_parser.vertices_value_fps || host_graph.edges.value_fps != graph_parser.edges_value_fps) {
      fprintf(stderr,"ERROR: host graph was not properly loaded\n");
      return;
   }

   graph_parser.find_isomorphic_subdigraphs(searched_graphs,host_graph,li_vertex_maps_arrays);
   graph_parser.find_edge_mappings(searched_graphs,host_graph,li_vertex_maps_arrays,li_vertex_map_idxs_array,li_edge_maps_arrays,false);

   // -----

   // - print info -
   {
      fprintf(stderr,"INFO:\n");

      unsigned idx = 0;
      do {
         fprintf(stderr,"   searched graph %u, isomorphism count: %u\n",idx,li_edge_maps_arrays[idx].used);
      } while(++idx < li_edge_maps_arrays.used);
   }

}/*}}}*/

void iso_processor_s::print_searched_all(iso_processor_s &a_ip)
{/*{{{*/
   graph_array_s &searched_graphs = a_ip.searched_graphs;

   // -----

   if (searched_graphs.used == 0) {
      fprintf(stderr,"ERROR: there are not loaded searched graphs\n");
      return;
   }

   graph_s *ptr = searched_graphs.data;
   graph_s *ptr_end = ptr + searched_graphs.used;
   do {
      ptr->DEBUG_print_dot_code(stdout);
   } while(++ptr < ptr_end);

   // -----

   fprintf(stderr,"INFO: all searched graphs was printed to standard output\n");
}/*}}}*/

void iso_processor_s::print_searched_int(iso_processor_s &a_ip)
{/*{{{*/
   ui_array_s &uint_stack = a_ip.uint_stack;
   graph_array_s &searched_graphs = a_ip.searched_graphs;

   // -----

   unsigned sg_idx = uint_stack.pop();

   if (sg_idx >= searched_graphs.used) {
      fprintf(stderr,"ERROR: given index exceeds count of loaded searched graphs\n");
      return;
   }

   searched_graphs[sg_idx].DEBUG_print_dot_code(stdout);

   // -----

   fprintf(stderr,"INFO: searched graph at position %u, was printed to standard output\n",sg_idx);
}/*}}}*/

void iso_processor_s::pa_print_host(iso_processor_s &a_ip)
{/*{{{*/

   a_ip.host_graph.DEBUG_print_dot_code(stdout);

   // -----

   fprintf(stderr,"INFO: host graph was printed to standard output\n");
}/*}}}*/

void iso_processor_s::pa_print_automata(iso_processor_s &a_ip)
{/*{{{*/
   graph_parser_s &graph_parser = a_ip.graph_parser;

   // -----

   if (graph_parser.vertices_value_fps == NULL || graph_parser.edges_value_fps == NULL) {
      fprintf(stderr,"ERROR: graph automata was not created yet\n");
      return;
   }

   graph_parser.DEBUG_print_states(stdout);

   // -----

   fprintf(stderr,"INFO: graph automata state machine information was printed to standard output\n");
}/*}}}*/

void iso_processor_s::pa_print_automata_dot(iso_processor_s &a_ip)
{/*{{{*/
   graph_parser_s &graph_parser = a_ip.graph_parser;

   // -----

   if (graph_parser.vertices_value_fps == NULL || graph_parser.edges_value_fps == NULL) {
      fprintf(stderr,"ERROR: graph automata was not created yet\n");
      return;
   }

   graph_parser.DEBUG_print_state_graph(stdout);

   // -----

   fprintf(stderr,"INFO: graph automata state machine information was printed to standard output (in dot format)\n");
}/*}}}*/

void iso_processor_s::pa_print_isomorphisms_all(iso_processor_s &a_ip)
{/*{{{*/
   graph_array_s &searched_graphs = a_ip.searched_graphs;
   ui_arrays_array_s &li_edge_maps_arrays = a_ip.li_edge_maps_arrays;

   // -----

   if (li_edge_maps_arrays.used == 0) {
      fprintf(stderr,"ERROR: there are not created isomoprhisms\n");
      return;
   }

   unsigned sg_idx = 0;
   do {
      printf(" -- SEARCHED GRAPH %u -- \n",sg_idx);
      a_ip.print_isomorphism_informations(sg_idx);
   } while(++sg_idx < searched_graphs.used);

   // -----

   fprintf(stderr,"INFO: isomorphisms of all searched graphs was printed to standard output\n");
}/*}}}*/

void iso_processor_s::pa_print_isomorphisms_all_dot(iso_processor_s &a_ip)
{/*{{{*/
   graph_array_s &searched_graphs = a_ip.searched_graphs;
   ui_arrays_array_s &li_edge_maps_arrays = a_ip.li_edge_maps_arrays;

   // -----

   if (li_edge_maps_arrays.used == 0) {
      fprintf(stderr,"ERROR: there are not created isomoprhisms\n");
      return;
   }

   unsigned sg_idx = 0;
   do {
      a_ip.print_isomorphism_dot_informations(sg_idx);
   } while(++sg_idx < searched_graphs.used);

   // -----

   fprintf(stderr,"INFO: isomorphisms of all searched graphs were printed in standard output (in dot format)\n");
}/*}}}*/

void iso_processor_s::pa_print_isomorphisms_int(iso_processor_s &a_ip)
{/*{{{*/
   ui_array_s &uint_stack = a_ip.uint_stack;
   ui_arrays_array_s &li_edge_maps_arrays = a_ip.li_edge_maps_arrays;

   // -----

   unsigned sg_idx = uint_stack.pop();

   if (sg_idx >= li_edge_maps_arrays.used) {
      fprintf(stderr,"ERROR: given index exceeds count of created isomorphisms\n");
      return;
   }

   a_ip.print_isomorphism_informations(sg_idx);

   // -----

   fprintf(stderr,"INFO: isomorphisms of searched graph at position %u was printed to standard output\n",sg_idx);
}/*}}}*/

void iso_processor_s::pa_print_isomorphisms_int_dot(iso_processor_s &a_ip)
{/*{{{*/
   ui_array_s &uint_stack = a_ip.uint_stack;
   ui_arrays_array_s &li_edge_maps_arrays = a_ip.li_edge_maps_arrays;

   // -----

   unsigned sg_idx = uint_stack.pop();

   if (sg_idx >= li_edge_maps_arrays.used) {
      fprintf(stderr,"ERROR: given index exceeds count of created isomorphisms\n");
      return;
   }

   a_ip.print_isomorphism_dot_informations(sg_idx);

   // -----

   fprintf(stderr,"INFO: isomorphisms of searched graph at position %u was printed to standard output (in dot format)\n",sg_idx);
}/*}}}*/

void iso_processor_s::pa_oct_int_constant(iso_processor_s &a_ip)
{/*{{{*/
   string_s &source_string = a_ip.source_string;
   lalr_stack_s &lalr_stack = a_ip.lalr_stack;
   ui_array_s &uint_stack = a_ip.uint_stack;

   // *****

   lalr_stack_element_s &lse = lalr_stack.last();
   unsigned num_end = lse.terminal_end - lse.terminal_start;
   char *num_data = source_string.data + lse.terminal_start;

   // - retrieve of number -
   char tmp_char = num_data[num_end];
   num_data[num_end] = '\0';
   int const_int = strtol(num_data,NULL,8);
   num_data[num_end] = tmp_char;

   // - insert integer constant on stack -
   uint_stack.push(const_int);
}/*}}}*/

void iso_processor_s::pa_dec_int_constant(iso_processor_s &a_ip)
{/*{{{*/
   string_s &source_string = a_ip.source_string;
   lalr_stack_s &lalr_stack = a_ip.lalr_stack;
   ui_array_s &uint_stack = a_ip.uint_stack;

   // *****

   lalr_stack_element_s &lse = lalr_stack.last();
   unsigned num_end = lse.terminal_end - lse.terminal_start;
   char *num_data = source_string.data + lse.terminal_start;

   // - retrieve of number -
   char tmp_char = num_data[num_end];
   num_data[num_end] = '\0';
   int const_int = strtol(num_data,NULL,10);
   num_data[num_end] = tmp_char;

   // - insert integer constant on stack -
   uint_stack.push(const_int);
}/*}}}*/

void iso_processor_s::pa_hex_int_constant(iso_processor_s &a_ip)
{/*{{{*/
   string_s &source_string = a_ip.source_string;
   lalr_stack_s &lalr_stack = a_ip.lalr_stack;
   ui_array_s &uint_stack = a_ip.uint_stack;

   // *****

   lalr_stack_element_s &lse = lalr_stack.last();
   unsigned num_end = lse.terminal_end - lse.terminal_start;
   char *num_data = source_string.data + lse.terminal_start;

   // - retrieve of number -
   char tmp_char = num_data[num_end];
   num_data[num_end] = '\0';
   int const_int = strtol(num_data,NULL,16);
   num_data[num_end] = tmp_char;

   // - insert integer constant on stack -
   uint_stack.push(const_int);
}/*}}}*/

