
/*
 * author Jiří Zuzaňák
 * institution BUT FIT UPGM
 */

@begin
   include "main.h"
@end

//#define INIT_SRAND

int main(int argc,char **argv)
{
   mc_init();

#ifdef INIT_SRAND
   {
      FILE *f = fopen("/dev/urandom","rb");
      cassert(f != NULL);

      // - read random number from linux "randomizer" -
      unsigned rand_seed;
      fread(&rand_seed,sizeof(unsigned),1,f);

      fclose(f);

      // - initialize random number generator -
      srand(rand_seed);
   }
#endif

   {

      // - set readline output stream -
      if (!isatty(fileno(stdin))) {
         rl_outstream = fopen("/dev/null","wb");
      }
      else {
         rl_outstream = stdout;
      }

      // - create and initialize isomorphism processor -
      iso_processor_s ip;
      ip.init();

      do {
         
         // - if there are given some arguments, load input from file -
         if (argc > 1) {
            ip.interactive = false;
            if (!ip.source_string.load_text_file(argv[1])) {
               fprintf(stderr,"ERROR: cannot open input file: \"%s\"\n",argv[1]);
               break;
            }
         }

         // - else interpret code from standard input -
         else {
            ip.interactive = true;
            ip.source_string.set(1,"\n");
         }

         // - parse source string -
         ip.parse_source_string();
      } while(0);

      ip.clear();

      // - close readline output stream -
      if (rl_outstream != stdout) {
         fclose(rl_outstream);
      }
   }

   mc_clear();

   return 0;
}

