
/*
 * author Jiří Zuzaňák
 * institution BUT FIT UPGM
 */

/*
 * ui_array_s
 */

%%define array
%name "ui_array_s"
%type "unsigned"
%%end

/*
 * string_array_s
 */

%%define array
%name "string_array_s"
%type "string_s"
%%end

/*
 * string_arrays_s
 */

%%define array
%name "string_arrays_s"
%type "string_array_s"
%%end

/*
 * data_type_s
 */

%%define set
%name "data_type_s"
%type "unsigned"
   %variable "cont_idx"
%type "string_s"
   %variable "string"
%type "string_s"
   %variable "real_name"
%type "unsigned"
   %variable "number"
%type "string_array_s"
   %variable "types"
%type "string_array_s"
   %variable "vars"
%type "ui_array_s"
   %variable "compare_idxs"
%%end

/*
 * data_types_s
 */

%%define array
%name "data_types_s"
%type "data_type_s"
%function "unsigned get_idx_by_real_name(unsigned n_length,char *n_data);"
%%end

/*
 * abbreviation_s
 * source_s
 */

%%define set
%name "abbreviation_s"
%name "source_s"
%type "string_s"
   %variable "string"
%type "unsigned"
   %variable "number"
%%end

/*
 * abbreviations_s
 * sources_s
 */

%%define array
%name "abbreviations_s"
%name "sources_s"
%type "abbreviation_s"
%function "unsigned get_idx_by_string(unsigned n_length,char *n_data);"
%%end

/*
 * lalr_stack_element_s
 */

%%define set
%name "lalr_stack_element_s"
%type "unsigned"
   %variable "first_num"
%type "unsigned"
   %variable "second_num"
%type "unsigned"
   %variable "third_num"
%%end

/*
 * lalr_stack_s
 */

%%define array
%name "lalr_stack_s"
%type "lalr_stack_element_s"
%function "inline void push(unsigned a_first_num);"
%function "inline void push(unsigned a_first_num,unsigned a_second_num,unsigned a_third_num);"
%%end

/*
 * process_s
 */

%%define set
%name "process_s"
%type "pointer"
   %variable "processor_ptr"
%type "string_s"
   %variable "source_string"
%type "unsigned"
   %variable "source_idx"
%type "lalr_stack_s"
   %variable "lalr_stack"
%type "string_arrays_s"
   %variable "cont_params"
%function "unsigned final_automata_recognize(string_s &source_string,unsigned &input_idx,unsigned &line_cnt);"
%function "void parse_def_code(string_s &def_code);"
%function "void run_on(char *file_name);"
%%end

/*
 * processor_s
 */

%%define set
%name "processor_s"
%type "data_types_s"
   %variables "data_types"
%type "abbreviations_s"
   %variable "abbreviations"
%type "string_array_s"
   %variable "include_names"
%function "void data_type_print(char *spaces,unsigned type_idx,char *var_name);"
%function "void generate_array_type(string_arrays_s &params,unsigned type_settings);"
%function "void generate_array_inlines(unsigned abb_idx,unsigned a_dt_idx);"
%function "void generate_array_methods(unsigned abb_idx,unsigned a_dt_idx);"
%function "void generate_queue_type(string_arrays_s &params,unsigned type_settings);"
%function "void generate_queue_inlines(unsigned abb_idx,unsigned a_dt_idx);"
%function "void generate_queue_methods(unsigned abb_idx,unsigned a_dt_idx);"
%function "void generate_set_type(string_arrays_s &params,unsigned type_settings);"
%function "void generate_set_inlines(unsigned abb_idx,unsigned a_dt_idx);"
%function "void generate_set_methods(unsigned abb_idx,unsigned a_dt_idx);"
%function "void generate_struct_type(string_arrays_s &params,unsigned type_settings);"
%function "void generate_struct_inlines(unsigned abb_idx,unsigned a_dt_idx);"
%function "void generate_struct_methods(unsigned abb_idx,unsigned a_dt_idx);"
%function "void generate_rb_tree_type(string_arrays_s &params,unsigned type_settings);"
%function "void generate_rb_tree_inlines(unsigned abb_idx,unsigned a_dt_idx);"
%function "void generate_rb_tree_methods(unsigned abb_idx,unsigned a_dt_idx);"
%function "void generate_container_def(string_s &cont_name,string_arrays_s &cont_params,unsigned type_settings);"
%function "void generate_type_inlines(unsigned a_length,char *a_data);"
%function "void generate_type_methods(unsigned a_length,char *a_data);"
%function "void init_processor();"
%function "void run(char *file_name);"
%function "void save_data(char *file_name);"
%function "void load_and_merge_data(char *file_name);"
%%end


