
/*
 * author Jiří Zuzaňák
 * institution BUT FIT UPGM
 */

#define ARRAY_INIT() \
{\
printf(\
"inline void %s::init()\n"\
"{/*{{{*/\n"\
"   size = 0;\n"\
"   used = 0;\n"\
"   data = NULL;\n"\
"}/*}}}*/\n"\
"\n"\
,IM_STRUCT_NAME);\
}

#define ARRAY_INIT_SIZE() \
{\
printf(\
"inline void %s::init_size(unsigned a_size)\n"\
"{/*{{{*/\n"\
"   init();\n"\
"   copy_resize(a_size);\n"\
"}/*}}}*/\n"\
"\n"\
,IM_STRUCT_NAME);\
}

#define ARRAY_CLEAR() \
{\
   if (!(TYPE_NUMBER & c_type_dynamic)) {\
printf(\
"inline void %s::clear()\n"\
,IM_STRUCT_NAME);\
   }\
   else {\
printf(\
"void %s::clear()\n"\
,IM_STRUCT_NAME);\
   }\
printf(\
"{/*{{{*/\n"\
"   if (data != NULL) {\n"\
);\
   if (TYPE_NUMBER & c_type_dynamic) {\
printf(\
"      %s *ptr = data;\n"\
"      %s *ptr_end = ptr + size;\n"\
"\n"\
"      do {\n"\
"         ptr->clear();\n"\
"      } while(++ptr < ptr_end);\n"\
"\n"\
,TYPE_NAME,TYPE_NAME);\
   }\
printf(\
"      cfree(data);\n"\
"   }\n"\
"\n"\
"   init();\n"\
"}/*}}}*/\n"\
"\n"\
);\
}

#define ARRAY_SET() \
{\
   if (!(TYPE_NUMBER & c_type_dynamic)) {\
printf(\
"inline void %s::set(unsigned a_used,%s *a_data)\n"\
,IM_STRUCT_NAME,TYPE_NAME);\
   }\
   else {\
printf(\
"void %s::set(unsigned a_used,%s *a_data)\n"\
,IM_STRUCT_NAME,TYPE_NAME);\
   }\
printf(\
"{/*{{{*/\n"\
"   clear();\n"\
"   if (a_used == 0) return;\n"\
"   \n"\
"   debug_assert(a_data != NULL);\n"\
"   copy_resize(a_used);\n"\
"\n"\
);\
   if (!(TYPE_NUMBER & c_type_dynamic)) {\
printf(\
"   memcpy(data,a_data,a_used*sizeof(%s));\n"\
,TYPE_NAME);\
   }\
   else {\
printf(\
"   %s *ptr = data;\n"\
"   %s *ptr_end = ptr + a_used;\n"\
"   %s *a_ptr = a_data;\n"\
"\n"\
"   do {\n"\
"      *ptr = *a_ptr;\n"\
"   } while(++a_ptr,++ptr < ptr_end);\n"\
"\n"\
,TYPE_NAME,TYPE_NAME,TYPE_NAME);\
   }\
printf(\
"   used = a_used;\n"\
"}/*}}}*/\n"\
"\n"\
);\
}

#define ARRAY_FLUSH() \
{\
printf(\
"inline void %s::flush()\n"\
"{/*{{{*/\n"\
"   copy_resize(used);\n"\
"}/*}}}*/\n"\
"\n"\
,IM_STRUCT_NAME);\
}

#define ARRAY_FLUSH_ALL() \
{\
   if (!(TYPE_NUMBER & c_type_flushable)) {\
printf(\
"inline void %s::flush_all()\n"\
,IM_STRUCT_NAME);\
   }\
   else {\
printf(\
"void %s::flush_all()\n"\
,IM_STRUCT_NAME);\
   }\
printf(\
"{/*{{{*/\n"\
);\
   if (TYPE_NUMBER & c_type_flushable) {\
printf(\
"   %s *ptr = data;\n"\
"   %s *ptr_end = ptr + used;\n"\
"\n"\
"   do {\n"\
"      ptr->flush_all();\n"\
"   } while(++ptr < ptr_end);\n"\
"\n"\
,TYPE_NAME,TYPE_NAME);\
   }\
printf(\
"   copy_resize(used);\n"\
"}/*}}}*/\n"\
"\n"\
);\
}

/*#define ARRAY_GET_SAVE_SIZE() \*/
/*{\*/
/*   if (!(TYPE_NUMBER & c_type_dynamic)) {\*/
/*printf(\*/
/*"inline unsigned %s::get_save_size()\n"\*/
/*,IM_STRUCT_NAME);\*/
/*   }\*/
/*   else {\*/
/*printf(\*/
/*"unsigned %s::get_save_size()\n"\*/
/*,IM_STRUCT_NAME);\*/
/*   }\*/
/*printf(\*/
/*"{\n"\*/
/*);\*/
/*   if (!(TYPE_NUMBER & c_type_dynamic)) {\*/
/*printf(\*/
/*"   return sizeof(unsigned) + used*sizeof(%s);\n"\*/
/*,TYPE_NAME);\*/
/*   }\*/
/*   else {\*/
/*printf(\*/
/*"   unsigned ret_size = sizeof(unsigned);\n"\*/
/*"\n"\*/
/*"   if (used != 0) {\n"\*/
/*"      %s *ptr = data;\n"\*/
/*"      %s *ptr_end = ptr + used;\n"\*/
/*"      do {\n"\*/
/*"         ret_size += ptr->get_save_size();\n"\*/
/*"      } while(++ptr < ptr_end);\n"\*/
/*"   }\n"\*/
/*"\n"\*/
/*"   return ret_size;\n"\*/
/*,TYPE_NAME,TYPE_NAME);\*/
/*   }\*/
/*printf(\*/
/*"}\n"\*/
/*"\n"\*/
/*);\*/
/*}*/

#define ARRAY_SWAP() \
{\
printf(\
"inline void %s::swap(%s &second)\n"\
"{/*{{{*/\n"\
"   unsigned tmp_unsigned = size;\n"\
"   size = second.size;\n"\
"   second.size = tmp_unsigned;\n"\
"\n"\
"   tmp_unsigned = used;\n"\
"   used = second.used;\n"\
"   second.used = tmp_unsigned;\n"\
"\n"\
"   %s *tmp_data = data;\n"\
"   data = second.data;\n"\
"   second.data = tmp_data;\n"\
"}/*}}}*/\n"\
"\n"\
,IM_STRUCT_NAME,IM_STRUCT_NAME,TYPE_NAME);\
}

#define ARRAY_OPERATOR_LE_BR_RE_BR() \
{\
printf(\
"inline %s &%s::operator[](unsigned a_idx)\n"\
"{/*{{{*/\n"\
"   debug_assert(a_idx < used);\n"\
"   return data[a_idx];\n"\
"}/*}}}*/\n"\
"\n"\
,TYPE_NAME,IM_STRUCT_NAME);\
}

#define ARRAY_PUSH() \
{\
   if (TYPE_NUMBER & c_type_basic) {\
printf(\
"inline void %s::push(%s a_value)\n"\
,IM_STRUCT_NAME,TYPE_NAME);\
   }\
   else {\
printf(\
"inline void %s::push(%s &a_value)\n"\
,IM_STRUCT_NAME,TYPE_NAME);\
   }\
printf(\
"{/*{{{*/\n"\
"   if (used >= size) {\n"\
"      copy_resize((size << 1) + c_array_add);\n"\
"   }\n"\
"\n"\
"   data[used++] = a_value;\n"\
"}/*}}}*/\n"\
"\n"\
);\
}

#define ARRAY_PUSH_BLANK() \
{\
printf(\
"inline void %s::push_blank()\n"\
"{/*{{{*/\n"\
"   if (used >= size) {\n"\
"      copy_resize((size << 1) + c_array_add);\n"\
"   }\n"\
"\n"\
"   used++;\n"\
"}/*}}}*/\n"\
"\n"\
,IM_STRUCT_NAME);\
}

#define ARRAY_PUSH_BLANKS() \
{\
printf(\
"void %s::push_blanks(unsigned a_cnt)\n"\
"{/*{{{*/\n"\
"   unsigned desired_cnt = used + a_cnt;\n"\
"   if (desired_cnt > size) {\n"\
"      unsigned r_size = size;\n"\
"      do {\n"\
"         r_size = (r_size << 1) + c_array_add;\n"\
"      } while(r_size < desired_cnt);\n"\
"\n"\
"      copy_resize(r_size);\n"\
"   }\n"\
"\n"\
"   used += a_cnt;\n"\
"}/*}}}*/\n"\
"\n"\
,IM_STRUCT_NAME);\
}

#define ARRAY_PUSH_CLEAR() \
{\
printf(\
"inline void %s::push_clear()\n"\
"{/*{{{*/\n"\
"   if (used >= size) {\n"\
"      copy_resize((size << 1) + c_array_add);\n"\
"   }\n"\
"\n"\
,IM_STRUCT_NAME);\
   if (!(TYPE_NUMBER & c_type_dynamic)) {\
printf(\
"   used++;\n"\
);\
   }\
   else {\
printf(\
"   data[used++].clear();\n"\
);\
   }\
printf(\
"}/*}}}*/\n"\
"\n"\
);\
}

#define ARRAY_POP() \
{\
printf(\
"inline %s &%s::pop()\n"\
"{/*{{{*/\n"\
"   debug_assert(used > 0);\n"\
"   return data[--used];\n"\
"}/*}}}*/\n"\
"\n"\
,TYPE_NAME,IM_STRUCT_NAME);\
}

#define ARRAY_LAST() \
{\
printf(\
"inline %s &%s::last()\n"\
"{/*{{{*/\n"\
"   debug_assert(used > 0);\n"\
"   return data[used - 1];\n"\
"}/*}}}*/\n"\
"\n"\
,TYPE_NAME,IM_STRUCT_NAME);\
}

#define ARRAY_COPY_RESIZE() \
{\
printf(\
"void %s::copy_resize(unsigned a_size)\n"\
"{/*{{{*/\n"\
"   debug_assert(a_size >= used);\n"\
"\n"\
"   %s *n_data;\n"\
"\n"\
"   if (a_size == 0) {\n"\
"      n_data = NULL;\n"\
"   }\n"\
"   else {\n"\
"      n_data = (%s *)cmalloc(a_size*sizeof(%s));\n"\
,IM_STRUCT_NAME,TYPE_NAME,TYPE_NAME,TYPE_NAME);\
   if (TYPE_NUMBER & c_type_dynamic) {\
      if (TYPE_NUMBER & c_type_setting_strict_dynamic) {\
printf(\
"\n"\
"      %s *ptr = n_data;\n"\
"      %s *ptr_end = n_data + a_size;\n"\
"\n"\
"      do {\n"\
"         ptr->init();\n"\
"      } while(++ptr < ptr_end);\n"\
,TYPE_NAME,TYPE_NAME);\
      }\
      else {\
printf(\
"\n"\
"      if (a_size > used) {\n"\
"         %s *ptr = n_data + used;\n"\
"         %s *ptr_end = n_data + a_size;\n"\
"\n"\
"         do {\n"\
"            ptr->init();\n"\
"         } while(++ptr < ptr_end);\n"\
"      }\n"\
,TYPE_NAME,TYPE_NAME);\
      }\
   }\
printf(\
"   }\n"\
"\n"\
);\
   if (TYPE_NUMBER & c_type_setting_strict_dynamic) {\
printf(\
"   if (used > 0) {\n"\
"      %s *ptr = data;\n"\
"      %s *ptr_end = ptr + used;\n"\
"      %s *n_ptr = n_data;\n"\
"\n"\
"      do {\n"\
"         n_ptr->swap(*ptr);\n"\
"      } while(++n_ptr,++ptr < ptr_end);\n"\
"   }\n"\
,TYPE_NAME,TYPE_NAME,TYPE_NAME);\
   }\
   else {\
printf(\
"   if (used != 0) {\n"\
"      memcpy(n_data,data,used*sizeof(%s));\n"\
"   }\n"\
,TYPE_NAME);\
   }\
   if (TYPE_NUMBER & c_type_dynamic) {\
printf(\
"\n"\
"   if (size > used) {\n"\
"      %s *ptr = data + used;\n"\
"      %s *ptr_end = data + size;\n"\
"\n"\
"      do {\n"\
"	 ptr->clear();\n"\
"      } while(++ptr < ptr_end);\n"\
"   }\n"\
,TYPE_NAME,TYPE_NAME);\
   }\
printf(\
"\n"\
"   if (size != 0) {\n"\
"      cfree(data);\n"\
"   }\n"\
"\n"\
"   data = n_data;\n"\
"   size = a_size;\n"\
"}/*}}}*/\n"\
"\n"\
);\
}

#define ARRAY_FILL() \
{\
   if (type_idx == c_bt_char){\
printf(\
"inline void %s::fill(%s a_value)\n"\
,IM_STRUCT_NAME,TYPE_NAME);\
   }\
   else {\
      if (TYPE_NUMBER & c_type_basic) {\
printf(\
"void %s::fill(%s a_value)\n"\
,IM_STRUCT_NAME,TYPE_NAME);\
      }\
      else {\
printf(\
"void %s::fill(%s &a_value)\n"\
,IM_STRUCT_NAME,TYPE_NAME);\
      }\
   }\
printf(\
"{/*{{{*/\n"\
"   if (size == 0) return;\n"\
"\n"\
);\
   if (type_idx == c_bt_bool || type_idx == c_bt_char || type_idx == c_bt_unsigned_char) {\
printf(\
"   memset(data,a_value,size);\n"\
);\
   }\
   else {\
printf(\
"   %s *ptr = data;\n"\
"   %s *ptr_end = data + size;\n"\
"\n"\
"   do {\n"\
"      *ptr = a_value;\n"\
"   } while(++ptr < ptr_end);\n"\
,TYPE_NAME,TYPE_NAME);\
   }\
printf(\
"\n"\
"   used = size;\n"\
"}/*}}}*/\n"\
"\n"\
);\
}

#define ARRAY_GET_IDX() \
{\
   if (TYPE_NUMBER & c_type_basic) {\
printf(\
"unsigned %s::get_idx(%s a_value)\n"\
,IM_STRUCT_NAME,TYPE_NAME);\
   }\
   else {\
printf(\
"unsigned %s::get_idx(%s &a_value)\n"\
,IM_STRUCT_NAME,TYPE_NAME);\
   }\
printf(\
"{/*{{{*/\n"\
"   if (used == 0) return c_idx_not_exist;\n"\
"\n"\
"   %s *ptr = data;\n"\
"   %s *ptr_end = data + used;\n"\
"\n"\
"   do {\n"\
"      if (*ptr == a_value) {\n"\
"	 return ptr - data;\n"\
"      }\n"\
"   } while(++ptr < ptr_end);\n"\
"\n"\
"   return c_idx_not_exist;\n"\
"}/*}}}*/\n"\
"\n"\
,TYPE_NAME,TYPE_NAME);\
}

#define ARRAY_OPERATOR_EQUAL() \
{\
   if (!(TYPE_NUMBER & c_type_dynamic)) {\
printf(\
"inline %s &%s::operator=(%s &src)\n"\
,IM_STRUCT_NAME,IM_STRUCT_NAME,IM_STRUCT_NAME);\
   }\
   else {\
printf(\
"%s &%s::operator=(%s &src)\n"\
,IM_STRUCT_NAME,IM_STRUCT_NAME,IM_STRUCT_NAME);\
   }\
printf(\
"{/*{{{*/\n"\
"   clear();\n"\
"\n"\
"   if (src.used == 0) return *this;\n"\
"\n"\
"   copy_resize(src.used);\n"\
);\
   if (!(TYPE_NUMBER & c_type_dynamic)) {\
printf(\
"   memcpy(data,src.data,src.used*sizeof(%s));\n"\
,TYPE_NAME);\
   }\
   else {\
printf(\
"\n"\
"   %s *ptr = data;\n"\
"   %s *s_ptr = src.data;\n"\
"   %s *s_ptr_end = s_ptr + src.used;\n"\
"\n"\
"   do {\n"\
"      *ptr = *s_ptr;\n"\
"   } while(++ptr,++s_ptr < s_ptr_end);\n"\
,TYPE_NAME,TYPE_NAME,TYPE_NAME);\
   }\
printf(\
"\n"\
"   used = src.used;\n"\
"   return *this;\n"\
"}/*}}}*/\n"\
"\n"\
);\
}

#define ARRAY_OPERATOR_DOUBLE_EQUAL() \
{\
   if (!(TYPE_NUMBER & c_type_dynamic)) {\
printf(\
"inline bool %s::operator==(%s &second)\n"\
,IM_STRUCT_NAME,IM_STRUCT_NAME);\
   }\
   else {\
printf(\
"bool %s::operator==(%s &second)\n"\
,IM_STRUCT_NAME,IM_STRUCT_NAME);\
   }\
printf(\
"{/*{{{*/\n"\
"   if (used != second.used) return false;\n"\
"   if (used == 0) return true;\n"\
);\
   if (!(TYPE_NUMBER & c_type_dynamic)) {\
printf(\
"\n"\
"   return (memcmp(data,second.data,used*sizeof(%s)) == 0);\n"\
,TYPE_NAME);\
   }\
   else {\
printf(\
"\n"\
"   %s *ptr = data;\n"\
"   %s *ptr_end = ptr + used;\n"\
"   %s *s_ptr = second.data;\n"\
"\n"\
"   do {\n"\
"      if (!(*ptr == *s_ptr)) {\n"\
"	 return false;\n"\
"      }\n"\
"   } while(++s_ptr,++ptr < ptr_end);\n"\
"\n"\
"   return true;\n"\
,TYPE_NAME,TYPE_NAME,TYPE_NAME);\
   }\
printf(\
"}/*}}}*/\n"\
"\n"\
);\
}

void processor_s::generate_array_type(string_arrays_s &params,unsigned type_settings)
{
   string_array_s &type_names = params[c_param_types];
   string_array_s &fun_defs = params[c_param_functions];
   string_array_s &abbs = params[c_param_names];

   if (type_names.used != 1) {
      fprintf(stderr,"array: not given name (or too many names) of contained type\n");
      assert(0);
   }

   if (abbs.used < 1) {
      fprintf(stderr,"array: not given name of generated structure\n");
      assert(0);
   }

   unsigned type_abb_idx = abbreviations.get_idx_by_string(type_names[0].size - 1,type_names[0].data);
   if (type_abb_idx == c_idx_not_exist) {
      fprintf(stderr,"array: contained type \"%s\" does not exist\n",type_names[0].data);
      assert(0);
   }

   unsigned type_idx = abbreviations[type_abb_idx].number;
   data_type_s &type = data_types[type_idx];

   // - test type options -
   if (type.number & c_type_setting_strict_dynamic) {
      assert(type.number & c_type_dynamic);
   }

   string_s real_name;
   real_name.init();
   real_name.conc_set(type.string.size - 1,type.string.data,strlen(c_cont_postfixes[c_cont_array]),(char *)c_cont_postfixes[c_cont_array]);

   string_s &data_type_name = abbs[0];

   unsigned data_type_idx;

   if ((data_type_idx = abbreviations.get_idx_by_string(data_type_name.size - 1,data_type_name.data)) == c_idx_not_exist) {
      //abbreviations.push_blank();
      //abbreviations.last().set(data_type_name,data_types.used);

      unsigned d_idx = data_types.get_idx_by_real_name(real_name.size - 1,real_name.data);
      if (d_idx != c_idx_not_exist) {
         fprintf(stderr,"DUPLICATE STRUCTURES: %s <-> %s\n",data_type_name.data,data_types[d_idx].string.data);
      }

      data_types.push_blank();
      data_type_s &data_type = data_types.last();

      data_type.cont_idx = c_cont_array;
      data_type.string.set(data_type_name.size - 1,data_type_name.data);
      data_type.real_name.swap(real_name);

      data_type.number = c_type_dynamic | c_type_flushable | (type_settings & c_type_setting_mask);

      data_type.types.push(abbreviations[type_abb_idx].string);

      data_type_idx = data_types.used - 1;
   }
   else {
      //data_type_idx = abbreviations[data_type_idx].number;
      fprintf(stderr,"array: name of generated structure \"%s\" is already used\n",data_type_name.data);
      assert(0);
   }

   real_name.clear();

   // zkontrolovani a zapsani zkratek
   if (abbs.used != 0) {
      unsigned idx = 0;
      do {
	 string_s &abb = abbs[idx];

         if (abbreviations.get_idx_by_string(abb.size - 1,abb.data) != c_idx_not_exist) {
            fprintf(stderr,"array: abreviated name \"%s\" for generated structure is already used\n",abb.data);
            assert(0);
         }

	 abbreviations.push_blank();
	 abbreviations.last().set(abb,data_type_idx);
      } while(++idx < abbs.used);
   }

   data_type_s &data_type = data_types[data_type_idx];

   // - --- definice struktury array --- -

printf(
"// --- struct %s definition --- \n"
"\n"
,STRUCT_NAME);

   if (abbs.used > 1) {
      unsigned idx = 1;
      do {
printf(
"typedef struct %s %s;\n"
,abbs[0].data,abbs[idx].data);
      } while(++idx < abbs.used);
printf(
"\n"
);
   }

printf(
"/*!\n"
" * \\brief __GEN array container of type %s\n"
" */\n"
"struct %s\n"
"{\n"
"   unsigned size; //!< actual size of allocated space in array\n"
"   unsigned used; //!< count of used space in array\n"
"   %s *data; //!< pointer to array elements\n"
"\n"
,TYPE_NAME,STRUCT_NAME,TYPE_NAME);
   if (!(data_type.number & c_type_setting_not_generate_init)) {
printf(
"   /*!\n"
"    * \\brief __GEN initialization of array structure\n"
"    */\n"
"   inline void init();\n"
"\n"
);
   }
printf(
"   /*!\n"
"    * \\brief __GEN initialization of array structure of desired size\n"
"    * \\param a_size - desired size of array\n"
"    */\n"
"   inline void init_size(unsigned a_size);\n"
"\n"
);
   if (!(TYPE_NUMBER & c_type_dynamic)) {
      if (!(data_type.number & c_type_setting_not_generate_clear)) {
printf(
"   /*!\n"
"    * \\brief __GEN release of allocated memory\n"
"    */\n"
"   inline void clear();\n"
"\n"
);
      }
printf(
"   /*!\n"
"    * \\brief __GEN creation of array based on pointer and element count\n"
"    * \\param a_used - number of elements stored at location denoted by pointer\n"
"    * \\param a_data - pointer to elements\n"
"    */\n"
"   inline void set(unsigned a_used,%s *a_data);\n"
"\n"
,TYPE_NAME);
   }
   else {
      if (!(data_type.number & c_type_setting_not_generate_clear)) {
printf(
"   /*!\n"
"    * \\brief __GEN release of allocated memory\n"
"    */\n"
"   void clear();\n"
"\n"
);
      }
printf(
"   /*!\n"
"    * \\brief __GEN creation of array based on pointer and element count\n"
"    * \\param a_used - number of elements stored at location denoted by pointer\n"
"    * \\param a_data - pointer to elements\n"
"    */\n"
"   void set(unsigned a_used,%s *a_data);\n"
"\n"
,TYPE_NAME);
   }
printf(
"   /*!\n"
"    * \\brief __GEN flush to minimal memory usage of array\n"
"    */\n"
"   inline void flush();\n"
"\n"
);
   if (!(TYPE_NUMBER & c_type_flushable)) {
printf(
"   /*!\n"
"    * \\brief __GEN flush to minimal memory usage of array and its elements\n"
"    */\n"
"   inline void flush_all();\n"
"\n"
);
   }
   else {
printf(
"   /*!\n"
"    * \\brief __GEN flush to minimal memory usage of array and its elements\n"
"    */\n"
"   void flush_all();\n"
"\n"
);
   }
   if (!(TYPE_NUMBER & c_type_dynamic)) {
printf(
"   /*!\n"
"    * \\brief __GEN compute size of memory needed to save data\n"
"    * \\return size of memory\n"
"    */\n"
"   inline unsigned get_save_size();\n"
"\n"
);
   }
   else {
printf(
"   /*!\n"
"    * \\brief __GEN compute size of memory needed to save data\n"
"    * \\return size of memory\n"
"    */\n"
"   unsigned get_save_size();\n"
"\n"
);
   }
   if (!(data_type.number & c_type_setting_not_generate_swap)) {
printf(
"   /*!\n"
"    * \\brief __GEN swap array members with another array\n"
"    * \\param second - reference to another array\n"
"    */\n"
"   inline void swap(%s &second);\n"
"\n"
,STRUCT_NAME);
   }
printf(
"   /*!\n"
"    * \\brief __GEN selection of element of array\n"
"    * \\param a_idx - index of element in array\n"
"    * \\return reference to element of array\n"
"    */\n"
"   inline %s &operator[](unsigned a_idx);\n"
"\n"
,TYPE_NAME);
   if (TYPE_NUMBER & c_type_basic) {
printf(
"   /*!\n"
"    * \\brief __GEN insert element array (stack) end\n"
"    * \\param a_value - value of inserted element\n"
"    */\n"
"   inline void push(%s a_value);\n"
"\n"
,TYPE_NAME);
   }
   else {
printf(
"   /*!\n"
"    * \\brief __GEN insert element array (stack) end\n"
"    * \\param a_value - reference to inserted value\n"
"    */\n"
"   inline void push(%s &a_value);\n"
"\n"
,TYPE_NAME);
   }
printf(
"   /*!\n"
"    * \\brief __GEN insert blank element to end of array\n"
"    */\n"
"   inline void push_blank();\n"
"\n"
"   /*!\n"
"    * \\brief __GEN insert blank elements to end of array\n"
"    * \\param a_cnt - count of elements inserted to array\n"
"    */\n"
"   void push_blanks(unsigned a_cnt);\n"
"\n"
"   /*!\n"
"    * \\brief __GEN insert and clear element to end of array\n"
"    */\n"
"   inline void push_clear();\n"
"\n"
"   /*!\n"
"    * \\brief __GEN selection of last element from array, and its removal\n"
"    */\n"
"   inline %s &pop();\n"
"\n"
"   /*!\n"
"    * \\brief __GEN selection of last element from array\n"
"    */\n"
"   inline %s &last();\n"
"\n"
"   /*!\n"
"    * \\brief __GEN resizing of array\n"
"    * \\param a_size - new size of array (must be greater or equal to used)\n"
"    */\n"
"   void copy_resize(unsigned a_size);\n"
"\n"
,TYPE_NAME,TYPE_NAME);
   if (type_idx == c_bt_char) {
printf(
"   /*!\n"
"    * \\brief __GEN setting of all element of array to given value\n"
"    * \\param a_value - target value of all elements\n"
"    */\n"
"   inline void fill(%s a_value);\n"
"\n"
,TYPE_NAME);
   }
   else {
      if (TYPE_NUMBER & c_type_basic) {
printf(
"   /*!\n"
"    * \\brief __GEN setting of all element of array to given value\n"
"    * \\param a_value - target value of all elements\n"
"    */\n"
"   void fill(%s a_value);\n"
"\n"
,TYPE_NAME);
      }
      else {
printf(
"   /*!\n"
"    * \\brief __GEN setting of all element of array to given value\n"
"    * \\param a_value - reference to target value of all elements\n"
"    */\n"
"   void fill(%s &a_value);\n"
"\n"
,TYPE_NAME);
      }
   }
   if (TYPE_NUMBER & c_type_basic) {
printf(
"   /*!\n"
"    * \\brief __GEN search for index of element\n"
"    * \\param a_value - value which index is searched\n"
"    */\n"
"   unsigned get_idx(%s a_value);\n"
"\n"
,TYPE_NAME);
   }
   else {
printf(
"   /*!\n"
"    * \\brief __GEN search for index of element\n"
"    * \\param a_value - value which index is searched\n"
"    */\n"
"   unsigned get_idx(%s &a_value);\n"
"\n"
,TYPE_NAME);
   }
   if (!(TYPE_NUMBER & c_type_dynamic)) {
      if (!(data_type.number & c_type_setting_not_generate_operator_equal)) {
printf(
"   /*!\n"
"    * \\brief __GEN copy of array to this array\n"
"    * \\param src - reference to source array\n"
"    * \\return reference to this array\n"
"    */\n"
"   inline %s &operator=(%s &src);\n"
"\n"
,STRUCT_NAME,STRUCT_NAME);
      }
printf(
"   /*!\n"
"    * \\brief __GEN comparison of array with another array\n"
"    * \\param second - reference to another array\n"
"    * \\return result of comparison\n"
"    */\n"
"   inline bool operator==(%s &second);\n"
"\n"
,STRUCT_NAME);
   }
   else {
      if (!(data_type.number & c_type_setting_not_generate_operator_equal)) {
printf(
"   /*!\n"
"    * \\brief __GEN copy of array to this array\n"
"    * \\param src - reference to source array\n"
"    */\n"
"   %s &operator=(%s &src);\n"
"\n"
,STRUCT_NAME,STRUCT_NAME);
      }
printf(
"   /*!\n"
"    * \\brief __GEN comparison of array with another array\n"
"    * \\param second - reference to another array\n"
"    */\n"
"   bool operator==(%s &second);\n"
"\n"
,STRUCT_NAME);
   }
   if (fun_defs.used != 0) {
      unsigned f_idx = 0;
      do {
printf(
"   %s\n"
,fun_defs[f_idx].data);
      } while(++f_idx < fun_defs.used);
   }
printf(
"};\n"
"\n"
);
};

void processor_s::generate_array_inlines(unsigned abb_idx,unsigned a_dt_idx)
{
   data_type_s &data_type = data_types[a_dt_idx];
   
   string_s &type_abb_string = data_type.types[0];
   unsigned type_abb_idx = abbreviations.get_idx_by_string(type_abb_string.size - 1,type_abb_string.data);

   if (type_abb_idx == c_idx_not_exist) {
      fprintf(stderr,"array: inlines: abbreviated type name \"%s\" does not exist\n",type_abb_string.data);
      assert(0);
   }

   unsigned type_idx = abbreviations[type_abb_idx].number;
   data_type_s &type = data_types[type_idx];

   // --- definice inline funkci ---

printf(
"// --- struct %s inline method definition ---\n"
"\n"
,IM_STRUCT_NAME);

   // - array init method -
   if (!(data_type.number & c_type_setting_not_generate_init)) {
ARRAY_INIT();
   }

   // - array init_size method -
ARRAY_INIT_SIZE();

   // - array clear method -
   if (!(TYPE_NUMBER & c_type_dynamic)) {
      if (!(data_type.number & c_type_setting_not_generate_clear)) {
ARRAY_CLEAR();
      }
   }

   // - array set method -
   if (!(TYPE_NUMBER & c_type_dynamic)) {
ARRAY_SET();
   }

   // - array_flush_method -
ARRAY_FLUSH();

   // - array flush_all method -
   if (!(TYPE_NUMBER & c_type_flushable)) {
ARRAY_FLUSH_ALL();
   }

   // - array get_save_size method -
//   if (!(TYPE_NUMBER & c_type_dynamic)) {
//ARRAY_GET_SAVE_SIZE();
//   }

   // - array swap method -
   if (!(data_type.number & c_type_setting_not_generate_swap)) {
ARRAY_SWAP();
   }

   // - array operator[] method -
ARRAY_OPERATOR_LE_BR_RE_BR();

   // - array push method -
ARRAY_PUSH();

   // - array push_blank method -
ARRAY_PUSH_BLANK();

   // - array push_blanks method -

   // - array push_clear method -
ARRAY_PUSH_CLEAR();

   // - array pop method -
ARRAY_POP();

   // - array last method -
ARRAY_LAST();

   // - array copy_resize method -

   // - array fill method -
   if (type_idx == c_bt_char) {
ARRAY_FILL();   
   }

   // - array get_idx method -

   // - array get_pc_idx -

   // - array operator= method -
   if (!(TYPE_NUMBER & c_type_dynamic)) {
      if (!(data_type.number & c_type_setting_not_generate_operator_equal)) {
ARRAY_OPERATOR_EQUAL();
      }
   }

   // - array operator== method -
   if (!(TYPE_NUMBER & c_type_dynamic)) {
ARRAY_OPERATOR_DOUBLE_EQUAL();
   }
}

void processor_s::generate_array_methods(unsigned abb_idx,unsigned a_dt_idx)
{
   data_type_s &data_type = data_types[a_dt_idx];
   
   string_s &type_abb_string = data_type.types[0];
   unsigned type_abb_idx = abbreviations.get_idx_by_string(type_abb_string.size - 1,type_abb_string.data);
   
   if (type_abb_idx == c_idx_not_exist) {
      fprintf(stderr,"array: methods: abreviated type name \"%s\" does not exist\n",type_abb_string.data);
      assert(0);
   }

   unsigned type_idx = abbreviations[type_abb_idx].number;
   data_type_s &type = data_types[type_idx];

   // --- definice funkci ---

printf(
"// --- struct %s method definition ---\n"
"\n"
,IM_STRUCT_NAME);

   // - array init method -

   // - array init_size method -

   // - array clear method -
   if (TYPE_NUMBER & c_type_dynamic) {
      if (!(data_type.number & c_type_setting_not_generate_clear)) {
ARRAY_CLEAR();
      }
   }

   // - array set method -
   if (TYPE_NUMBER & c_type_dynamic) {
ARRAY_SET();
   }

   // - array_flush_method -

   // - array flush_all method -
   if (TYPE_NUMBER & c_type_flushable) {
ARRAY_FLUSH_ALL();
   }

   // - array get_save_size method -
//   if (TYPE_NUMBER & c_type_dynamic) {
//ARRAY_GET_SAVE_SIZE();
//   }

   // - array swap method -

   // - array operator[] method -

   // - array push method -

   // - array push_blank method -

   // - array push_blanks method -
ARRAY_PUSH_BLANKS();

   // - array push_clear method -

   // - array pop method -

   // - array last method -

   // - array copy_resize method -
ARRAY_COPY_RESIZE();

   // - array fill method -
   if (type_idx != c_bt_char) {
ARRAY_FILL();   
   }

   // - array get_idx method -
ARRAY_GET_IDX();

   // - array operator= method -
   if (TYPE_NUMBER & c_type_dynamic) {
      if (!(data_type.number & c_type_setting_not_generate_operator_equal)) {
ARRAY_OPERATOR_EQUAL();
      }
   }

   // - array operator== method -
   if (TYPE_NUMBER & c_type_dynamic) {
ARRAY_OPERATOR_DOUBLE_EQUAL();
   }
}

