
/*
 * author Jiří Zuzaňák
 * institution BUT FIT UPGM
 */

/*
 * identifikace operaci prirazenych k redukcim
 */

enum {
   c_reduce_null_0 = 0,
   c_reduce_null_1,
   c_reduce_null_2,
   c_reduce_header,
   c_reduce_include,
   c_reduce_inlines,
   c_reduce_methods,
   c_reduce_define,
   c_reduce_null_3,
   c_reduce_null_4,
   c_reduce_mod_basic,
   c_reduce_mod_static,
   c_reduce_mod_dynamic,
   c_reduce_mod_flushable,
   c_reduce_gen_container,
   c_reduce_null_5,
   c_reduce_null_6,
   c_reduce_null_7,
   c_reduce_null_8,
   c_reduce_null_9,
   c_reduce_type,
   c_reduce_type_and_name,
   c_reduce_null_10,
   c_reduce_null_11,
   c_reduce_null_12,
   c_reduce_not_generate_init,
   c_reduce_not_generate_clear,
   c_reduce_not_generate_swap,
   c_reduce_not_generate_operator_equal,
   c_reduce_null_13,
   c_reduce_null_14,
   c_reduce_null_15,
   c_reduce_option_strict_dynamic,
   c_reduce_additions_body,
   c_reduce_name,
};

/*
 * rozkladove konstanty
 */

const unsigned short c_escape_char = 256;
const unsigned c_rule_cnt = 35;
const unsigned rule_head_idxs[c_rule_cnt] = {29, 30, 30, 31, 31, 31, 31, 31, 32, 32, 33, 33, 33, 33, 31, 34, 34, 35, 36, 36, 37, 37, 35, 38, 38, 39, 39, 39, 39, 35, 40, 40, 41, 35, 35, };
const unsigned rule_body_lengths[c_rule_cnt] = {4, 2, 1, 2, 2, 2, 2, 3, 2, 1, 1, 1, 1, 1, 3, 2, 1, 3, 2, 1, 1, 3, 2, 2, 1, 1, 1, 1, 1, 2, 2, 1, 1, 2, 1, };

/*
 * rozkladova tabulka
 */

#define blank c_idx_not_exist
#define SHIFT(VALUE) VALUE
#define REDUCE(VALUE) c_lalr_table_reduce_base + VALUE
#define GOTO(VALUE) VALUE

const unsigned c_lalr_table_reduce_base = 0x80000000;
const unsigned c_terminal_plus_nonterminal_cnt = 42;
const unsigned lalr_state_cnt = 53;

const unsigned lalr_table[lalr_state_cnt*c_terminal_plus_nonterminal_cnt] = {
    SHIFT(1),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,    SHIFT(4),    SHIFT(5),    SHIFT(6),    SHIFT(7),       blank,    SHIFT(8),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    SHIFT(9),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,     GOTO(2),     GOTO(3),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,   SHIFT(11),    SHIFT(4),    SHIFT(5),    SHIFT(6),    SHIFT(7),       blank,    SHIFT(8),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    SHIFT(9),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    GOTO(10),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,   REDUCE(2),   REDUCE(2),   REDUCE(2),   REDUCE(2),   REDUCE(2),       blank,   REDUCE(2),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   REDUCE(2),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(12),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(13),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(14),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(15),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(16),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(22),       blank,       blank,       blank,       blank,       blank,   SHIFT(20),       blank,       blank,       blank,       blank,   SHIFT(21),       blank,       blank,       blank,   SHIFT(23),   SHIFT(19),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    GOTO(17),    GOTO(18),       blank,       blank,       blank,       blank,       blank,       blank,
       blank,   REDUCE(1),   REDUCE(1),   REDUCE(1),   REDUCE(1),   REDUCE(1),       blank,   REDUCE(1),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   REDUCE(1),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(24),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,   REDUCE(3),   REDUCE(3),   REDUCE(3),   REDUCE(3),   REDUCE(3),       blank,   REDUCE(3),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   REDUCE(3),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,   REDUCE(4),   REDUCE(4),   REDUCE(4),   REDUCE(4),   REDUCE(4),       blank,   REDUCE(4),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   REDUCE(4),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,   REDUCE(5),   REDUCE(5),   REDUCE(5),   REDUCE(5),   REDUCE(5),       blank,   REDUCE(5),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   REDUCE(5),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,   REDUCE(6),   REDUCE(6),   REDUCE(6),   REDUCE(6),   REDUCE(6),       blank,   REDUCE(6),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   REDUCE(6),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(27),   SHIFT(28),   SHIFT(29),   SHIFT(30),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    GOTO(25),    GOTO(26),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(22),       blank,       blank,       blank,       blank,       blank,   SHIFT(20),       blank,       blank,       blank,       blank,   SHIFT(21),       blank,       blank,       blank,   SHIFT(23),   SHIFT(19),       blank,       blank,   SHIFT(32),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    GOTO(31),       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(16),       blank,       blank,       blank,       blank,       blank,  REDUCE(16),       blank,       blank,       blank,       blank,  REDUCE(16),       blank,       blank,       blank,  REDUCE(16),  REDUCE(16),       blank,       blank,  REDUCE(16),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(35),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    GOTO(33),    GOTO(34),       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(38),   SHIFT(39),   SHIFT(40),   SHIFT(41),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    GOTO(36),    GOTO(37),       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(44),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    GOTO(42),    GOTO(43),
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(45),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(34),       blank,       blank,       blank,       blank,       blank,  REDUCE(34),       blank,       blank,       blank,       blank,  REDUCE(34),       blank,       blank,       blank,  REDUCE(34),  REDUCE(34),       blank,       blank,  REDUCE(34),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,   REDUCE(7),   REDUCE(7),   REDUCE(7),   REDUCE(7),   REDUCE(7),       blank,   REDUCE(7),   SHIFT(27),   SHIFT(28),   SHIFT(29),   SHIFT(30),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   REDUCE(7),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    GOTO(46),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,   REDUCE(9),   REDUCE(9),   REDUCE(9),   REDUCE(9),   REDUCE(9),       blank,   REDUCE(9),   REDUCE(9),   REDUCE(9),   REDUCE(9),   REDUCE(9),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   REDUCE(9),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,  REDUCE(10),  REDUCE(10),  REDUCE(10),  REDUCE(10),  REDUCE(10),       blank,  REDUCE(10),  REDUCE(10),  REDUCE(10),  REDUCE(10),  REDUCE(10),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(10),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,  REDUCE(11),  REDUCE(11),  REDUCE(11),  REDUCE(11),  REDUCE(11),       blank,  REDUCE(11),  REDUCE(11),  REDUCE(11),  REDUCE(11),  REDUCE(11),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(11),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,  REDUCE(12),  REDUCE(12),  REDUCE(12),  REDUCE(12),  REDUCE(12),       blank,  REDUCE(12),  REDUCE(12),  REDUCE(12),  REDUCE(12),  REDUCE(12),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(12),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,  REDUCE(13),  REDUCE(13),  REDUCE(13),  REDUCE(13),  REDUCE(13),       blank,  REDUCE(13),  REDUCE(13),  REDUCE(13),  REDUCE(13),  REDUCE(13),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(13),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(15),       blank,       blank,       blank,       blank,       blank,  REDUCE(15),       blank,       blank,       blank,       blank,  REDUCE(15),       blank,       blank,       blank,  REDUCE(15),  REDUCE(15),       blank,       blank,  REDUCE(15),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,  REDUCE(14),  REDUCE(14),  REDUCE(14),  REDUCE(14),  REDUCE(14),       blank,  REDUCE(14),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(14),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(35),       blank,   SHIFT(48),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    GOTO(47),       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(19),       blank,  REDUCE(19),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(20),       blank,  REDUCE(20),   SHIFT(49),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(22),       blank,       blank,       blank,       blank,       blank,  REDUCE(22),   SHIFT(38),   SHIFT(39),   SHIFT(40),   SHIFT(41),  REDUCE(22),       blank,       blank,       blank,  REDUCE(22),  REDUCE(22),       blank,       blank,  REDUCE(22),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    GOTO(50),       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(24),       blank,       blank,       blank,       blank,       blank,  REDUCE(24),  REDUCE(24),  REDUCE(24),  REDUCE(24),  REDUCE(24),  REDUCE(24),       blank,       blank,       blank,  REDUCE(24),  REDUCE(24),       blank,       blank,  REDUCE(24),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(25),       blank,       blank,       blank,       blank,       blank,  REDUCE(25),  REDUCE(25),  REDUCE(25),  REDUCE(25),  REDUCE(25),  REDUCE(25),       blank,       blank,       blank,  REDUCE(25),  REDUCE(25),       blank,       blank,  REDUCE(25),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(26),       blank,       blank,       blank,       blank,       blank,  REDUCE(26),  REDUCE(26),  REDUCE(26),  REDUCE(26),  REDUCE(26),  REDUCE(26),       blank,       blank,       blank,  REDUCE(26),  REDUCE(26),       blank,       blank,  REDUCE(26),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(27),       blank,       blank,       blank,       blank,       blank,  REDUCE(27),  REDUCE(27),  REDUCE(27),  REDUCE(27),  REDUCE(27),  REDUCE(27),       blank,       blank,       blank,  REDUCE(27),  REDUCE(27),       blank,       blank,  REDUCE(27),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(28),       blank,       blank,       blank,       blank,       blank,  REDUCE(28),  REDUCE(28),  REDUCE(28),  REDUCE(28),  REDUCE(28),  REDUCE(28),       blank,       blank,       blank,  REDUCE(28),  REDUCE(28),       blank,       blank,  REDUCE(28),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(29),       blank,       blank,       blank,       blank,       blank,  REDUCE(29),       blank,       blank,       blank,       blank,  REDUCE(29),   SHIFT(44),       blank,       blank,  REDUCE(29),  REDUCE(29),       blank,       blank,  REDUCE(29),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,    GOTO(51),
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(31),       blank,       blank,       blank,       blank,       blank,  REDUCE(31),       blank,       blank,       blank,       blank,  REDUCE(31),  REDUCE(31),       blank,       blank,  REDUCE(31),  REDUCE(31),       blank,       blank,  REDUCE(31),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(32),       blank,       blank,       blank,       blank,       blank,  REDUCE(32),       blank,       blank,       blank,       blank,  REDUCE(32),  REDUCE(32),       blank,       blank,  REDUCE(32),  REDUCE(32),       blank,       blank,  REDUCE(32),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(33),       blank,       blank,       blank,       blank,       blank,  REDUCE(33),       blank,       blank,       blank,       blank,  REDUCE(33),       blank,       blank,       blank,  REDUCE(33),  REDUCE(33),       blank,       blank,  REDUCE(33),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,   REDUCE(8),   REDUCE(8),   REDUCE(8),   REDUCE(8),   REDUCE(8),       blank,   REDUCE(8),   REDUCE(8),   REDUCE(8),   REDUCE(8),   REDUCE(8),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   REDUCE(8),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(18),       blank,  REDUCE(18),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(17),       blank,       blank,       blank,       blank,       blank,  REDUCE(17),       blank,       blank,       blank,       blank,  REDUCE(17),       blank,       blank,       blank,  REDUCE(17),  REDUCE(17),       blank,       blank,  REDUCE(17),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,   SHIFT(52),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(23),       blank,       blank,       blank,       blank,       blank,  REDUCE(23),  REDUCE(23),  REDUCE(23),  REDUCE(23),  REDUCE(23),  REDUCE(23),       blank,       blank,       blank,  REDUCE(23),  REDUCE(23),       blank,       blank,  REDUCE(23),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(30),       blank,       blank,       blank,       blank,       blank,  REDUCE(30),       blank,       blank,       blank,       blank,  REDUCE(30),  REDUCE(30),       blank,       blank,  REDUCE(30),  REDUCE(30),       blank,       blank,  REDUCE(30),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,  REDUCE(21),       blank,  REDUCE(21),       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,       blank,
};

/*
 * funkce struktury lalr_stack_s
 */

inline void lalr_stack_s::push(unsigned a_first_num)
{
   if (used >= size) {
      copy_resize(size + c_array_add);
   }

   lalr_stack_element_s &target = data[used++];

   target.first_num = a_first_num;
}

inline void lalr_stack_s::push(unsigned a_first_num,unsigned a_second_num,unsigned a_third_num)
{
   if (used >= size) {
      copy_resize(size + c_array_add);
   }

   lalr_stack_element_s &target = data[used++];

   target.first_num = a_first_num;
   target.second_num = a_second_num;
   target.third_num = a_third_num;
}

/*
 * funkce struktury process_s
 */

unsigned process_s::final_automata_recognize(string_s &source_string,unsigned &input_idx,unsigned &line_cnt)
{
   unsigned source_string_length = source_string.size - 1;

#define GET_NEXT_CHAR() \
{\
   if (input_idx < source_string_length) {\
      in_char = (unsigned char)source_string[input_idx];\
   }\
   else {\
      in_char = '\0';\
   }\
}

#define CLOSE_CHAR(RET_TERM_IDX) \
{\
   if (in_char == '\0') {\
      return RET_TERM_IDX;\
   }\
\
   input_idx++;\
}

   unsigned short in_char;

// - STAV 0 - 
   GET_NEXT_CHAR();

   if (in_char == 0)
      goto state_1_label;

   if (in_char >= 9 && in_char < 11)
      goto state_22_label;

   if (in_char == 32)
      goto state_22_label;

   if (in_char == 34)
      goto state_2_label;

   if (in_char == 36)
      goto state_3_label;

   if (in_char == 58)
      goto state_4_label;

   if (in_char == 59)
      goto state_5_label;

   if (in_char == 60)
      goto state_6_label;

   if (in_char == 62)
      goto state_7_label;

   if (in_char == 64)
      goto state_8_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char == 97)
      goto state_10_label;

   if (in_char == 98)
      goto state_11_label;

   if (in_char == 99)
      goto state_12_label;

   if (in_char == 100)
      goto state_13_label;

   if (in_char == 101)
      goto state_9_label;

   if (in_char == 102)
      goto state_14_label;

   if (in_char == 103)
      goto state_9_label;

   if (in_char == 104)
      goto state_15_label;

   if (in_char == 105)
      goto state_16_label;

   if (in_char >= 106 && in_char < 109)
      goto state_9_label;

   if (in_char == 109)
      goto state_17_label;

   if (in_char == 110)
      goto state_18_label;

   if (in_char == 111)
      goto state_19_label;

   if (in_char >= 112 && in_char < 115)
      goto state_9_label;

   if (in_char == 115)
      goto state_20_label;

   if (in_char >= 116 && in_char < 123)
      goto state_9_label;

   if (in_char == 123)
      goto state_21_label;

   return c_idx_not_exist;

// - STAV 1 - 
state_1_label:
   CLOSE_CHAR(28)
   return 28;

// - STAV 2 - 
state_2_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 34)
      goto state_2_label;

   if (in_char == 34)
      goto state_23_label;

   if (in_char >= 35 && in_char < 257)
      goto state_2_label;

   return c_idx_not_exist;

// - STAV 3 - 
state_3_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 10)
      goto state_3_label;

   if (in_char == 10)
      goto state_24_label;

   if (in_char >= 11 && in_char < 257)
      goto state_3_label;

   return c_idx_not_exist;

// - STAV 4 - 
state_4_label:
   CLOSE_CHAR(24)
   return 24;

// - STAV 5 - 
state_5_label:
   CLOSE_CHAR(25)
   return 25;

// - STAV 6 - 
state_6_label:
   CLOSE_CHAR(22)
   return 22;

// - STAV 7 - 
state_7_label:
   CLOSE_CHAR(23)
   return 23;

// - STAV 8 - 
state_8_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 98)
      goto state_25_label;

   if (in_char == 101)
      goto state_26_label;

   return c_idx_not_exist;

// - STAV 9 - 
state_9_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 10 - 
state_10_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 100)
      goto state_9_label;

   if (in_char == 100)
      goto state_27_label;

   if (in_char >= 101 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 11 - 
state_11_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char == 97)
      goto state_28_label;

   if (in_char >= 98 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 12 - 
state_12_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 108)
      goto state_9_label;

   if (in_char == 108)
      goto state_29_label;

   if (in_char >= 109 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 13 - 
state_13_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_30_label;

   if (in_char >= 102 && in_char < 121)
      goto state_9_label;

   if (in_char == 121)
      goto state_31_label;

   if (in_char == 122)
      goto state_9_label;

   return 21;

// - STAV 14 - 
state_14_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 108)
      goto state_9_label;

   if (in_char == 108)
      goto state_32_label;

   if (in_char >= 109 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 15 - 
state_15_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_33_label;

   if (in_char >= 102 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 16 - 
state_16_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 110)
      goto state_9_label;

   if (in_char == 110)
      goto state_34_label;

   if (in_char >= 111 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 17 - 
state_17_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_35_label;

   if (in_char >= 102 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 18 - 
state_18_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 111)
      goto state_9_label;

   if (in_char == 111)
      goto state_36_label;

   if (in_char >= 112 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 19 - 
state_19_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 112)
      goto state_9_label;

   if (in_char == 112)
      goto state_37_label;

   if (in_char >= 113 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 20 - 
state_20_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 116)
      goto state_9_label;

   if (in_char == 116)
      goto state_38_label;

   if (in_char >= 117 && in_char < 119)
      goto state_9_label;

   if (in_char == 119)
      goto state_39_label;

   if (in_char >= 120 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 21 - 
state_21_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char < 125)
      goto state_21_label;

   if (in_char == 125)
      goto state_40_label;

   if (in_char >= 126 && in_char < 257)
      goto state_21_label;

   return c_idx_not_exist;

// - STAV 22 - 
state_22_label:
   CLOSE_CHAR(26)
   GET_NEXT_CHAR();

   if (in_char >= 9 && in_char < 11)
      goto state_22_label;

   if (in_char == 32)
      goto state_22_label;

   return 26;

// - STAV 23 - 
state_23_label:
   CLOSE_CHAR(19)
   return 19;

// - STAV 24 - 
state_24_label:
   CLOSE_CHAR(27)
   return 27;

// - STAV 25 - 
state_25_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 101)
      goto state_41_label;

   return c_idx_not_exist;

// - STAV 26 - 
state_26_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 110)
      goto state_42_label;

   return c_idx_not_exist;

// - STAV 27 - 
state_27_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 100)
      goto state_9_label;

   if (in_char == 100)
      goto state_43_label;

   if (in_char >= 101 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 28 - 
state_28_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 115)
      goto state_9_label;

   if (in_char == 115)
      goto state_44_label;

   if (in_char >= 116 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 29 - 
state_29_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_45_label;

   if (in_char >= 102 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 30 - 
state_30_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 102)
      goto state_9_label;

   if (in_char == 102)
      goto state_46_label;

   if (in_char >= 103 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 31 - 
state_31_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 110)
      goto state_9_label;

   if (in_char == 110)
      goto state_47_label;

   if (in_char >= 111 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 32 - 
state_32_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 117)
      goto state_9_label;

   if (in_char == 117)
      goto state_48_label;

   if (in_char >= 118 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 33 - 
state_33_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char == 97)
      goto state_49_label;

   if (in_char >= 98 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 34 - 
state_34_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 99)
      goto state_9_label;

   if (in_char == 99)
      goto state_50_label;

   if (in_char >= 100 && in_char < 105)
      goto state_9_label;

   if (in_char == 105)
      goto state_51_label;

   if (in_char >= 106 && in_char < 108)
      goto state_9_label;

   if (in_char == 108)
      goto state_52_label;

   if (in_char >= 109 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 35 - 
state_35_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 116)
      goto state_9_label;

   if (in_char == 116)
      goto state_53_label;

   if (in_char >= 117 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 36 - 
state_36_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 116)
      goto state_9_label;

   if (in_char == 116)
      goto state_54_label;

   if (in_char >= 117 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 37 - 
state_37_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_55_label;

   if (in_char >= 102 && in_char < 116)
      goto state_9_label;

   if (in_char == 116)
      goto state_56_label;

   if (in_char >= 117 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 38 - 
state_38_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char == 97)
      goto state_57_label;

   if (in_char >= 98 && in_char < 114)
      goto state_9_label;

   if (in_char == 114)
      goto state_58_label;

   if (in_char >= 115 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 39 - 
state_39_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char == 97)
      goto state_59_label;

   if (in_char >= 98 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 40 - 
state_40_label:
   CLOSE_CHAR(20)
   return 20;

// - STAV 41 - 
state_41_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 103)
      goto state_60_label;

   return c_idx_not_exist;

// - STAV 42 - 
state_42_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 100)
      goto state_61_label;

   return c_idx_not_exist;

// - STAV 43 - 
state_43_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 105)
      goto state_9_label;

   if (in_char == 105)
      goto state_62_label;

   if (in_char >= 106 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 44 - 
state_44_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 105)
      goto state_9_label;

   if (in_char == 105)
      goto state_63_label;

   if (in_char >= 106 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 45 - 
state_45_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char == 97)
      goto state_64_label;

   if (in_char >= 98 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 46 - 
state_46_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 105)
      goto state_9_label;

   if (in_char == 105)
      goto state_65_label;

   if (in_char >= 106 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 47 - 
state_47_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char == 97)
      goto state_66_label;

   if (in_char >= 98 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 48 - 
state_48_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 115)
      goto state_9_label;

   if (in_char == 115)
      goto state_67_label;

   if (in_char >= 116 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 49 - 
state_49_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 100)
      goto state_9_label;

   if (in_char == 100)
      goto state_68_label;

   if (in_char >= 101 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 50 - 
state_50_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 108)
      goto state_9_label;

   if (in_char == 108)
      goto state_69_label;

   if (in_char >= 109 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 51 - 
state_51_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 116)
      goto state_9_label;

   if (in_char == 116)
      goto state_70_label;

   if (in_char >= 117 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 52 - 
state_52_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 105)
      goto state_9_label;

   if (in_char == 105)
      goto state_71_label;

   if (in_char >= 106 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 53 - 
state_53_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 104)
      goto state_9_label;

   if (in_char == 104)
      goto state_72_label;

   if (in_char >= 105 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 54 - 
state_54_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_73_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 55 - 
state_55_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 114)
      goto state_9_label;

   if (in_char == 114)
      goto state_74_label;

   if (in_char >= 115 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 56 - 
state_56_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 105)
      goto state_9_label;

   if (in_char == 105)
      goto state_75_label;

   if (in_char >= 106 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 57 - 
state_57_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 116)
      goto state_9_label;

   if (in_char == 116)
      goto state_76_label;

   if (in_char >= 117 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 58 - 
state_58_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 105)
      goto state_9_label;

   if (in_char == 105)
      goto state_77_label;

   if (in_char >= 106 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 59 - 
state_59_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 112)
      goto state_9_label;

   if (in_char == 112)
      goto state_78_label;

   if (in_char >= 113 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 60 - 
state_60_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 105)
      goto state_79_label;

   return c_idx_not_exist;

// - STAV 61 - 
state_61_label:
   CLOSE_CHAR(1)
   return 1;

// - STAV 62 - 
state_62_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 116)
      goto state_9_label;

   if (in_char == 116)
      goto state_80_label;

   if (in_char >= 117 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 63 - 
state_63_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 99)
      goto state_9_label;

   if (in_char == 99)
      goto state_81_label;

   if (in_char >= 100 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 64 - 
state_64_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 114)
      goto state_9_label;

   if (in_char == 114)
      goto state_82_label;

   if (in_char >= 115 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 65 - 
state_65_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 110)
      goto state_9_label;

   if (in_char == 110)
      goto state_83_label;

   if (in_char >= 111 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 66 - 
state_66_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 109)
      goto state_9_label;

   if (in_char == 109)
      goto state_84_label;

   if (in_char >= 110 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 67 - 
state_67_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 104)
      goto state_9_label;

   if (in_char == 104)
      goto state_85_label;

   if (in_char >= 105 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 68 - 
state_68_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_86_label;

   if (in_char >= 102 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 69 - 
state_69_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 117)
      goto state_9_label;

   if (in_char == 117)
      goto state_87_label;

   if (in_char >= 118 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 70 - 
state_70_label:
   CLOSE_CHAR(13)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 13;

// - STAV 71 - 
state_71_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 110)
      goto state_9_label;

   if (in_char == 110)
      goto state_88_label;

   if (in_char >= 111 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 72 - 
state_72_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 111)
      goto state_9_label;

   if (in_char == 111)
      goto state_89_label;

   if (in_char >= 112 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 73 - 
state_73_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 103)
      goto state_9_label;

   if (in_char == 103)
      goto state_90_label;

   if (in_char >= 104 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 74 - 
state_74_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char == 97)
      goto state_91_label;

   if (in_char >= 98 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 75 - 
state_75_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 111)
      goto state_9_label;

   if (in_char == 111)
      goto state_92_label;

   if (in_char >= 112 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 76 - 
state_76_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 105)
      goto state_9_label;

   if (in_char == 105)
      goto state_93_label;

   if (in_char >= 106 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 77 - 
state_77_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 99)
      goto state_9_label;

   if (in_char == 99)
      goto state_94_label;

   if (in_char >= 100 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 78 - 
state_78_label:
   CLOSE_CHAR(15)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 15;

// - STAV 79 - 
state_79_label:
   CLOSE_CHAR(c_idx_not_exist);
   GET_NEXT_CHAR();

   if (in_char == 110)
      goto state_95_label;

   return c_idx_not_exist;

// - STAV 80 - 
state_80_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 105)
      goto state_9_label;

   if (in_char == 105)
      goto state_96_label;

   if (in_char >= 106 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 81 - 
state_81_label:
   CLOSE_CHAR(8)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 8;

// - STAV 82 - 
state_82_label:
   CLOSE_CHAR(14)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 14;

// - STAV 83 - 
state_83_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_97_label;

   if (in_char >= 102 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 84 - 
state_84_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 105)
      goto state_9_label;

   if (in_char == 105)
      goto state_98_label;

   if (in_char >= 106 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 85 - 
state_85_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char == 97)
      goto state_99_label;

   if (in_char >= 98 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 86 - 
state_86_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 114)
      goto state_9_label;

   if (in_char == 114)
      goto state_100_label;

   if (in_char >= 115 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 87 - 
state_87_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 100)
      goto state_9_label;

   if (in_char == 100)
      goto state_101_label;

   if (in_char >= 101 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 88 - 
state_88_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_102_label;

   if (in_char >= 102 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 89 - 
state_89_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 100)
      goto state_9_label;

   if (in_char == 100)
      goto state_103_label;

   if (in_char >= 101 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 90 - 
state_90_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_104_label;

   if (in_char >= 102 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 91 - 
state_91_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 116)
      goto state_9_label;

   if (in_char == 116)
      goto state_105_label;

   if (in_char >= 117 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 92 - 
state_92_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 110)
      goto state_9_label;

   if (in_char == 110)
      goto state_106_label;

   if (in_char >= 111 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 93 - 
state_93_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 99)
      goto state_9_label;

   if (in_char == 99)
      goto state_107_label;

   if (in_char >= 100 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 94 - 
state_94_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 116)
      goto state_9_label;

   if (in_char == 116)
      goto state_108_label;

   if (in_char >= 117 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 95 - 
state_95_label:
   CLOSE_CHAR(0)
   return 0;

// - STAV 96 - 
state_96_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 111)
      goto state_9_label;

   if (in_char == 111)
      goto state_109_label;

   if (in_char >= 112 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 97 - 
state_97_label:
   CLOSE_CHAR(7)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 7;

// - STAV 98 - 
state_98_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 99)
      goto state_9_label;

   if (in_char == 99)
      goto state_110_label;

   if (in_char >= 100 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 99 - 
state_99_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char == 97)
      goto state_9_label;

   if (in_char == 98)
      goto state_111_label;

   if (in_char >= 99 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 100 - 
state_100_label:
   CLOSE_CHAR(2)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 2;

// - STAV 101 - 
state_101_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_112_label;

   if (in_char >= 102 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 102 - 
state_102_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 115)
      goto state_9_label;

   if (in_char == 115)
      goto state_113_label;

   if (in_char >= 116 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 103 - 
state_103_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 115)
      goto state_9_label;

   if (in_char == 115)
      goto state_114_label;

   if (in_char >= 116 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 104 - 
state_104_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 110)
      goto state_9_label;

   if (in_char == 110)
      goto state_115_label;

   if (in_char >= 111 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 105 - 
state_105_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 111)
      goto state_9_label;

   if (in_char == 111)
      goto state_116_label;

   if (in_char >= 112 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 106 - 
state_106_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 115)
      goto state_9_label;

   if (in_char == 115)
      goto state_117_label;

   if (in_char >= 116 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 107 - 
state_107_label:
   CLOSE_CHAR(9)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 9;

// - STAV 108 - 
state_108_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_118_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 109 - 
state_109_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 110)
      goto state_9_label;

   if (in_char == 110)
      goto state_119_label;

   if (in_char >= 111 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 110 - 
state_110_label:
   CLOSE_CHAR(10)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 10;

// - STAV 111 - 
state_111_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 108)
      goto state_9_label;

   if (in_char == 108)
      goto state_120_label;

   if (in_char >= 109 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 112 - 
state_112_label:
   CLOSE_CHAR(3)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 3;

// - STAV 113 - 
state_113_label:
   CLOSE_CHAR(4)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 4;

// - STAV 114 - 
state_114_label:
   CLOSE_CHAR(5)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 5;

// - STAV 115 - 
state_115_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_121_label;

   if (in_char >= 102 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 116 - 
state_116_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 114)
      goto state_9_label;

   if (in_char == 114)
      goto state_122_label;

   if (in_char >= 115 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 117 - 
state_117_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char == 58)
      goto state_123_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 118 - 
state_118_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 100)
      goto state_9_label;

   if (in_char == 100)
      goto state_124_label;

   if (in_char >= 101 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 119 - 
state_119_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 115)
      goto state_9_label;

   if (in_char == 115)
      goto state_125_label;

   if (in_char >= 116 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 120 - 
state_120_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_126_label;

   if (in_char >= 102 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 121 - 
state_121_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 114)
      goto state_9_label;

   if (in_char == 114)
      goto state_127_label;

   if (in_char >= 115 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 122 - 
state_122_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char == 61)
      goto state_128_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 123 - 
state_123_label:
   CLOSE_CHAR(17)
   return 17;

// - STAV 124 - 
state_124_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 121)
      goto state_9_label;

   if (in_char == 121)
      goto state_129_label;

   if (in_char == 122)
      goto state_9_label;

   return 21;

// - STAV 125 - 
state_125_label:
   CLOSE_CHAR(6)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 6;

// - STAV 126 - 
state_126_label:
   CLOSE_CHAR(11)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 11;

// - STAV 127 - 
state_127_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char == 97)
      goto state_130_label;

   if (in_char >= 98 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 128 - 
state_128_label:
   CLOSE_CHAR(16)
   return 16;

// - STAV 129 - 
state_129_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 110)
      goto state_9_label;

   if (in_char == 110)
      goto state_131_label;

   if (in_char >= 111 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 130 - 
state_130_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 116)
      goto state_9_label;

   if (in_char == 116)
      goto state_132_label;

   if (in_char >= 117 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 131 - 
state_131_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char == 97)
      goto state_133_label;

   if (in_char >= 98 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 132 - 
state_132_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 101)
      goto state_9_label;

   if (in_char == 101)
      goto state_134_label;

   if (in_char >= 102 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 133 - 
state_133_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 109)
      goto state_9_label;

   if (in_char == 109)
      goto state_135_label;

   if (in_char >= 110 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 134 - 
state_134_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char == 58)
      goto state_136_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 135 - 
state_135_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 105)
      goto state_9_label;

   if (in_char == 105)
      goto state_137_label;

   if (in_char >= 106 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 136 - 
state_136_label:
   CLOSE_CHAR(12)
   return 12;

// - STAV 137 - 
state_137_label:
   CLOSE_CHAR(21)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 99)
      goto state_9_label;

   if (in_char == 99)
      goto state_138_label;

   if (in_char >= 100 && in_char < 123)
      goto state_9_label;

   return 21;

// - STAV 138 - 
state_138_label:
   CLOSE_CHAR(18)
   GET_NEXT_CHAR();

   if (in_char >= 48 && in_char < 58)
      goto state_9_label;

   if (in_char >= 65 && in_char < 91)
      goto state_9_label;

   if (in_char == 95)
      goto state_9_label;

   if (in_char >= 97 && in_char < 123)
      goto state_9_label;

   return 18;

}

void process_s::parse_def_code(string_s &def_code)
{
   lalr_stack.used = 0;
   lalr_stack.push(0);

   unsigned type_settings = 0;

   unsigned old_input_idx = 0;
   unsigned input_idx = 0;
   unsigned line_cnt = 1;
   unsigned ret_term = c_idx_not_exist;

   do {

      while (ret_term == c_idx_not_exist) {
         old_input_idx = input_idx;

         ret_term = final_automata_recognize(def_code,input_idx,line_cnt);

         if (ret_term == c_idx_not_exist) {
            fprintf(stderr,"Unrecognized terminal\n");
            fprintf(stderr,"SOURCE DEF. CODE: %s\n",def_code.data);
            assert(0);
         }

         if (ret_term == 26 || ret_term == 27) {
            ret_term = c_idx_not_exist;
         }
      }

      // - nalezeni akce v tabulce akci -
      unsigned parse_action = lalr_table[lalr_stack.last().first_num*c_terminal_plus_nonterminal_cnt + ret_term];
      
      if (parse_action == c_idx_not_exist) {
         fprintf(stderr,"Cannot find action in parse table\n");
         fprintf(stderr,"SOURCE DEF. CODE: %s\n",def_code.data);
         assert(0);
      }

      // - akce SHIFT -
      if (parse_action < c_lalr_table_reduce_base) {

         if (ret_term == 28) {
            break;
         }

         // - vlozi na zasobnik novy stav a pozici terminalu ve zdrojovem retezci -
         lalr_stack.push(parse_action,old_input_idx,input_idx);
         ret_term = c_idx_not_exist;
      }

      // -akce REDUCE-
      else {
         parse_action -= c_lalr_table_reduce_base;

         // - reakce na redukci podle pravidla -
         switch (parse_action) {
         case c_reduce_header:
	    {
	       /*lalr_stack_element_s &lse = lalr_stack.last();

	       unsigned tmp_char_idx = lse.third_num - 1;
	       char tmp_char = def_code.data[tmp_char_idx];
	       def_code.data[tmp_char_idx] = '\0';

	       char dta_file_name[256];
	       unsigned dta_file_name_length = snprintf(dta_file_name,256,"%s.dta",def_code.data + lse.second_num + 1);
	       assert(dta_file_name_length < 256);

	       def_code.data[tmp_char_idx] = tmp_char;
	       
	       ((processor_s *)processor_ptr)->load_and_merge_data(dta_file_name);*/

               fprintf(stderr,"Obsolete \"header\" including method\n");
               assert(0);
	    }
            break;
         case c_reduce_include:
	    {
	       lalr_stack_element_s &lse = lalr_stack.last();

	       unsigned tmp_char_idx = lse.third_num - 1;
	       char tmp_char = def_code.data[tmp_char_idx];
	       def_code.data[tmp_char_idx] = '\0';

               // - create included string -
               string_s include_str;
               include_str.data = def_code.data + lse.second_num + 1;
               include_str.size = (lse.third_num - lse.second_num) - 1;
               
               processor_s &processor = *((processor_s *)processor_ptr);
               if (processor.include_names.get_idx(include_str) == c_idx_not_exist) {
                  
                  // - insert included file to include names array -
                  processor.include_names.push_blank();
                  processor.include_names.last().set(include_str.size - 1,include_str.data);

                  // - process included file -
                  process_s process;
                  process.init();

                  process.processor_ptr = processor_ptr;
                  process.run_on(def_code.data + lse.second_num + 1);
                  process.clear();
               }

	       def_code.data[tmp_char_idx] = tmp_char;
	    }
            break;
         case c_reduce_inlines:
	    {
	       lalr_stack_element_s &lse = lalr_stack.last();
	       
	       ((processor_s *)processor_ptr)->generate_type_inlines(lse.third_num - lse.second_num,def_code.data + lse.second_num);
	    }
            break;
         case c_reduce_methods:
	    {
	       lalr_stack_element_s &lse = lalr_stack.last();
	       
	       ((processor_s *)processor_ptr)->generate_type_methods(lse.third_num - lse.second_num,def_code.data + lse.second_num);
	    }
            break;
         case c_reduce_define:
            {
               lalr_stack_element_s &lse = lalr_stack[lalr_stack.used - 2];
               unsigned str_length = lse.third_num - lse.second_num;
               char *str_data = def_code.data + lse.second_num;

               processor_s &processor = *((processor_s *)processor_ptr);
               unsigned abb_idx = processor.abbreviations.get_idx_by_string(str_length,str_data);

               if (abb_idx != c_idx_not_exist) {
                  fprintf(stderr,"Cannot define already existing type\n");
                  assert(0);
               }

               // - define new data type -
               processor.data_types.push_blank();
               data_type_s &data_type = processor.data_types.last();

               data_type.string.set(str_length,str_data);
               data_type.real_name.set(str_length,str_data);
               data_type.number = type_settings;

               // - define data type abbreviation -
               processor.abbreviations.push_blank();
               abbreviation_s &abb = processor.abbreviations.last();

               abb.string.set(str_length,str_data);
               abb.number = processor.data_types.used - 1;

               // - reset type_setting -
               type_settings = 0;
            }
            break;
         case c_reduce_mod_basic:
            type_settings = (type_settings & 0xf8) | c_type_basic;
            break;
         case c_reduce_mod_static:
            type_settings = (type_settings & 0xf8) | c_type_static;
            break;
         case c_reduce_mod_dynamic:
            type_settings = (type_settings & 0xf8) | c_type_dynamic;
            break;
         case c_reduce_mod_flushable:
            type_settings |= c_type_flushable;
            break;
         case c_reduce_gen_container:
	    {
	       lalr_stack_element_s &lse = lalr_stack[lalr_stack.used - 3];

	       unsigned tmp_char_idx = lse.third_num;
	       char tmp_char = def_code.data[tmp_char_idx];
	       def_code.data[tmp_char_idx] = '\0';

	       string_s cont_name;
	       cont_name.size = lse.third_num - lse.second_num + 1;
	       cont_name.data = def_code.data + lse.second_num;

	       ((processor_s *)processor_ptr)->generate_container_def(cont_name,cont_params,type_settings);
               type_settings = 0;

	       def_code.data[tmp_char_idx] = tmp_char;

	       cont_params[c_param_types].used = 0;
	       cont_params[c_param_variables].used = 0;
	       cont_params[c_param_compare].used = 0;
	       cont_params[c_param_functions].used = 0;
	       cont_params[c_param_names].used = 0;
	    }
            break;
         case c_reduce_type:
	    {
	       string_array_s &param = cont_params[c_param_types];
	       lalr_stack_element_s &lse = lalr_stack.last();

	       param.push_blank();
	       param.last().set(lse.third_num - lse.second_num,def_code.data + lse.second_num);
	    }
            break;
         case c_reduce_type_and_name:
	    {
	       string_array_s &type_param = cont_params[c_param_types];
	       lalr_stack_element_s &t_lse = lalr_stack[lalr_stack.used - 3];

	       type_param.push_blank();
	       type_param.last().set(t_lse.third_num - t_lse.second_num,def_code.data + t_lse.second_num);

	       string_array_s &var_param = cont_params[c_param_variables];
	       lalr_stack_element_s &v_lse = lalr_stack.last();

	       var_param.push_blank();
	       var_param.last().set(v_lse.third_num - v_lse.second_num,def_code.data + v_lse.second_num);
	    }
            break;
         case c_reduce_not_generate_init:
	    type_settings |= c_type_setting_not_generate_init;
            break;
         case c_reduce_not_generate_clear:
	    type_settings |= c_type_setting_not_generate_clear;
            break;
         case c_reduce_not_generate_swap:
            type_settings |= c_type_setting_not_generate_swap;
            break;
         case c_reduce_not_generate_operator_equal:
	    type_settings |= c_type_setting_not_generate_operator_equal;
            break;
         case c_reduce_option_strict_dynamic:
            type_settings |= c_type_setting_strict_dynamic;
            break;
         case c_reduce_additions_body:
            {
	       string_array_s &param = cont_params[c_param_functions];
	       lalr_stack_element_s &lse = lalr_stack.last();
	       
	       param.push_blank();
	       param.last().set((lse.third_num - lse.second_num) - 2,def_code.data + lse.second_num + 1);
            }
            break;
         case c_reduce_name:
	    {
	       string_array_s &param = cont_params[c_param_names];
	       lalr_stack_element_s &lse = lalr_stack.last();
	       
	       param.push_blank();
	       param.last().set(lse.third_num - lse.second_num,def_code.data + lse.second_num);
	    }
            break;
         }

         // - odstraneni tela pravidla z vrcholu zasobniku -
         lalr_stack.used -= rule_body_lengths[parse_action];

         // - ulozeni noveho stavu automatu na zasobnik -
         unsigned goto_val = lalr_table[lalr_stack.last().first_num*c_terminal_plus_nonterminal_cnt + rule_head_idxs[parse_action]];
         lalr_stack.push(goto_val);
      }

   } while(1);
}

void process_s::run_on(char *file_name)
{
   cont_params.copy_resize(5);
   cont_params.used = 5;

   if (!source_string.load_text_file(file_name)) {
      fprintf(stderr,"Cannot load source file \"%s\"\n",file_name);
      assert(0);
   }

   source_idx = 0;

   /*
    * nalezeni a zpracovani definici kontejneru ve zdrojovych souborech
    */

   do {
      //unsigned left_size = source_string.size - 1 - source_idx;
      //char *b_ptr = (char *)memmem(source_string.data + source_idx,left_size,c_begin,c_begin_len);
      char *b_ptr = strstr(source_string.data + source_idx,c_begin);

      if (b_ptr == NULL) {
	 printf("%s",source_string.data + source_idx);
	 break;
      }
      else {
	 *b_ptr = '\0';
	 printf("%s",source_string.data + source_idx);
	 *b_ptr = c_begin[0];

	 source_idx = b_ptr - source_string.data;
	 //left_size = source_string.size - 1 - source_idx;
	 //char *e_ptr = (char *)memmem(source_string.data + source_idx,left_size,c_end,c_end_len);
	 char *e_ptr = strstr(source_string.data + source_idx,c_end);

	 assert(e_ptr != NULL);

	 unsigned tmp_char_idx = (e_ptr - b_ptr) + c_end_len;
	 char tmp_char = b_ptr[tmp_char_idx];

	 b_ptr[tmp_char_idx] = '\0';

	 string_s def_code;
	 def_code.size = (e_ptr - b_ptr) + c_end_len + 1;
	 def_code.data = b_ptr;
	 parse_def_code(def_code);
	 b_ptr[tmp_char_idx] = tmp_char;

	 source_idx = e_ptr - source_string.data + c_end_len;
	 //left_size = source_string.size - 1 - source_idx;
      }
   } while(1);
}


