
/*
 * author Jiří Zuzaňák
 * institution BUT FIT UPGM
 */

/*
 * TODO list
 *
 * - jednotlive funkce generujici kontejnery - done: array,set
 * - promyslet zda nezvetsovat dynamicke kontejnery na dvojnasobek soucasne velikosti
 * - mozna u save_to kontrolovat hranice tejne jako u load_from
 *
 */

#define STRUCT_NAME abbs[0].data
#define IM_STRUCT_NAME abbreviations[abb_idx].string.data
#define TYPE_CNT type_cnt
#define TYPE_NAME abbreviations[type_abb_idx].string.data
#define TYPE_NUMBER type.number
#define TYPE_NAMES(IDX) (type_names[IDX].data)
#define IM_TYPE_NAMES(IDX) (data_type.types[IDX].data)
#define TYPE_NUMBERS(IDX) (types[IDX]->number)
#define VAR_NAMES_CNT (data_type.vars.used)
#define VAR_NAMES(IDX) (data_type.vars[IDX].data)
#define COMP_IDX_CNT (data_type.compare_idxs.used)
#define COMP_IDXS(IDX) (data_type.compare_idxs[IDX])

/*
 * typy parametru containeru
 */

enum {
   c_param_types = 0,
   c_param_variables,
   c_param_compare,
   c_param_functions,
   c_param_names,
};

/*
 * retezce popisujici zacatek a konec definicniho bloku
 */

const char *c_begin = "@""begin";
const char *c_end = "@""end";

const unsigned c_begin_len = strlen(c_begin);
const unsigned c_end_len = strlen(c_end);

/*
 * vycet datovych typu
 */

enum {
   c_type_basic = 0x00000001,
   c_type_static = 0x00000002,
   c_type_dynamic = 0x00000004,
};

const unsigned c_type_flushable = 0x00000010;
const unsigned c_type_setting_mask = 0xffffff00;

enum {
   c_type_setting_not_generate_init = 0x00000100,
   c_type_setting_not_generate_clear = 0x00000200,
   c_type_setting_not_generate_swap = 0x00000400,
   c_type_setting_not_generate_operator_equal = 0x00000800,

   c_type_setting_strict_dynamic = 0x00001000,
};

/*
 * jmena zakladnich datovych typu
 */
enum {
   c_bt_bool = 0,
   c_bt_char,
   c_bt_unsigned_char,
   c_bt_short,
   c_bt_unsigned_short,
   c_bt_int,
   c_bt_unsigned,
   c_bt_long,
   c_bt_unsigned_long,
   c_bt_long_long,
   c_bt_unsigned_long_long,
   c_bt_float,
   c_bt_double,
   c_bt_long_double,
};

const unsigned c_basic_type_cnt = 14;
const char *c_basic_types[c_basic_type_cnt] = {
   "bb",
   "bc",
   "uc",
   "si",
   "usi",
   "bi",
   "ui",
   "li",
   "uli",
   "lli",
   "ulli",
   "bf",
   "bd",
   "ld",
};

unsigned c_basic_type_types[c_basic_type_cnt] = {
   c_type_basic,
   c_type_basic,
   c_type_basic,
   c_type_basic,
   c_type_basic,
   c_type_basic,
   c_type_basic,
   c_type_basic,
   c_type_basic,
   c_type_basic,
   c_type_basic,
   c_type_basic,
   c_type_basic,
   c_type_basic,
};

/*
 * "zkratky" zakladnich datovych typu
 */
const unsigned c_basic_abbreviation_cnt = 35;
const char *c_basic_abbreviations[c_basic_abbreviation_cnt] = {
   "bb","bool",
   "bc","char",
   "uc","unsigned_char",
   "si","short","short_int",
   "usi","unsigned_short","unsigned_short_int",
   "bi","int",
   "ui","unsigned","unsigned_int",
   "li","long","long_int",
   "uli","unsigned_long","unsigned_long_int",
   "lli","long_long","long_long_int",
   "ulli","unsigned_long_long","unsigned_long_long_int",
   "bf","float",
   "bd","double",
   "ld","long_double",
};

const int c_basic_abbreviation_types[c_basic_abbreviation_cnt] = {
   0,0,
   1,1,
   2,2,
   3,3,3,
   4,4,4,
   5,5,
   6,6,6,
   7,7,7,
   8,8,8,
   9,9,9,
   10,10,10,
   11,11,
   12,12,
   13,13,
};

/*
 * konstanty popisujici kontejnery
 */

const unsigned c_cont_cnt = 5;

enum {
   c_cont_array = 0,
   c_cont_queue,
   c_cont_set,
   c_cont_struct,
   c_cont_rb_tree,
};

const char *c_cont_names[c_cont_cnt] = {
   "array",
   "queue",
   "set",
   "struct",
   "rb_tree",
};

const char *c_cont_postfixes[c_cont_cnt] = {
   "_a",
   "_q",
   "_t",
   "_s",
   "_rbt",
};

/*
 * funkce struktury data_types_s
 */

unsigned data_types_s::get_idx_by_real_name(unsigned n_length,char *n_data)
{
   if (used == 0) return c_idx_not_exist;

   data_type_s *ptr = data;
   data_type_s *ptr_end = ptr + used;
   do {
      if (ptr->real_name.compare_char_ptr(n_length,n_data)) {
         return ptr - data;
      }
   } while(++ptr < ptr_end);

   return c_idx_not_exist;
}

/*
 * funkce struktury abbreviations_s
 */

unsigned abbreviations_s::get_idx_by_string(unsigned n_length,char *n_data)
{
   if (used == 0) return c_idx_not_exist;

   abbreviation_s *ptr = data;
   abbreviation_s *ptr_end = ptr + used;
   do {
      if (ptr->string.compare_char_ptr(n_length,n_data)) {
	 return ptr - data;
      }
   } while(++ptr < ptr_end);

   return c_idx_not_exist;
}

/*
 * funkce struktury processor_s
 */

void processor_s::data_type_print(char *spaces,unsigned type_idx,char *var_name)
{
   data_type_s &type = data_types[type_idx];

   if (type.number & c_type_basic) {
      switch (type_idx) {
      case c_bt_bool:
printf(
"%sif(%s) {\n"
"%s   printf(\"true\");\n"
"%s}\n"
"%selse {\n"
"%s   printf(\"false\");\n"
"%s}\n"
,spaces,var_name,spaces,spaces,spaces,spaces,spaces);
	 break;
      case c_bt_char:
printf(
"%sputchar(%s);\n"
,spaces,var_name);
	 break;
      case c_bt_unsigned_char:
printf(
"%sprintf(\"%%hhu\",%s);\n"
,spaces,var_name);
	 break;
      case c_bt_short:
printf(
"%sprintf(\"%%hd\",%s);\n"
,spaces,var_name);
	 break;
      case c_bt_unsigned_short:
printf(
"%sprintf(\"%%hu\",%s);\n"
,spaces,var_name);
	 break;
      case c_bt_int:
printf(
"%sprintf(\"%%d\",%s);\n"
,spaces,var_name);
	 break;
      case c_bt_unsigned:
printf(
"%sprintf(\"%%u\",%s);\n"
,spaces,var_name);
	 break;
      case c_bt_long:
printf(
"%sprintf(\"%%ld\",%s);\n"
,spaces,var_name);
	 break;
      case c_bt_unsigned_long:
printf(
"%sprintf(\"%%lu\",%s);\n"
,spaces,var_name);
	 break;
      case c_bt_long_long:
printf(
"%sprintf(\"%%lld\",%s);\n"
,spaces,var_name);
	 break;
      case c_bt_unsigned_long_long:
printf(
"%sprintf(\"%%llu\",%s);\n"
,spaces,var_name);
	 break;
      case c_bt_float:
printf(
"%sprintf(\"%%f\",%s);\n"
,spaces,var_name);
	 break;
      case c_bt_double:
printf(
"%sprintf(\"%%f\",%s);\n"
,spaces,var_name);
	 break;
      case c_bt_long_double:
printf(
"%sprintf(\"%%Lf\",%s);\n"
,spaces,var_name);
	 break;
      default:
	 assert(0);
      }
   }
   else {
printf(
"%s%s.print();\n"
,spaces,var_name);
   }
}

%%include gen_array.cc
%%include gen_queue.cc
%%include gen_set.cc
%%include gen_struct.cc
%%include gen_rb_tree.cc

void processor_s::generate_container_def(string_s &cont_name,string_arrays_s &cont_params,unsigned type_settings)
{
   unsigned idx = 0;
   do {
      if (cont_name.compare_char_ptr(strlen(c_cont_names[idx]),(char *)c_cont_names[idx])) {
	 break;
      }
   } while(++idx < c_cont_cnt);

   switch (idx) {
   case c_cont_array:
      generate_array_type(cont_params,type_settings);
      break;
   case c_cont_queue:
      generate_queue_type(cont_params,type_settings);
      break;
   case c_cont_set:
      generate_set_type(cont_params,type_settings);
      break;
   case c_cont_struct:
      generate_struct_type(cont_params,type_settings);
      break;
   case c_cont_rb_tree:
      generate_rb_tree_type(cont_params,type_settings);
      break;
   default:
      assert(0);
   }
}

void processor_s::generate_type_inlines(unsigned a_length,char *a_data)
{
   unsigned abb_idx = abbreviations.get_idx_by_string(a_length,a_data);
   
   if (abb_idx == c_idx_not_exist) {
      char tmp_char = a_data[a_length];
      a_data[a_length] = '\0';
      fprintf(stderr,"Unknown abbreviation: \"%s\" for generating inline methods",a_data);
      a_data[a_length] = tmp_char;

      assert(0);
   }

   unsigned data_type_idx = abbreviations[abb_idx].number;

   switch (data_types[data_type_idx].cont_idx) {
   case c_cont_array:
      generate_array_inlines(abb_idx,data_type_idx);
      break;
   case c_cont_queue:
      generate_queue_inlines(abb_idx,data_type_idx);
      break;
   case c_cont_set:
      generate_set_inlines(abb_idx,data_type_idx);
      break;
   case c_cont_struct:
      generate_struct_inlines(abb_idx,data_type_idx);
      break;
   case c_cont_rb_tree:
      generate_rb_tree_inlines(abb_idx,data_type_idx);
      break;
   default:
      assert(0);
   }
}

void processor_s::generate_type_methods(unsigned a_length,char *a_data)
{
   unsigned abb_idx = abbreviations.get_idx_by_string(a_length,a_data);

   if (abb_idx == c_idx_not_exist) {
      char tmp_char = a_data[a_length];
      a_data[a_length] = '\0';
      fprintf(stderr,"Unknown abbreviation: \"%s\" for generating inline methods",a_data);
      a_data[a_length] = tmp_char;

      assert(0);
   }

   unsigned data_type_idx = abbreviations[abb_idx].number;

   switch (data_types[data_type_idx].cont_idx) {
   case c_cont_array:
      generate_array_methods(abb_idx,data_type_idx);
      break;
   case c_cont_queue:
      generate_queue_methods(abb_idx,data_type_idx);
      break;
   case c_cont_set:
      generate_set_methods(abb_idx,data_type_idx);
      break;
   case c_cont_struct:
      generate_struct_methods(abb_idx,data_type_idx);
      break;
   case c_cont_rb_tree:
      generate_rb_tree_methods(abb_idx,data_type_idx);
      break;
   default:
      assert(0);
   }
}

void processor_s::init_processor()
{
   clear();

   /*
    * nastaveni zakladnich datovych typu
    */
   {
      unsigned idx = 0;
      do {
	 data_types.push_blank();
	 data_type_s &data_type = data_types.last();

	 const char *c_basic_type = c_basic_types[idx];

         unsigned c_basic_type_length = strlen(c_basic_type);
	 data_type.string.set(c_basic_type_length,(char *)c_basic_type);
         data_type.real_name.set(c_basic_type_length,(char *)c_basic_type);

	 data_type.number = c_basic_type_types[idx];
      } while(++idx < c_basic_type_cnt);
   }

   /*
    * nastaveni zakladnich zkratek
    */
   {
      unsigned idx = 0;
      do {
	 abbreviations.push_blank();
	 abbreviation_s &abbreviation = abbreviations.last();

	 const char *c_basic_abbreviation = c_basic_abbreviations[idx];
	 abbreviation.string.set(strlen(c_basic_abbreviation),(char *)c_basic_abbreviation);
	 abbreviation.number = c_basic_abbreviation_types[idx];
      } while(++idx < c_basic_abbreviation_cnt);
   }
}

void processor_s::run(char *file_name)
{

   /*
    * zapis zakladnich definici
    */

printf(
"\n"
"typedef bool bb;\n"
"typedef char bc;\n"
"typedef unsigned char uc;\n"
"typedef short int si;\n"
"typedef unsigned short int usi;\n"
"typedef int bi;\n"
"typedef unsigned int ui;\n"
"typedef long int li;\n"
"typedef unsigned long uli;\n"
"typedef long long int lli;\n"
"typedef unsigned long long int ulli;\n"
"typedef float bf;\n"
"typedef double bd;\n"
"typedef long double ld;\n"
"\n"
);

   process_s process;
   process.init();

   process.processor_ptr = (pointer)this;
   process.run_on(file_name);

   process.clear();

   //data_types.print();
   //abbreviations.print();
}

void processor_s::save_data(char *file_name)
{
   assert(file_name != NULL);

   unsigned save_size = data_types.save_size() + abbreviations.save_size();
   
   char *buffer = (char *)cmalloc(save_size);
   char *b_ptr = buffer;

   data_types.save_to(&b_ptr);
   abbreviations.save_to(&b_ptr);

   assert((unsigned)(b_ptr - buffer) == save_size);
   
   FILE *f = fopen(file_name,"wb");
   assert(f != NULL);
   fwrite(buffer,save_size,1,f);
   fclose(f);

   cfree(buffer);
}

void processor_s::load_and_merge_data(char *file_name)
{
   assert(file_name != NULL);

   data_types_s f_data_types;
   f_data_types.init();

   abbreviations_s f_abbreviations;
   f_abbreviations.init();

   FILE *f = fopen(file_name,"rb");
   assert(f != NULL);

   fseek(f,0,SEEK_END);
   unsigned file_size = ftell(f);
   fseek(f,0,SEEK_SET);

   char *buffer = (char *)cmalloc(file_size);

   fread(buffer,file_size,1,f);
   fclose(f);

   char *b_ptr = buffer;

   f_abbreviations.clear();
   f_data_types.clear();

   f_data_types.load_from(&b_ptr);
   f_abbreviations.load_from(&b_ptr);
   assert((unsigned)(b_ptr - buffer) == file_size);

   cfree(buffer);

   // - merge -
   {
      abbreviation_s *a_ptr = f_abbreviations.data;
      abbreviation_s *a_ptr_end = a_ptr + f_abbreviations.used;

      do {
	 unsigned idx = abbreviations.get_idx_by_string(a_ptr->string.size - 1,a_ptr->string.data);

	 if (idx != c_idx_not_exist) {
	    assert(data_types[abbreviations[idx].number] == f_data_types[a_ptr->number]);
	 }
	 else {
	    data_type_s &f_data_type = f_data_types[a_ptr->number];

	    unsigned d_idx = data_types.get_idx(f_data_type);

	    if (d_idx != c_idx_not_exist) {
	       abbreviations.push_blank();
	       abbreviations.last().swap(*a_ptr);
	       abbreviations.last().number = d_idx;
	    }
	    else {
	       data_types.push(f_data_type);
	       abbreviations.push_blank();
	       abbreviations.last().swap(*a_ptr);
	       abbreviations.last().number = data_types.used - 1;
	    }
	 }
      } while(++a_ptr < a_ptr_end);
   }

   f_abbreviations.clear();
   f_data_types.clear();
}

