
/*
 * author Jiří Zuzaňák
 * institution BUT FIT UPGM
 */

#ifndef __STRUCTURES_H
#define __STRUCTURES_H

@begin
   include "basic.h"
   include "mem_check.h"
@end

/*
 * definition of generated structures
 */

// -- bb_array_s --
@begin
   array<bool> bb_array_s;
@end

// -- bb_arrays_s --
@begin
   array<bb_array_s> bb_arrays_s;
@end

// -- bc_array_s --
@begin
   array<char> bc_array_s;
@end

// -- uc_array_s --
@begin
   array<uc> uc_array_s;
@end

// -- ui_array_s --
@begin
   array<unsigned> ui_array_s;
@end

// -- ui_arrays_s --
@begin
   array<ui_array_s> 

   additions {
      void remove_by_idx(unsigned a_idx);
   }

   ui_arrays_s;
@end

// -- ui_arrays_array_s --
@begin
   array<ui_arrays_s> ui_arrays_array_s;
@end

/*
 * inline methods of generated structures
 */

// -- bb_array_s --
@begin
   inlines bb_array_s
@end

// -- bb_arrays_s --
@begin
   inlines bb_arrays_s
@end

// -- bc_array_s --
@begin
   inlines bc_array_s
@end

// -- uc_array_s --
@begin
   inlines uc_array_s
@end

// -- ui_array_s --
@begin
   inlines ui_array_s
@end

// -- ui_arrays_s --
@begin
   inlines ui_arrays_s
@end

// -- ui_arrays_array_s --
@begin
   inlines ui_arrays_array_s
@end

#endif

